      program side
c23456789012345678901234567890123456789012345678901234567890123456789012

      include 'work.inc'
      common /const/ p, epsilon1, pos, pos1, numel,ityp
      common /period/ xper,yper,iper1,iper2
      common /period2/ xper2,yper2,iper3,iper4
      common /sides/ glmin,glmax
      common /visc/ Re, xte1,yte1,xte2,yte2


      glmax = 0.
      glmin = 1000.

      ivlt = 51
      ivltx = 52
      ires = 53
      iresx = 54
      iresn = 55
      iprof = 56
      idt3 = 57
      isid = 58

      open(isid,file='paramet',status='old')

cc      read(isid,*) ityp,icrack
      read(isid,*) ityp
      read(isid,*) ndim
      read(isid,*) ifv
cc      read(isid,*) pos, pos1
      read(isid,*) pos
      read(isid,*) numel
      read(isid,*) epsilon1
      read(isid,*) p

      icrack = 0
      pos1 = 0.
      

      open (ivlt, STATUS='old', file='triang')
      open (ivltx,STATUS='unknown', file='triangx')

      open (iprof, STATUS='old', file='profiles')

      if( ifv .eq. 1 .or. ifv .eq. 0) then 
         if (ityp .ne. 0 .and. ityp .ne. -3 .and. ityp .ne. -1 ) then
            open (ires, STATUS='old', file='results')
         endif
cx      elseif(ifv .eq. 2) then
cx         open (ires, STATUS='old', file='file.rese')
      else
         print *,'Sorry, incorect number in paramet'
         print *,'Ifv in paramet =',ifv
         stop
      endif

      if(ityp .gt. 0) 
     *     open (iresx, STATUS='unknown', file='resultsx')


      read(ivlt,*) npoin, nelem, nbelm
      read(ivlt,*)  xper, yper,iper1,iper2,xper2,yper2,iper3,iper4
      maxdeg = 35
c     the maximum elemnet which need to any point + 1
      ipoint = 0
      read(iprof,*) nbp
      do i=1,nbp
         read(iprof,*) ipoin
         ipoint = ipoint + ipoin
         do j=1,ipoin
            read(iprof,*) x1,y1
         enddo
      enddo
      rewind(iprof)

      lwork = 0
      mwork = maxwrk

      if(ityp .ne. 0) then
c     standard
         melem = max(20*numel,8*nelem)
         mpoin = max(10*numel,8*npoin)
         mbelm = max(40*int(sqrt(1.*numel)),8*nbelm)
      else
c     fine isotropic
         melem = max(4*numel,7*nelem)
         mpoin = max(2*numel,7*npoin)
         mbelm = max(8*int(sqrt(1.*numel)),7*nbelm)
      endif

      print *,'MAX:',melem,mpoin,mbelm
      lfr = lwork                                                       
      lx   = MEMO ('r', mpoin) 
      ly   = MEMO ('r', mpoin) 
      lxold= MEMO ('r', mpoin) 
      lyold= MEMO ('r', mpoin) 
      lxnew= MEMO ('r', mpoin) 
      lynew= MEMO ('r', mpoin) 
      llnd = MEMO ('i', melem*3)                                    
      llndold = MEMO ('i', melem*3)
      litli = MEMO ('i', melem)
      lima = MEMO ('i', melem)
      liretk= MEMO('i',melem)
      llbn = MEMO ('i', mbelm*2)                                        
      libc = MEMO('i',mbelm)
      litc = MEMO('i',mbelm)
      libp = MEMO('i',mpoin*2)
      libi  = MEMO('i',mbelm)
      lbx = MEMO('r',mbelm*2)
      lby = MEMO('r',mbelm*2)
      licyc = MEMO('i',mpoin*maxdeg)
      liae = MEMO('i',melem*3)
      lnserr = MEMO('i',melem*6)
      lw = MEMO('r',melem*ndim)
      lwpold = MEMO('r',mpoin*ndim)
      ltlr = MEMO('r',melem*3)
      lwp = MEMO('r',mpoin*(ndim+1))
      lsupp = MEMO('r',mpoin)
      lrga = MEMO('r',mpoin)
      lrgb = MEMO('r',mpoin)
      lrgc = MEMO('r',mpoin)
      ldx = MEMO('r',melem)
      ldy = MEMO('r',melem)
      ltria = MEMO('r',melem)
      larea = MEMO('r',mpoin)
      lra = MEMO('r',melem*3)
      libpoin = MEMO('i',nbp+1)
      lxb = MEMO('r',ipoint)
      lyb = MEMO('r',ipoint)
      lf1 = MEMO('r',melem)
      lf2 = MEMO('r',melem)
      liba= MEMO('i', melem*3) 
      libb= MEMO('i',mpoin*3) 
      liaegr= MEMO('i',melem*4) 

      llnd1= MEMO ('i', melem*3)                                    
      liae1 = MEMO ('i', melem*3)                                    
      litrans=MEMO ('i', melem)


      call SOLVE (ivlt,ivltx, ires, iresx,iresn,iprof,ifv,isid,
     *     ndim, melem,nelem,mpoin,npoin,maxdeg,
     *     ndime,nnode, nband, igeom, nmats,nbelm,mbelm, nbc, 
     *     iorref,work(lxold),work(lyold),iw(llndold),
     *     iw(litli),work(ltlr),iw(liaegr),
     *     work(lx),work(ly),iw(llnd),iw(lima),iw(liretk),iw(llbn),
     *     iw(libc),iw(litc),work(lbx),work(lby),iw(libi), iw(licyc),
     *     work(lxnew),work(lynew), work(lwpold),
     *     work(lra),work(lw),work(lwp),work(lsupp), iw(liae),
     *     work(lrga),work(lrgb),work(lrgc),iw(lnserr),
     *     work(ldx), work(ldy), work(larea),work(ltria),
     *     ipoint,nbp,work(lxb),work(lyb),iw(libpoin),
     *     iw(libp),work(lf1),work(lf2),iflag,iw(liba),iw(libb),icrack,
     *     iw(llnd1), iw(liae1),iw(litrans) )

      end                                                               


      subroutine SOLVE (ivlt,ivltx,ires, iresx,iresn,iprof,ifv,isid,
     *     ndim, melem,nelem,mpoin,npoin,maxdeg,
     *     ndime,nnode, nband, igeom, nmats,nbelm,mbelm, nbc, 
     *     iorref,xold,yold,lndold,itli,tlr,iaegr,
     *     x,y,lnd,ima,iretk, lbn,ibc,itc,bx,by,ibi,icyc,
     *     xnew,ynew,wpold,ra,w,wp,supp,iae,rga,rgb,rgc,
     *     nserr,dx,dy,area,tria,ipoint,nbp,xb,yb,ibpoin,ibp,f1,f2, 
     *     iflag,iba,ibb,icrack, lnd1, iae1, itrans)

      dimension x(mpoin),y(mpoin),lnd(melem,3),ima(melem),iretk(melem),
     *     lbn(mbelm,2),ibc(mbelm),itc(mbelm),bx(mbelm,2),by(mbelm,2),
     *     icyc(mpoin,maxdeg),xold(mpoin),yold(mpoin),lndold(melem,3),
     *     xnew(mpoin),ynew(mpoin), ibi(mbelm),iae(melem,3),
     *     ra(melem*3),wp(mpoin,(ndim+1)),supp(mpoin),w(melem,ndim),
     *     wpold(mpoin,ndim), lnd1(melem,3), iae1(melem,3),
     *     rga(mpoin),rgb(mpoin),rgc(mpoin),nserr(melem*3,2),
     *     dx(melem),dy(melem),area(mpoin),tria(melem),ibb(mpoin,3),
     *     xb(ipoint),yb(ipoint),ibpoin(0:nbp),
     *     ibp(mpoin,2),f1(melem),f2(melem), itrans(melem),
     *     itli(mpoin),tlr(mpoin,3),iaegr(melem,4)

      integer iba(melem,3)
      common /const/ p, epsilon1, pos, pos1, numel,ityp
      common /period/ xper,yper,iper1,iper2
      common /period2/ xper2,yper2,iper3,iper4
      common /sides/ glmin,glmax
      common /visc/ Re, xte1,yte1,xte2,yte2
      character*1  ch
      dimension iwall(10)
c       array of components of impearmeable walls      
      
c      if(ityp .ge. 3) then
c         read(isid,*) Re
c         read(isid,*) xte1
c         read(isid,*) yte1
c         read(isid,*) xte2
c         read(isid,*) yte2
c         read(isid,*) iwa
c         do j=1,iwa
c            read(isid,*) iwall(j)
c         enddo
c      else
         Re = 0.
         xte1 = 0.
         yte1 = 0.
         xte2 = 1.
         yte2 = 0.
         iwa = 0
c      endif
c      close(isid)

      do k=1,npoin
         read (ivlt,*) x(k),y(k)
      enddo
      do k=1,nelem
         read (ivlt,*) lnd(k,1),lnd(k,2),lnd(k,3)
      enddo

      npoinold = npoin
      nelemold = nelem
      
      do 5 i=1,npoin
         ibp(i,1) = 0
         ibp(i,2) = 0
         xold(i) = x(i)
         yold(i) = y(i)
         ibb(i,3) = 0
 5    continue

      do  i=1,nelem
         do j=1,3
            lndold(i,j) = lnd(i,j)
         enddo
      enddo

      nbc = 0
c     maximal index of components
      do 10 k=1,nbelm
         read (ivlt,*) lbn(k,1),lbn(k,2),ibc(k)
         nbc = max(nbc, ibc(k) )
         if(iflag .eq. 2) then
            print *,'I am here, TRY it!!!!'
            do 11 i=1,iwa
               if(ibc(k) .eq. iwall(i) ) then
                  ibp(lbn(k,1),1) = -1
                  ibp(lbn(k,2),1) = -1
                  goto 10
               endif
 11         continue
         endif
         if(k .eq. 1) then
            k1 = nbelm
         else
            k1 = k -1
         endif
         if(ibc(k) .ne. ibc(k1)) ibb(lbn(k,1),3) = -1
 10   continue
      close(ivlt)

c      do i=1,npoin
c         if(ibb(i,3) .eq. -1) write(95,*) x(i),y(i),i,'&^%'
c      enddo

      do  k=1,nbelm
         do  i=1,nelem
            do  j=1,3
               j1 = mod(j,3) +1
               if(lnd(i,j) .eq. lbn(k,1) .and.
     *              lnd(i,j1) .eq. lbn(k,2) ) then
                  itc(k) = i
                  goto 681
               endif
            enddo
         enddo
 681     continue
      enddo


      if(ityp .ne. 0 .and. ityp .ne. -3 .and. ityp .ne. -1) then
         if(ifv .eq. 1)  then
c     ... IS NOT IDENTICAL WHEN #COLOUMS IS HIGHER THEN ndim
c            read(ires, * ) (  ( w(i,k),k=1,ndim ), i=1,nelem )         
            do i=1,nelem
               read(ires, * )   ( w(i,k),k=1,ndim )
            enddo
         else
c            read(ires, * ) (  ( w(i,k),k=1,ndim ), i=1,npoin )         
            do i=1,npoin
               read(ires, * )   ( w(i,k),k=1,ndim )
            enddo
c            do i=1,npoin
c               write(21,*) x(i),y(i),w(i,2)
c            enddo
         endif
         close(ires)
      else
         if(ifv .eq. 1)  then
            do i=1,nelem
               do k=1,ndim
                  w(i,k) = 1.
               enddo
            enddo
         else
            do i=1,npoin
               do k=1,ndim
                  w(i,k) = 1.
               enddo
            enddo
         endif
      endif

      ibpoin(0) = 0
      read(iprof,*) nbppp
      do i=1,nbp
         read(iprof,*) ipoin
         ibpoin(i) = ibpoin(i-1) + ipoin
         do j=1,ipoin
            read(iprof,*) xb(ibpoin(i-1)+j),yb(ibpoin(i-1)+j)
         enddo
      enddo
      close(iprof)
      print *,'The reading of datas done'
      
      
      print *,'**************************************************'
      print *,'****                                          ****'
      print *,'****       A  N  G  E  N  E  R    3.0         ****'
      print *,'****                                          ****'
      print *,'**************************************************'

      noit = 0

      call ADJAC(melem,nelem,mpoin,npoin,lnd,iae,maxdeg,icyc)

      call COINS(melem,nelem,mpoin,npoin,lnd,iae,nbelm,mbelm,lbn,itc)

      call SEEK_BOUN(melem,nelem,mpoin,npoin,ipoint,nbp,xb,yb,lnd,iae,
     *     ibb,ibpoin,x,y, icrack)

      call CYKLE(melem,nelem,mpoin,npoin,maxdeg,
     *     x,y,lnd,iae,icyc,
     *     lbn,nbelm,mbelm,ibp,itc,ibc)

      call CYKLE_BOUND(melem,nelem,mpoin,npoin,maxdeg,
     *     x,y,lnd,iae,icyc)

      call TEST(melem,nelem,mpoin,npoin,maxdeg,x,y,
     *     lnd,iae,icyc,lbn,nbelm,mbelm,ibp,itc)
      
      call METRIX(ndim, melem,nelem,mpoin,npoin,maxdeg,
     *     x,y,lnd,iae,w,wp,supp,icyc,ra,surface,ibp,ifv,
     *     ipoint,nbp, ibb,ibpoin,xb,yb,tria)

c     for back interpolation
      do i=1,npoin
         do j=1,ndim
            wpold(i,j) = wp(i,j+1)
         enddo
      enddo

      call ERROR1(ndim,melem,nelem,mpoin,npoin,maxdeg,
     *     dx,dy,area,tria,noit,
     *     x,y,lnd,iae,wp,icyc,ra,rga,rgb,rgc,surface,ibp,
     *     ipoint,nbp,ibb,ibpoin,xb,yb,ifv)


      print *,'Iteration    quality          changes  ',
     *     ' GL^2:  min        max        nelem'
      print *,'-----------------------------------------',
     *     '---------------------------------'

      call QUALITY(ndim,melem,nelem,mpoin,npoin,x,y,lnd,iae,noit,err,
     *     rminerr,imin,errrez,rmaxrez,ra,wp,rga,rgb,rgc)

      write(*,99999) noit,errrez,'begin',0,glmin,glmax,nelem
      ichag = 0
      
      iter = 1

      call C_REP_BOUND(ndim,melem,nelem,mpoin,npoin,maxdeg,nbelm,mbelm,
     *     noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *     rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,area,tria,surface,
     *     ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp)



c      goto 100
      noflc = 20
      do 99 nob=1,noflc
         ichag = 0

         iter = 5
         call C_REM_BOUND(ndim, melem,nelem,mpoin,npoin,
     *        maxdeg,nbelm,mbelm,
     *        noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *        rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,area,tria,surface,
     *        ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp)

         iter = 10
         if(nob .eq. 1) iter = 0
         call C_MOVING(ndim, melem,nelem,mpoin,npoin,
     *        maxdeg,nbelm,mbelm,
     *        noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *        rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,area,tria,surface,
     *        ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp)
c         goto 100


         iloc = 0
         do iter2 = 1,15
            if(iloc .eq. 0) then
               iter = 1
               call C_REMOVE(ndim, melem,nelem,mpoin,npoin,
     *              maxdeg,nbelm,mbelm,
     *              noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *              rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,
     *              area,tria,surface,
     *              ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp,iba,ier)

               if(icha .eq. 0) iloc = -1
            endif
c            goto 100

            if(iloc .eq. 0) then
               iter = 5
               call C_SWAPPING(ndim, melem,nelem,mpoin,npoin,
     *              maxdeg,nbelm,mbelm,
     *              noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *              rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,
     *              area,tria,surface,
     *              ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp,iba,ier)
            iter = 1
            call C_REP_BOUND(ndim, melem,nelem,mpoin,npoin,
     *           maxdeg,nbelm,mbelm,
     *           noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *           rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,area,tria,surface,
     *           ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp)

            endif
         enddo
         

         iter = 10
         call C_MOVING(ndim, melem,nelem,mpoin,npoin,maxdeg,nbelm,mbelm,
     *        noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *        rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,area,tria,surface,
     *        ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp)
       

         iloc = 0
         do iter2 =1,15


c            if(iter2 .eq. 4)  goto 100

            if(iloc .eq. 0) then
               iter = 1
               call C_INSERT(ndim, melem,nelem,mpoin,npoin,
     *              maxdeg,nbelm,mbelm,
     *              noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *              rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,
     *              area,tria,surface,
     *              ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp,iba,ier)


c               if(iter2 .eq. 4)  goto 100

c     bad dimension
               if(icha .eq. 0) iloc = -1
            endif


            
            if(iloc .eq. 0) then
               iter = 5
               call C_SWAPPING(ndim, melem,nelem,mpoin,npoin,
     *              maxdeg,nbelm,mbelm,
     *              noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *              rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,
     *              area,tria,surface,
     *              ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp,iba,ier)


               iter = 1
               call C_REP_BOUND(ndim, melem,nelem,mpoin,npoin,
     *              maxdeg,nbelm,mbelm,
     *              noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *              rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,area,tria,
     *              surface,
     *              ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp)
               

c               if(iter2 .eq. 2)   goto 100

            endif
         enddo

c         goto 100

         iter = 10
         call C_MOVING(ndim, melem,nelem,mpoin,npoin,maxdeg,nbelm,mbelm,
     *        noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *        rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,area,tria,surface,
     *        ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp)

         iter = 5
         call C_SWAPPING(ndim, melem,nelem,mpoin,npoin,
     *        maxdeg,nbelm,mbelm,
     *        noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *        rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,area,tria,surface,
     *        ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp,iba,ier)

         iter = 1
         call C_REP_BOUND(ndim, melem,nelem,mpoin,npoin,
     *        maxdeg,nbelm,mbelm,
     *        noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *        rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,area,tria,surface,
     *        ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp)

c         if(nob .eq. 1) goto 100

         if( ichag .eq. 0 .or. (ichag .eq. ichagold .and.
     *       ichag .le. 8) ) 
     *        goto 101
         ichagold = ichag
 99   continue

 101  continue

c     ... to ensure the triangulation of Delaunay type
      do nob1 = 1,1
         ichag = 0

         iter =  30
         call C_MOVING(ndim, melem,nelem,mpoin,npoin,maxdeg,nbelm,mbelm,
     *        noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *        rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,area,tria,surface,
     *        ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp)

         iter = 1
         if(nob1 .eq. 1)
     *        call C_B_INSERT(ndim, melem,nelem,mpoin,npoin,
     *        maxdeg,nbelm,mbelm,
     *        noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *        rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,
     *        area,tria,surface,
     *        ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp,iba,ier)
      

         iter = 0
         call C_DELAUNAY(ndim, melem,nelem,mpoin,npoin,
     *        maxdeg,nbelm,mbelm,
     *        noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *        rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,area,tria,surface,
     *        ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp,iba,ier)
         if(ichag .eq. 0) goto 100
      enddo

 100  continue

      call PLOT(melem,nelem,mpoin,npoin,x,y,lnd)

      call TEST(melem,nelem,mpoin,npoin,maxdeg,x,y,
     *     lnd,iae,icyc,lbn,nbelm,mbelm,ibp,itc)
      

c     ... reordering of elements in order to minimize matrix band
      call SEEK_NEIGH(melem,mpoin,mbelm,npoin,nelem,maxdeg,lnd,iae,icyc)

c      igra = 11
c      open (igra,STATUS='unknown', file='matrix_old')
c      call DRAW_MATRIX(melem,mpoin,mbelm,igra,nelem,lnd,iae)
c      close(igra)


      call COMPUTE_BAND(melem,mpoin,mbelm,nelem,lnd,iae,iband)

cccc  simple algorithmus
      do i=1,nelem
         do j=1,3
            iae1(i,j) = 0
            lnd1(i,j) = 0
         enddo
         itrans(i) = 0
      enddo

      ipoc = 1
      iac_old = 1
      do j=1,3
         lnd1(ipoc,j) = lnd(iac_old,j)
      enddo
      iae1(iac_old,1) = -2
      iac_new = ipoc
      itrans(iac_new) = iac_old


      do i=2,nelem
         iac_old = itrans(iac_new)
         if(iac_old .eq. 0) then
            print*,'iac_old is ZERO'
            stop
         endif
         do j=1,3
            ii = iae(iac_old,j)
            if(ii .gt. 0 ) then
               if(iae1(ii,1) .eq. 0) then
                  ipoc = ipoc + 1
                  itrans(ipoc) = ii
                  do k=1,3
                     lnd1(ipoc,k) = lnd(ii,k)
                  enddo
                  iae1(ii,1) = -2
               endif
            endif
         enddo
         iac_new = iac_new+1
      enddo
      

      call SEEK_NEIGH(melem,mpoin,mbelm,npoin,
     *     nelem,maxdeg,lnd1,iae1,icyc)


c      igra = 11
c      open (igra,STATUS='unknown', file='matrix_new')
c      call DRAW_MATRIX(melem,mpoin,mbelm,igra,nelem,lnd1,iae1)
c      close(igra)


      call COMPUTE_BAND(melem,mpoin,mbelm,nelem,lnd,iae1,iband1)


      print *,'The final mesh:'
      print *,'number of elements:',nelem
      print *,'number of points  :',npoin
      print *,'number of boun. s.:',nbelm

      write (ivltx,*) npoin, nelem, nbelm, nbc
      write (ivltx,'(2e14.7,2i3,2e14.7,2i3)') 
     *     xper,yper, iper1,iper2,xper2,yper2,iper3,iper4
      do k=1,npoin
         write (ivltx,*) x(k),y(k)
      enddo
      do k=1,nelem
         write (ivltx,*) lnd1(k,1),lnd1(k,2),lnd1(k,3)
      enddo
      

      do  k=1,nbelm
         write (ivltx,*) lbn(k,1),lbn(k,2),ibc(k)
      enddo
      write (ivltx,'(a4,i6,3e12.4)') '****',numel,epsilon1,p,pos
      close(ivltx)

      call INTERPOLATION(ndim,mpoin,melem,nelem,npoin,
     *     nelemold,npoinold,
     *     x,y,lnd,
     *     xold,yold,lndold,wpold,itli,tlr,wp,iaegr,icrack)

      if(ityp .gt. 0) then
         if( ifv .eq. 1) then
            do 991 i=1,nelem
               do 992 k=1,ndim
                  w(i,k) = (wp(lnd(i,1),k+1)
     *                 + wp(lnd(i,2),k+1) + wp(lnd(i,3),k+1))/3
 992           continue
 991        continue
            do ii=1,nelem
               i = itrans(ii)
               write (iresx,'(4e16.8)' )   ( w(i,k),k=1,ndim )
            enddo
         else
            do  i=1,npoin
               write(iresx,'(4e16.8)') ( wp(i,k+1),k=1,ndim)
            enddo
         endif
         close(iresx)
      endif


c     check of "positivity"
      ipocel = 0
      do 800 i=1,nelem
         x1 = x(lnd(i,1))
         y1 = y(lnd(i,1))
         x2 = x(lnd(i,2))
         y2 = y(lnd(i,2))
         x3 = x(lnd(i,3))
         y3 = y(lnd(i,3))
         det = x1*(y2-y3) + x2*(y3-y1) + x3*(y1-y2)
         reps = pos*( ((x1-x3)**2 + (y1-y3)**2) +
     *              ((x2-x3)**2 + (y2-y3)**2) +
     *              ((x1-x2)**2 + (y1-y2)**2) )
         if (det .le. reps) then
            ipocel = ipocel + 1
         endif
 800  continue
      print *,'Total number of violations of positivity:',ipocel

c     check of "shaphness"
c      ipocel = 0
c      do  i=1,nelem
c         x1 = x(lnd(i,1))
c         y1 = y(lnd(i,1))
c         x2 = x(lnd(i,2))
c         y2 = y(lnd(i,2))
c         x3 = x(lnd(i,3))
c         y3 = y(lnd(i,3))
c         call POS1TEST(x1,y1,x2,y2,x3,y3,itet)
c         if(itet .eq. 1) ipocel = ipocel + 1
c         if(itet .eq. 1) then
c            write (41,*) x1,y1
c            write (41,*) x2,y2
c            write (41,*) x3,y3
c            write (41,*) x1,y1
c            write(41,'(x)')
c         endif
c      enddo
c      print *,'Total number of violations of sharpness: ',ipocel

      
88888 format(a1,4x,2i5)                                                 
99999 format (i6,2x,1(e16.8),2x,a9,i5,2x,2e12.4,i8)
      return
      end


      subroutine  COMPUTE_BAND(melem,mpoin,mbelm,nelem,lnd,iae,iband)
      dimension lnd(melem,3),iae(melem,3)
      
      iband = 0
      do i=1,nelem
         do j=1,3
            ii = iae(i,j)
            if(ii .gt. 0) then
               iband = max(iband,abs(i-ii) )
            endif
         enddo
      enddo
      
      write(*,'(a6,i7,a14,i7,a8,f12.8)') 
     *     'nelem=',nelem,', matrix band=',iband,
     *     ', ratio=',1.*iband/nelem
      end

      subroutine  DRAW_MATRIX(melem,mpoin,mbelm,igra,nelem,lnd,iae)
      dimension lnd(melem,3),iae(melem,3)

      do i=1,nelem
         write(igra,*) i, -i
         do j=1,3
            if(iae(i,j) .gt. 0) then
               write(igra,*) i, -iae(i,j)
            endif
         enddo
      enddo
      return
      end

      subroutine SEEK_NEIGH(melem,mpoin,mbelm,
     *     npoin,nelem,maxdeg,lnd,iae,icyc)
      dimension lnd(melem,3),iae(melem,3),icyc(mpoin,maxdeg)
c     ... seeking of neighbours
      do i=1,nelem
         do j=1,3
            iae(i,j) = -2
         enddo
      enddo

      do i=1,npoin
         icyc(i,1) = 0
      enddo

c      print*,'23'
      do i=1,nelem
         do j=1,3
            k = lnd(i,j)
            icyc(k,1) = icyc(k,1) + 1
            if(icyc(k,1) .ge. maxdeg) then
               print *,'Bad dimension in ADJAC'
               print *,'maxdeg < icyc(k,1)',maxdeg,icyc(k,1)
               stop
            endif
            icyc(k,icyc(k,1)+1) = i
         enddo
      enddo
c      print*,'24'
      
      do i=1,nelem
         do  j=1,3
            if(iae(i,j) .eq. -2)then
               j1 = mod(j,3) +1
               do il=1,icyc(lnd(i,j),1)
                  ii = icyc(lnd(i,j),il+1)
                  if( ii .ne. i) then
                     do jj=1,3
                        jj1 = mod(jj,3) +1
                        if( (lnd(i,j) .eq. lnd(ii,jj1) ).and.
     *                       (lnd(i,j1) .eq. lnd(ii,jj))) then
c     print *,'**',i,j,lnd(i,j),lnd(i,j1),ii
                           iae(i,j) = ii
                           iae(ii,jj) = i
                           goto 60
                        endif
                     enddo
                  endif
               enddo
 60            continue
            endif
         enddo
      enddo
      return
      end

