      subroutine POS1TEST(x1,y1,x2,y2,x3,y3,itet)
      common /const/ p, epsilon1, pos, pos1, numel,ityp

      if(itet .eq. -1) then
         itet1 = -1
      else
         itet1 = 0
      endif
      if(itet1 .eq. -1) then
         print *,'***'
         print *,x1,y1
         print *,x2,y2
         print *,x3,y3
      endif
      itet = 0
      rl1 = ((x1-x2)*(x1-x2) + (y1-y2)*(y1-y2))**0.5
      rl2 = ((x2-x3)*(x2-x3) + (y2-y3)*(y2-y3))**0.5
      rl3 = ((x3-x1)*(x3-x1) + (y3-y1)*(y3-y1))**0.5
      if(rl1 + rl2 .lt. (1.+pos1)*rl3) itet = 1
      if(rl2 + rl3 .lt. (1.+pos1)*rl1) itet = 1
      if(rl3 + rl1 .lt. (1.+pos1)*rl2) itet = 1
      if(itet1 .eq. -1) print *,'* *',itet
      end

      subroutine POS2TEST(x1,y1,x2,y2,x3,y3,itet)
      common /const/ p, epsilon1, pos, pos1, numel,ityp
      real *8 x1,y1,x2,y2,x3,y3

      if(itet .eq. -1) then
         itet1 = -1
      else
         itet1 = 0
      endif
      if(itet1 .eq. -1) then
         print *,'***'
         print *,x1,y1
         print *,x2,y2
         print *,x3,y3
      endif
      itet = 0
      rl1 = ((x1-x2)*(x1-x2) + (y1-y2)*(y1-y2))**0.5
      rl2 = ((x2-x3)*(x2-x3) + (y2-y3)*(y2-y3))**0.5
      rl3 = ((x3-x1)*(x3-x1) + (y3-y1)*(y3-y1))**0.5
      if(rl1 + rl2 .lt. (1.+pos1)*rl3) itet = 1
      if(rl2 + rl3 .lt. (1.+pos1)*rl1) itet = 1
      if(rl3 + rl1 .lt. (1.+pos1)*rl2) itet = 1
      if(itet1 .eq. -1) print *,'* *',itet
      end


      subroutine INTERPOLATION(ndim,mpoin,melem,
     *     nelem,npoin,nelemold,npoinold,x,y,lnd,
     *     xold,yold,lndold,wpold,itli,tlr,wp,iaegr,icrack)

      dimension  x(mpoin),y(mpoin),lnd(melem,3),
     *     xold(mpoin),yold(mpoin),lndold(melem,3),
     *     itli(mpoin),tlr(mpoin,3),wpold(mpoin,ndim),
     *     iaegr(melem,4),wp(mpoin,ndim+1)


c     coefficients for transformation from global mesh to the local one
      do i=1,npoin
         itli(i) = 0
         tlr(i,1) = 0.
         tlr(i,2) = 0.
         tlr(i,3) = 0.
      enddo
      
      xrmax = -10000.
      xrmin = 100000.
      yrmax = -10000.
      yrmin = 100000.
      do i=1,npoinold
         xc = xold(i)
         yc = yold(i)
         xrmax = max(xrmax,xc)
         xrmin = min(xrmin,xc)
         yrmax = max(yrmax,yc)
         yrmin = min(yrmin,yc)
      enddo

      sradiusmax = 0.
      do i=1,nelemold
         iaegr(i,2) =  0
         iaegr(i,3) =  0
         x1 = xold(lndold(i,1))
         y1 = yold(lndold(i,1))
         x2 = xold(lndold(i,2))
         y2 = yold(lndold(i,2))
         x3 = xold(lndold(i,3))
         y3 = yold(lndold(i,3))
         radius = max(((x1-x2)**2 + (y1-y2)**2)**0.5,  
     *        ((x2-x3)**2 + (y2-y3)**2)**0.5 ,
     *        ((x1-x3)**2 + (y1-y3)**2)**0.5, sradiusmax )
         sradiusmax = max(sradiusmax, radius)
      enddo
      sradiusmax = sradiusmax *2
      

      nsqrt = nelemold**0.5 
      do i=1,nelemold
         xc = (xold(lndold(i,1)) + xold(lndold(i,2)) + 
     *        xold(lndold(i,3)) )/3
         yc = (yold(lndold(i,1)) + yold(lndold(i,2)) + 
     *        yold(lndold(i,3)) )/3
         sx = (xc - xrmin)/(xrmax - xrmin)
         sy = (yc - yrmin)/(yrmax - yrmin)
         if(sx .ge. 1. .or. sy .ge. 1 .or. 
     *        sx .le. 0 .or. sy .le. 0.) then
            print *,xc,yc,sx,sy
            stop
         endif
         ix = sx*nsqrt + 1
         iy = sy*nsqrt + 1
         iele = (ix-1)*nsqrt + iy
         iaegr(i,1) = iele
         iaegr(iele,2) = iaegr(iele,2) + 1
      enddo
      rboxmax = max((xrmax - xrmin)/nsqrt,(yrmax - yrmin)/nsqrt )
      ishiftmax = sradiusmax/rboxmax + 1

c      print *,'BOXES:',nsqrt,nsqrt**2,nelemold
c      print *,sradiusmax,rboxmax,sradiusmax/rboxmax,ishiftmax
      it = -10
      do i=1,nelemold
         if(iaegr(i,1) .eq. it) then
            print *,xold(lndold(i,1)), yold(lndold(i,1)),lndold(i,1),i
            print *,xold(lndold(i,2)), yold(lndold(i,2)),lndold(i,2)
            print *,xold(lndold(i,3)), yold(lndold(i,3)),lndold(i,3)
            print *,xold(lndold(i,1)), yold(lndold(i,1))
            print *
         endif
      enddo
c      print *,'pocet =',iaegr(it,2),it/nsqrt,mod(it,nsqrt)
      isum = 0
      do i=1,nsqrt**2
         inum = iaegr(i,2)
         iaegr(i,2) = isum + 1
         isum = isum + inum
      enddo
      
      do i=1,nelemold
         icom = iaegr(i,1)
         iord = iaegr(icom,2) + iaegr(icom,3)
         iaegr(icom,3) = iaegr(icom,3) + 1
         iaegr(iord,4) = i
      enddo
      


      do ic =1,nsqrt**2
         ip = iaegr(ic,2)
         if(ic .ne. nsqrt**2) then
            il = iaegr(ic+1,2) - 1
         else
            il = nelemold
         endif
         if(ip .gt. il .and. iaegr(ic,3) .ne. 0) then
            print *,'error for ic =',ic
            print *,'nozero'
            print *,ip,il,nsqrt**2
            stop
         endif
         do iel = ip,il
            ielem = iaegr(iel,4)
            if(iaegr(ielem,1) .ne. ic) then
               print *,'error for ic =',ic
               print *,'the elements don''t correspond'
               print *,ic,iel,ielem,iaegr(ielem,1)
               stop
            endif
         enddo
      enddo

      do ip=1,npoin
c         if(mod(Ip,1000) .eq. 1) print *,'***',ip,ishift
         ishift = 0
         x0 = x(ip)
         y0 = y(ip)
         iposit = 0
         
c     some improvement for a unit cyrcle with a crack
         if(icrack .eq. 1) then
            if(y0 .eq. 0) then
               do ipom = 1,nelem
                  if(lnd(ipom,1) .eq. ip .or. lnd(ipom,2) .eq. ip
     *                 .or. lnd(ipom,3) .eq. ip ) then
                     yc = (y(lnd(ipom,1))+y(lnd(ipom,2))+
     *                    y(lnd(ipom,3)))/3
                     if(yc .gt. 0) then
                        iposit = 1
                     else
                        iposit = -1
                     endif
                     goto 234
                  endif   
               enddo
 234           continue
            endif
         endif


         sx = (x0 - xrmin)/(xrmax - xrmin)
         sy = (y0 - yrmin)/(yrmax - yrmin)
         iiner = 0
         if(sx .gt. 0. .and. sx .lt. 1. .and. 
     *        sy .gt. 0. .and. sy .lt. 1.) then
c     inner point
            iiner = 1
         endif
         if(iiner .eq. 1) then
            ix = sx*nsqrt + 1
            iy = sy*nsqrt + 1
 954        continue
            do lx = -ishift,ishift
               do ly = -ishift,ishift
                  if( ix+lx .ge. 1 .and. ix+lx .le. nsqrt .and.
     *                 iy+ly .ge. 1 .and. iy+ly .le. nsqrt .and.
     *                 (abs(lx) .eq. ishift .or. abs(ly) .eq. ishift) )
     *                 then

                     ic = (ix-1+lx)*nsqrt + iy+ly
                     il1 = iaegr(ic,2)
                     if(ic .ne. nsqrt**2) then
                        il2 = iaegr(ic+1,2) - 1
                     else
                        il2 = nelemold
                     endif
c     we go through the elements belonging to ic
                     do iel = il1,il2
                        i = iaegr(iel,4)
                        i1 = lndold(i,1) 
                        i2 = lndold(i,2) 
                        i3 = lndold(i,3) 
                        xx0 = x0
                        yy0 = y0
                        xx1 = xold(i1)
                        yy1 = yold(i1)
                        xx2 = xold(i2)
                        yy2 = yold(i2)
                        xx3 = xold(i3)
                        yy3 = yold(i3)

                        if(iposit .ne. 0) then
                           yyc = (yy1 + yy2 + yy3)/3.
                           if(yyc*iposit .lt. 0) then
                              goto 235
                           endif
                        endif

                        det0 = xx3*(yy1-yy2)+xx1*(yy2-yy3)+xx2*(yy3-yy1)
                        det1 = xx0*(yy1-yy2)+xx1*(yy2-yy0)+xx2*(yy0-yy1)
                        det2 = xx0*(yy2-yy3)+xx2*(yy3-yy0)+xx3*(yy0-yy2)
                        det3 = xx0*(yy3-yy1)+xx3*(yy1-yy0)+xx1*(yy0-yy3)


                        if(det0 .le. 0.) then
                           write(112,'(2e14.6,2i7)')xx1,yy1,i1,i
                           write(112,'(2e14.6,i7)')xx2,yy2,i2
                           write(112,'(2e14.6,i7)')xx3,yy3,i3
                           write(112,'(3e14.6)')xold(i1),yold(i1),det0
                           write(112,'(x)')
                        endif
                        epss = 1E-03
                        if(abs(det1)/det0 .lt. epss) det1 = abs(det1)
                        if(abs(det2)/det0 .lt. epss) det2 = abs(det2)
                        if(abs(det3)/det0 .lt. epss) det3 = abs(det3)
                        if(det1 .ge. 0 .and. det2 .ge.0 
     *                       .and. det3 .ge. 0 .and. det0 .gt. 0.) then
c     the node is in this triangle
                           itli(ip) = i
                           tlr(ip,1) = det2/det0
                           tlr(ip,2) = det3/det0
                           tlr(ip,3) = det1/det0
                           goto 209
                        endif
 235                    continue
                     enddo
                  endif
               enddo
            enddo

            ishift = ishift + 1
            if(ishift .le. ishiftmax) goto 954
            iiner = 0
 209        continue
         endif

         if(iiner .eq. 0) then
c     outer point
            rmin = 100000.
            do ie =1,nelemold
               xc = (xold(lndold(ie,1)) + xold(lndold(ie,2)) + 
     *              xold(lndold(ie,3)))/3
               yc = (yold(lndold(ie,1)) + yold(lndold(ie,2)) + 
     *              yold(lndold(ie,3)))/3
               rlen = ((x0-xc)**2 + (y0-yc)**2 )**0.5
               if(iposit .ne. 0) then
                  if(yc*iposit .lt. 0) then
                     goto 236
                  endif
               endif

               if(rlen .lt. rmin) then
                  rmin = rlen
                  imin = ie
               endif
 236           continue
            enddo
            i = imin
            i1 = lndold(i,1) 
            i2 = lndold(i,2) 
            i3 = lndold(i,3) 
            xx0 = x0
            yy0 = y0
            xx1 = xold(i1)
            yy1 = yold(i1)
            xx2 = xold(i2)
            yy2 = yold(i2)
            xx3 = xold(i3)
            yy3 = yold(i3)

            det0 = xx3*(yy1-yy2)+xx1*(yy2-yy3)+xx2*(yy3-yy1)
            det1 = xx0*(yy1-yy2)+xx1*(yy2-yy0)+xx2*(yy0-yy1)
            det2 = xx0*(yy2-yy3)+xx2*(yy3-yy0)+xx3*(yy0-yy2)
            det3 = xx0*(yy3-yy1)+xx3*(yy1-yy0)+xx1*(yy0-yy3)
c     the node is the nearest to this triangle
            itli(ip) = i
            tlr(ip,1) = det2/det0
            tlr(ip,2) = det3/det0
            tlr(ip,3) = det1/det0
            if(abs(tlr(ip,1)).gt. 1.5 .or. abs(tlr(ip,2)).gt. 1.5
     *           .or. abs(tlr(ip,3) ) .gt. 1.5 ) then
               tlr(ip,1) = 1./3
               tlr(ip,2) = 1./3
               tlr(ip,3) = 1./3
            endif
         endif
      enddo

      do i=1,npoin
         ie = itli(i)
         do k=1,ndim
            wp(i,k+1) = tlr(i,1)*wpold(lndold(ie,1),k) +
     *           tlr(i,2)*wpold(lndold(ie,2),k) +
     *           tlr(i,3)*wpold(lndold(ie,3),k) 
         enddo
      enddo

      return
      end


      subroutine C_DELAUNAY(ndim, melem,nelem,mpoin,npoin,
     *     maxdeg,nbelm,mbelm,
     *     noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *     rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,area,tria,surface,
     *     ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp,iba,ier)

      dimension x(mpoin),y(mpoin),lnd(melem,3),iae(melem,3),
     *     lbn(mbelm,2),ibc(mbelm),itc(mbelm),
     *     icyc(mpoin,maxdeg),
     *     ra(melem*3),wp(mpoin,ndim+1),
     *     rga(mpoin),rgb(mpoin),rgc(mpoin),nserr(melem*3,2),
     *     dx(melem),dy(melem),area(mpoin),tria(melem),
     *     xb(ipoint),yb(ipoint),ibp(mpoin,2),ibb(mpoin,3),ibpoin(0:nbp)
      integer iba(melem,3)

      common /const/ p, epsilon1, pos, pos1, numel,ityp
      common /period/ xper,yper,iper1,iper2
      common /period2/ xper2,yper2,iper3,iper4
      common /sides/ glmin,glmax

      err1 = 0.
      err1rez = 0.
      do 30 icy =1,iter 
         noit = noit + 1
         call DELAUNAY(ndim, melem,nelem,mpoin,npoin,x,y,lnd,iae,icha,
     *        ra,wp,rga,rgb,rgc,iba,nbelm,mbelm,lbn,ibc,itc,
     *        maxdeg,icyc,ibp )
         call CYKLE_REP(melem,nelem,mpoin,npoin,maxdeg,
     *        x,y,lnd,iae,icyc,lbn,nbelm,mbelm,ibp)
         call CYKLE_BOUND(melem,nelem,mpoin,npoin,maxdeg,
     *        x,y,lnd,iae,icyc)
         call QUALITY(ndim, melem,nelem,mpoin,npoin,x,y,lnd,iae,noit,
     *        err,rminerr,imin,errrez,rmaxrez,ra,wp,
     *        rga,rgb,rgc)
         write(*,99999) noit,errrez,'delaunay',icha,glmin,glmax,nelem
         ichag = ichag + icha
         if(icha .le. 1 ) return
 30   continue
99999 format (i6,2x,1(e16.8),2x,a9,i5,2x,2e12.4,i8)
      return
      end

      subroutine C_SWAPPING(ndim, melem,nelem,mpoin,npoin,
     *     maxdeg,nbelm,mbelm,
     *     noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *     rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,area,tria,surface,
     *     ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp,iba,ier)

      dimension x(mpoin),y(mpoin),lnd(melem,3),iae(melem,3),
     *     lbn(mbelm,2),ibc(mbelm),itc(mbelm),
     *     icyc(mpoin,maxdeg),
     *     ra(melem*3),wp(mpoin,ndim+1),
     *     rga(mpoin),rgb(mpoin),rgc(mpoin),nserr(melem*3,2),
     *     dx(melem),dy(melem),area(mpoin),tria(melem),
     *     xb(ipoint),yb(ipoint),ibp(mpoin,2),ibb(mpoin,3),ibpoin(0:nbp)
      integer iba(melem,3)

      common /const/ p, epsilon1, pos, pos1, numel,ityp
      common /period/ xper,yper,iper1,iper2
      common /period2/ xper2,yper2,iper3,iper4
      common /sides/ glmin,glmax

      err1 = 0.
      err1rez = 0.
      do 30 icy =1,iter 
         noit = noit + 1
         call SWAPPING(ndim, melem,nelem,mpoin,npoin,x,y,lnd,iae,icha,
     *        ra,wp,rga,rgb,rgc,iba,nbelm,mbelm,lbn,ibc,itc,
     *        maxdeg,icyc,ibp )
         call CYKLE_REP(melem,nelem,mpoin,npoin,maxdeg,
     *        x,y,lnd,iae,icyc,lbn,nbelm,mbelm,ibp)
         call CYKLE_BOUND(melem,nelem,mpoin,npoin,maxdeg,
     *        x,y,lnd,iae,icyc)
         call QUALITY(ndim, melem,nelem,mpoin,npoin,x,y,lnd,iae,noit,
     *        err,rminerr,imin,errrez,rmaxrez,ra,wp,
     *        rga,rgb,rgc)
         write(*,99999) noit,errrez,'swapping',icha,glmin,glmax,nelem
         ichag = ichag + icha
         if(icha .le. 1 ) return
 30   continue
99999 format (i6,2x,1(e16.8),2x,a9,i5,2x,2e12.4,i8)
      return
      end

      subroutine C_MOVING(ndim, melem,nelem,mpoin,npoin,
     *     maxdeg,nbelm,mbelm,
     *     noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *     rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,area,tria,surface,
     *     ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp)

      dimension x(mpoin),y(mpoin),lnd(melem,3),iae(melem,3),
     *     lbn(mbelm,2),ibc(mbelm),itc(mbelm),
     *     icyc(mpoin,maxdeg),
     *     ra(melem*3),wp(mpoin,ndim+1),
     *     rga(mpoin),rgb(mpoin),rgc(mpoin),nserr(melem*3,2),
     *     dx(melem),dy(melem),area(mpoin),tria(melem),
     *     xb(ipoint),yb(ipoint),ibp(mpoin,2),ibb(mpoin,3),ibpoin(0:nbp)

      common /const/ p, epsilon1, pos, pos1, numel,ityp
      common /period/ xper,yper,iper1,iper2
      common /period2/ xper2,yper2,iper3,iper4
      common /sides/ glmin,glmax

      err1 = 0.
      err1rez = 1.E+35

      do 40 icy =1,iter
         noit = noit + 1
         call MOVING(ndim, melem,nelem,mpoin,npoin,maxdeg,x,y,lnd,iae,
     *        ra,icyc,wp,rga,rgb,rgc,noit,ipoint,nbp,xb,yb,ibb,
     *        ibpoin,ichag, mbelm,nbelm,ibp)
         call QUALITY(ndim, melem,nelem,mpoin,npoin,x,y,lnd,iae,noit,
     *        err,rminerr,imin,errrez,rmaxrez,ra,wp,
     *        rga,rgb,rgc)
         write(*,99998) noit,errrez,'moving',glmin,glmax,nelem
         if( err1rez - errrez .lt. 1E-06 ) return
         err1rez = errrez
 40   continue
99998 format (i6,2x,1(e16.8),2x,a9,5x,2x,2e12.4,i8)
      return
      end

      subroutine C_REM_BOUND(ndim, melem,nelem,mpoin,npoin,
     *     maxdeg,nbelm,mbelm,
     *     noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *     rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,area,tria,surface,
     *     ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp)

      dimension x(mpoin),y(mpoin),lnd(melem,3),iae(melem,3),
     *     lbn(mbelm,2),ibc(mbelm),itc(mbelm),
     *     icyc(mpoin,maxdeg),
     *     ra(melem*3),wp(mpoin,ndim+1),
     *     rga(mpoin),rgb(mpoin),rgc(mpoin),nserr(melem*3,2),
     *     dx(melem),dy(melem),area(mpoin),tria(melem),
     *     xb(ipoint),yb(ipoint),ibp(mpoin,2),ibb(mpoin,3),ibpoin(0:nbp)

      common /const/ p, epsilon1, pos, pos1, numel,ityp
      common /period/ xper,yper,iper1,iper2
      common /period2/ xper2,yper2,iper3,iper4
      common /sides/ glmin,glmax

      do 20 it =1,iter
         noit = noit + 1
         call REM_BOUND(ndim, melem,nelem,mpoin,npoin,
     *        maxdeg,x,y,lnd,iae,
     *        ra,icyc,rminerr,imin,rmaxrez,icha,nserr,
     *        wp,lbn,itc,ibc,nbelm,mbelm,rga,rgb,rgc,ibp,ibb,ibpoin,
     *        ipoint,nbp)
         call QUALITY(ndim,melem,nelem,mpoin,npoin,x,y,lnd,iae,noit,
     *        err,rminerr,imin,errrez,rmaxrez,ra,wp,
     *        rga,rgb,rgc)
         write(*,99999) noit,errrez,'rem_bou',icha,glmin,glmax,nelem
         ichag = ichag + icha
         if(icha .le. 1) return
 20   continue
99999 format (i6,2x,1(e16.8),2x,a9,i5,2x,2e12.4,i8)
      return
      end

      subroutine C_REMOVE(ndim, melem,nelem,mpoin,npoin,
     *     maxdeg,nbelm,mbelm,
     *     noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *     rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,area,tria,surface,
     *     ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp,iba,ier)

      dimension x(mpoin),y(mpoin),lnd(melem,3),iae(melem,3),
     *     lbn(mbelm,2),ibc(mbelm),itc(mbelm),
     *     icyc(mpoin,maxdeg),
     *     ra(melem*3),wp(mpoin,ndim+1),
     *     rga(mpoin),rgb(mpoin),rgc(mpoin),nserr(melem*3,2),
     *     dx(melem),dy(melem),area(mpoin),tria(melem),
     *     xb(ipoint),yb(ipoint),ibp(mpoin,2),ibb(mpoin,3),ibpoin(0:nbp)
      integer iba(melem,3)

      common /const/ p, epsilon1, pos, pos1, numel,ityp
      common /period/ xper,yper,iper1,iper2
      common /period2/ xper2,yper2,iper3,iper4
      common /sides/ glmin,glmax


      do 30 icy =1,iter
         noit = noit + 1
         call REMOVE(ndim,melem,nelem,mpoin,npoin,maxdeg,x,y,lnd,iae,
     *        ra,icyc,rminerr,imin,rmaxrez,icha,nserr,
     *        wp,lbn,ibc,itc,nbelm,mbelm,rga,rgb,rgc,ipoint,nbp,xb,yb,
     *        ibb,ibpoin,ibp)
         call QUALITY(ndim,melem,nelem,mpoin,npoin,x,y,lnd,iae,noit,
     *        err,rminerr,imin,errrez,rmaxrez,ra,wp,
     *        rga,rgb,rgc)
         write(*,99999) noit,errrez,'remove',icha,glmin,glmax,nelem
         ichag = ichag + icha
         if(icha .le. 1) return
 30   continue
99999 format (i6,2x,1(e16.8),2x,a9,i5,2x,2e12.4,i8)
      return
      end

      subroutine C_INSERT(ndim,melem,nelem,mpoin,npoin,
     *     maxdeg,nbelm,mbelm,
     *     noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *     rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,area,tria,surface,
     *     ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp,iba,ier)

      dimension x(mpoin),y(mpoin),lnd(melem,3),iae(melem,3),
     *     lbn(mbelm,2),ibc(mbelm),itc(mbelm),
     *     icyc(mpoin,maxdeg),
     *     ra(melem*3),wp(mpoin,ndim+1),
     *     rga(mpoin),rgb(mpoin),rgc(mpoin),nserr(melem*3,2),
     *     dx(melem),dy(melem),area(mpoin),tria(melem),
     *     xb(ipoint),yb(ipoint),ibp(mpoin,2),ibb(mpoin,3),ibpoin(0:nbp)
      integer iba(melem,3)

      common /const/ p, epsilon1, pos, pos1, numel,ityp
      common /period/ xper,yper,iper1,iper2
      common /period2/ xper2,yper2,iper3,iper4
      common /sides/ glmin,glmax

      do 30 icy =1,iter
         noit = noit + 1
         call INSERT(ndim,melem,nelem,mpoin,npoin,maxdeg,x,y,lnd,iae,
     *        ra,icyc,rminerr,imin,rmaxrez,icha,nserr,
     *        wp,rga,rgb,rgc,lbn,itc,ibc,nbelm,mbelm,
     *        ipoint,nbp,xb,yb,ibb,ibpoin,
     *        ibp,ier)
         call CYKLE_REP(melem,nelem,mpoin,npoin,maxdeg,
     *        x,y,lnd,iae,icyc,lbn,nbelm,mbelm,ibp)
         call CYKLE_BOUND(melem,nelem,mpoin,npoin,maxdeg,
     *        x,y,lnd,iae,icyc)
         call QUALITY(ndim, melem,nelem,mpoin,npoin,x,y,lnd,iae,noit,
     *        err,rminerr,imin,errrez,rmaxrez,ra,wp,
     *        rga,rgb,rgc)
         write(*,99999) noit,errrez,'insert',icha,glmin,glmax,nelem
         ichag = ichag + icha
         if(icha .le. 1) return
 30   continue
99999 format (i6,2x,1(e16.8),2x,a9,i5,2x,2e12.4,i8)
      return
      end

      subroutine C_REP_BOUND(ndim,melem,nelem,mpoin,npoin,
     *     maxdeg,nbelm,mbelm,
     *     noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *     rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,area,tria,surface,
     *     ipoint,nbp,xb,yb,ibb,ibpoin, ichag, icha,ibp)

      dimension x(mpoin),y(mpoin),lnd(melem,3),iae(melem,3),
     *     lbn(mbelm,2),ibc(mbelm),itc(mbelm),
     *     icyc(mpoin,maxdeg),
     *     ra(melem*3),wp(mpoin,ndim+1),
     *     rga(mpoin),rgb(mpoin),rgc(mpoin),nserr(melem*3,2),
     *     dx(melem),dy(melem),area(mpoin),tria(melem),
     *     xb(ipoint),yb(ipoint),ibp(mpoin,2),ibb(mpoin,3),ibpoin(0:nbp)

      common /const/ p, epsilon1, pos, pos1, numel,ityp
      common /period/ xper,yper,iper1,iper2
      common /period2/ xper2,yper2,iper3,iper4
      common /sides/ glmin,glmax

      do 30 icy =1,iter
         noit = noit + 1
         call REP_BOUND(ndim,melem,nelem,mpoin,npoin,
     *        maxdeg,x,y,lnd,iae,
     *        ra,icyc,rminerr,imin,rmaxrez,icha,nserr,
     *        wp,rga,rgb,rgc,lbn,itc,ibc,nbelm,mbelm,
     *        ipoint,nbp,xb,yb,ibb,ibpoin,
     *        ibp)
c     the subroutine REP_BOUND is in insert.f
         call QUALITY(ndim,melem,nelem,mpoin,npoin,x,y,lnd,iae,noit,
     *        err,rminerr,imin,errrez,rmaxrez,ra,wp,
     *        rga,rgb,rgc)
         write(*,99999) noit,errrez,'rep_boun',icha,glmin,glmax,nelem
      ichag = ichag + icha
 30   continue
99999 format (i6,2x,1(e16.8),2x,a9,i5,2x,2e12.4,i8)
      return
      end



      subroutine C_B_INSERT(ndim,melem,nelem,mpoin,npoin,
     *     maxdeg,nbelm,mbelm,
     *     noit, iter, x,y,lnd,iae,wp,icyc,ra,
     *     rga,rgb,rgc,lbn,ibc,itc,nserr,dx,dy,area,tria,surface,
     *     ipoint,nbp,xb,yb,ibb,ibpoin,ichag, icha,ibp,iba,ier)

      dimension x(mpoin),y(mpoin),lnd(melem,3),iae(melem,3),
     *     lbn(mbelm,2),ibc(mbelm),itc(mbelm),
     *     icyc(mpoin,maxdeg),
     *     ra(melem*3),wp(mpoin,ndim+1),
     *     rga(mpoin),rgb(mpoin),rgc(mpoin),nserr(melem*3,2),
     *     dx(melem),dy(melem),area(mpoin),tria(melem),
     *     xb(ipoint),yb(ipoint),ibp(mpoin,2),ibb(mpoin,3),ibpoin(0:nbp)
      integer iba(melem,3)

      common /const/ p, epsilon1, pos, pos1, numel,ityp
      common /period/ xper,yper,iper1,iper2
      common /period2/ xper2,yper2,iper3,iper4
      common /sides/ glmin,glmax

      do 30 icy =1,iter
         noit = noit + 1
         call INSERT_BOUND(ndim,melem,nelem,mpoin,npoin,maxdeg,
     *        x,y,lnd,iae,
     *        ra,icyc,rminerr,imin,rmaxrez,icha,nserr,
     *        wp,rga,rgb,rgc,lbn,itc,ibc,nbelm,mbelm,
     *        ipoint,nbp,xb,yb,ibb,ibpoin,
     *        ibp,ier)
         call CYKLE_REP(melem,nelem,mpoin,npoin,maxdeg,
     *        x,y,lnd,iae,icyc,lbn,nbelm,mbelm,ibp)
         call CYKLE_BOUND(melem,nelem,mpoin,npoin,maxdeg,
     *        x,y,lnd,iae,icyc)
         call QUALITY(ndim, melem,nelem,mpoin,npoin,x,y,lnd,iae,noit,
     *        err,rminerr,imin,errrez,rmaxrez,ra,wp,
     *        rga,rgb,rgc)
         write(*,99999) noit,errrez,'B_insert',icha,glmin,glmax,nelem
         ichag = ichag + icha
         if(icha .le. 1) return
 30   continue
99999 format (i6,2x,1(e16.8),2x,a9,i5,2x,2e12.4,i8)
      return
      end
