      subroutine MOVING(ndim, melem,nelem,mpoin,npoin,
     *     maxdeg,x,y,lnd,iae,
     *     ra,icyc,wp,rga,rgb,rgc,noit,ipoint,nbp,xb,yb,ibb,ibpoin,
     *     ichag,mbelm,nbelm,ibp)
      dimension lnd(melem,3),iae(melem,3),x(mpoin),y(mpoin),
     *     ra(mpoin),wp(mpoin,ndim),
     *     rga(mpoin),rgb(mpoin),rgc(mpoin),
     *     icyc(mpoin,maxdeg),
     *     xb(ipoint),yb(ipoint),ibp(mpoin,2),ibb(mpoin,3),ibpoin(0:nbp)
      real xloc(25),yloc(25)
      integer iloc(25)
      real*8 a,b,c,d,det0,det1,det2,det3,xs,ys,yq,xq,
     *     rlen0,rlen1,rlen2,ss,rcos

      common /const/ p, epsilon1, pos, pos1, numel,ityp
      common /period/ xper,yper,iper1,iper2
      common /period2/ xper2,yper2,iper3,iper4

      do 10 i=1,npoin
         if(ibb(i,3) .eq. -1) goto 10
         if(icyc(i,1) .gt. 0) then
            if(icyc(i,1) .gt. 25) then
               print *,'Error in dimension in MOVING',icyc(i,1)
               return
            endif
            xp = x(i)
            yp = y(i)
            xq = 0.
            yq = 0.
            quality = 0.
            do 20 j=1,icyc(i,1)
               j1 = mod(j,icyc(i,1) ) +1
               ii1 = icyc(i,j+1)
               ii2 = icyc(i,j1+1)
               xi = x(ii1)
               yi = y(ii1)
               xi1 = x(ii2)
               yi1 = y(ii2)
               a = (rga(ii1) + rga(ii2))/2
               b = (rgb(ii1) + rgb(ii2))/2
               c = (rgc(ii1) + rgc(ii2))/2
               d = ( (a*c-b*b)/3)**0.5
               if( d .le. 0) then
                  print *,'ERROR in matrix in moving'
                  print *,a,b,c
                  stop
               endif

               xs = xi + ((d-b)*(xi1-xi) - c*(yi1-yi))/2/d
               ys = yi + ( a*(xi1-xi) + (d+b)*(yi1-yi))/2/d

               xloc(j) = xs
               yloc(j) = ys

               xq = xq + xloc(j)
               yq = yq + yloc(j)
 20         continue

            xq = xq/icyc(i,1)
            yq = yq/icyc(i,1)

c     now we check the the triangles xi,xi1,xq are reals
            numit = 10
            k=numit
 1240       continue
            ierr = 0
            xnew = xp + 1.*k/numit*(xq - xp) 
            ynew = yp + 1.*k/numit*(yq - yp) 
            do 1230 j=1,icyc(i,1)
               j1 = mod(j,icyc(i,1))+1
               ii1 = icyc(i,j+1)
               ii2 = icyc(i,j1+1)
               xi = x(ii1)
               yi = y(ii1)
               xi1 = x(ii2)
               yi1 = y(ii2)
c     check the orientation and bad conditionality
               detiii = xi*(yi1-ynew) + xi1*(ynew-yi) + xnew*(yi-yi1)
               reps = pos*( ((xi1-xi)**2 + (yi1-yi)**2) +
     *              ((xi-xnew)**2 + (yi-ynew)**2) +
     *              ((xi1-xnew)**2 + (yi1-ynew)**2) )
               if (detiii .le. reps) then 
                  ierr = 1
                  goto 1231
               endif
               call POS1TEST(xi,yi,xi1,yi1,xnew,ynew,itet)
               if(itet .eq. 1) then
                  ierr = 1
                  goto 1231
               endif

 1230       continue
 1231       continue

            if(ierr .eq. 1 .and. k .ge. 2) then
               k = k - 1
               goto 1240
            endif
            if( k .eq. 1) then
               xq = xp
               yq = yp
            else
               xq = xnew
               yq = ynew
            endif

            quality = 0.
            qualityrez = 1E+35
            numit = 8
            ice = 0
            xold = xp
            yold = yp

            do 40 k=0,numit
               quality1 = 0.
               quality1rez = 0.
               xnew = xp + 1.*k/numit*(xq - xp) 
               ynew = yp + 1.*k/numit*(yq - yp) 
               do 30 j=1,icyc(i,1)
                  j1 = mod(j,icyc(i,1))+1
                  ii1 = icyc(i,j+1)
                  ii2 = icyc(i,j1+1)
                  xi = x(ii1)
                  yi = y(ii1)
                  xi1 = x(ii2)
                  yi1 = y(ii2)
c     check the orientation and bad conditionality
                  detiii = xi*(yi1-ynew) + xi1*(ynew-yi) + xnew*(yi-yi1)
                  reps = pos*( ((xi1-xi)**2 + (yi1-yi)**2) +
     *              ((xi-xnew)**2 + (yi-ynew)**2) +
     *              ((xi1-xnew)**2 + (yi1-ynew)**2) )
                  if (detiii .le. reps) then 
c                     print *,'VIOLATION of positivity - algorith ERROR'
                     goto 45
                  endif
                  call POS1TEST(xi,yi,xi1,yi1,xnew,ynew,itet)
                  if(itet .eq. 1) then
                     goto 45
                  endif

                  acc = ACCUTE(xi,yi,xi1,yi1,xnew,ynew, 1.)

                  rl1 = (0.5*((rga(i)+rga(ii1))*(xi-xnew)*(xi-xnew)+
     *                 2*(rgb(i)+rgb(ii1))*(xi-xnew)*(yi-ynew)+
     *                 (rgc(i)+rgc(ii1))*(yi-ynew)*(yi-ynew)))**0.5

c                  quality1rez = quality1rez + (rl1 - 1.732050807)**2
c     ... NEW ACCUTE
                  quality1rez = quality1rez 
     *                 +(rl1 - 1.732050807)**2*acc

 30            continue

               if(quality1rez .ge. qualityrez ) goto 45

               xold = xnew
               yold = ynew
               qualityrez = quality1rez
 40         continue
 45         continue

            x(i) = xold
            y(i) = yold
         endif
 10   continue

c     for boundary points, the movement, only if the point is on the
c     straight segment
c     or on the boundary given by the field [xb(i),yb(i)] i=1,ipoint

      do 100 i=1,npoin
         if(ibb(i,3) .eq. -1) goto 100
         if(ibb(i,1) .gt. 0) then 
            ikk1 = ibb(i,2)
            if(ibb(i,1) .eq. ibpoin(ikk1-1)+1  .or.
     *           ibb(i,1) .eq. ibpoin(ikk1)) then
c               NO moving of final or initial node of profiles
               goto 21
            endif
         endif

         if(icyc(i,1) .lt. 0 ) then
            len = abs(icyc(i,1))
            x1 = x(i)
            y1 = y(i)
            x2 = x(icyc(i,2))
            y2 = y(icyc(i,2))
            x0 = x(icyc(i,len+1))
            y0 = y(icyc(i,len+1))
            rlen1 = ((x2-x1)**2 + (y2-y1)**2)**0.5
            rlen2 = ((x0-x1)**2 + (y0-y1)**2)**0.5
            ss = ((x2-x1)*(x0-x1) + (y2-y1)*(y0-y1))
            rcos = ss/rlen1/rlen2
c            if(i .eq. 2) print *,'%%%%',rcos
            if( rcos .gt. -0.9999 .or. (ibb(i,1) .gt. 0 .and.
c            if( rcos .gt. -0.9866 .or. (ibb(i,1) .gt. 0 .and.
     *              (ibb(icyc(i,2),1) .gt. 0 .and. 
     *              ibb(icyc(i,len+1),1) .lt. 0 ) .or. 
     *              (ibb(icyc(i,2),1) .lt. 0 .and. 
     *              ibb(icyc(i,len+1),1) .gt. 0 ) )) then
c     too sharp angle or. begin or end of noclosed profile,
c     movement forbidden
               goto 100
            elseif ( ibb(i,1) .lt. 0  ) then
c     this points are on straight segments
c     the maximal value of numit can not be greater than 9 !!!!!!
               numit = 9
               ice = 0
               xold = x1
               yold = y1
               do 141 k=-numit,0
                  l = numit + k + 1
                  xloc(l) = x1 - 1.*k/(numit+1)*(x0 - x1) 
                  yloc(l) = y1 - 1.*k/(numit+1)*(y0 - y1) 
                  iloc(l) = -1
 141           continue
               do 146 k=1,numit
                  l = numit + k + 1
                  xloc(l) = x1 + 1.*k/(numit+1)*(x2 - x1) 
                  yloc(l) = y1 + 1.*k/(numit+1)*(y2 - y1) 
                  iloc(l) = -1
 146           continue
               ilo = 2*numit + 1
            else
c     nodes are on curved part of boundary
               i2 = icyc(i,2)
               i0 = icyc(i,abs(icyc(i,1))+1)

               if(ibb(i,1) .lt. 0 .or. ibb(i0,1) .lt. 0 
     *              .or. ibb(i2,1) .lt.0) then
                  print *,'LOGICAL error in MOVING, ibb'
                  print *,i,i0,i2,ibb(i,1),ibb(i0,1),ibb(i2,1)
                  print *,x(i),y(i)
c,xb(ibb(i,1)),yb(ibb(i,1))
                  print *,x(i0),y(i0)
c,xb(ibb(i0,1)),yb(ibb(i0,1))
                  print *,x(i2),y(i2)
c,xb(ibb(i2,1)),yb(ibb(i2,1))
                  stop
               endif

               il0 = ibb(i0,1)
               il1 = ibb(i,1)
               il2 = ibb(i2,1)
               ilk = ibb(i,2)

               if(ilk.ne. ibb(i0,2) .or. ilk .ne. ibb(i2,2) ) then
                  print *,'error jkol'
                  print *,x(i),y(i),i,ibb(i,1),ibb(i,2),ilk
                  print *,x(i0),y(i0),i0,ibb(i0,1),ibb(i0,2)
                  print *,x(i2),y(i2),i2,ibb(i2,1),ibb(i2,2)
                  stop
               endif
         
c     reordering in the case of end point
               if(il0 .eq. ibpoin(ilk-1)+1 .and. il1 .gt. il2) then
                  il0 = ibpoin(ilk)
                  if(abs(xb(ibpoin(ilk-1)+1)-xb(ibpoin(ilk)) ) 
     *                 .gt. 1E-05 .or.
     *                 abs(yb(ibpoin(ilk-1)+1)-yb(ibpoin(ilk)) ) 
     *                 .gt. 1E-05 )then
                     print *,'error in profile, the end point is not'
                     print *,'the first, or bad reordering'
                     print *,ilk,(ibpoin(ilk-1)+1),ibpoin(ilk)
                     print *,'1',il0,il1,il2
                     stop
                  endif
               endif

               if(il0 .eq. ibpoin(ilk) .and. il2 .gt. il1) then
                  il0 = ibpoin(ilk-1)+1
                  if(abs(xb(ibpoin(ilk-1)+1)-xb(ibpoin(ilk)) ) 
     *                 .gt. 1E-05 .or.
     *                 abs(yb(ibpoin(ilk-1)+1)-yb(ibpoin(ilk)) ) 
     *                 .gt. 1E-05 )then
                     print *,'error in profile, the end point is not'
                     print *,'the first, or bad reordering'
                     print *,'2',il0,il1,il2
                     stop
                  endif
               endif

               if(il2 .eq. ibpoin(ilk-1)+1 .and. il1 .gt. il0) then
                  il2 = ibpoin(ilk)
                  if(abs(xb(ibpoin(ilk-1)+1)-xb(ibpoin(ilk)) ) 
     *                 .gt. 1E-05 .or.
     *                 abs(yb(ibpoin(ilk-1)+1)-yb(ibpoin(ilk)) ) 
     *                 .gt. 1E-05 )then
                     print *,'error in profile, the end point is not'
                     print *,'the first, or bad reordering'
                     print *,'3',il0,il1,il2
                     stop
                  endif
               endif

               if(il2 .eq. ibpoin(ilk) .and. il0 .gt. il1) then
                  il2 = ibpoin(ilk-1)+1
                  if(abs(xb(ibpoin(ilk-1)+1)-xb(ibpoin(ilk)) ) 
     *                 .gt. 1E-05 .or.
     *                 abs(yb(ibpoin(ilk-1)+1)-yb(ibpoin(ilk)) ) 
     *                 .gt. 1E-05 )then
                     print *,'error in profile, the end point is not'
                     print *,'the first, or bad reordering'
                     print *,'4',il0,il1,il2
                     print *,x(i0),y(i0),i0
                     print *,x(i),y(i),i
                     print *,x(i2),y(i2),i2
                     stop
                  endif
               endif
c     always il0 < il1 < il2 due to the orientation
c     but may be il1 or il2 > ibpoin(ilk)
               if( il2 .gt. il0 .and. il2 - il0 .le. 20) then
                  ilo = il2 - il0 - 1
                  do 210 l=il0+1,il2-1
                     xloc(l-il0) = xb(l)
                     yloc(l-il0) = yb(l)
                     iloc(l-il0) = l
 210              continue
               endif
               if(il0 .gt. il2 .and. il2+ibpoin(ilk)-il0-2 .le. 20) then
                  ilo = il2 + ibpoin(ilk) - il0 -2
                  do 220 l=il0+1,ibpoin(ilk)-1
                     xloc(l-il0) = xb(l)
                     yloc(l-il0) = yb(l)
                     iloc(l-il0) = l
 220              continue
                  do l=1,il2-1
                     xloc(l+ibpoin(ilk) - il0 -1) = xb(l)
                     yloc(l+ibpoin(ilk) - il0 -1) = yb(l)
                     iloc(l+ibpoin(ilk) - il0 -1) = l
                  enddo
               endif

               if(il2 .gt. il0 .and. il2 - il0 .gt. 20) then
                  rkg = 1.*(il2-il0 -2) /19
                  do 230 k=0,19
                     l = il0 + 1 +int(k*rkg+0.5)
                     xloc(k+1) = xb(l)
                     yloc(k+1) = yb(l)
                     iloc(k+1) = l
 230              continue
                  ilo = 20
               endif
               if(il0.gt.il2 .and. il2+ibpoin(ilk)-il0-2 .gt. 20) then
                  rkg = 1.*(il2-il0+ibpoin(ilk) -2) /19
                  do 240 k=0,19
                     l = il2 + 1 +int(k*rkg+0.5)
                     if(l .ge. ibpoin(ilk)) l = l -ibpoin(ilk)+1
                     iprint = 0
                     if(iprint .eq. 1) then
                        print *,'&&&',i,l,ibpoin(ilk)
                        print *,x(i),y(i),i
                        print *,x(i0),y(i0),i0
                        print *,x(i2),y(i2),i2
                        print *,'______________________'
                        do kk1 =1,abs(icyc(i,1))
                           print *,x(icyc(i,kk1+1)),y(icyc(i,kk1+1)),
     *                          icyc(i,kk1+1)
                        enddo
                        print *,'______________________'
                        print *,xb(il0),yb(il0),il0
                        print *,xb(il1),yb(il1),il1
                        print *,xb(il2),yb(il2),il2
                        print *,'Mischmatch detected in MOVING.f????' 
                     endif
                     xloc(k+1) = xb(l)
                     yloc(k+1) = yb(l)
                     iloc(k+1) = l
 240              continue
                  ilo = 20
c                  stop
               endif
            endif

            quality = 0.
            qualityrez = 1E+35

            if(ibp(i,1) .eq. 0 ) then
c     for nonperiodical points
               jbet = 0
               do 140 k=1,ilo
                  quality1 = 0.
                  quality1rez = 0.
                  xnew = xloc(k)
                  ynew = yloc(k)

                  do 130 j=1,len-1
                     j1 = mod(j,len )+1
                     ii1 = icyc(i,j+1)
                     ii2 = icyc(i,j1+1)
                     xi = x(icyc(i,j+1))
                     yi = y(icyc(i,j+1))
                     xi1 = x(icyc(i,j1+1))
                     yi1 = y(icyc(i,j1+1))
c     check the orientation and bad conditionality
                     detiii = xi*(yi1-ynew)+xi1*(ynew-yi)+xnew*(yi-yi1)
                     reps = pos*( ((xi1-xi)**2 + (yi1-yi)**2) +
     *                    ((xi-xnew)**2 + (yi-ynew)**2) +
     *                    ((xi1-xnew)**2 + (yi1-ynew)**2) )
                     
                     if (detiii .le. reps) goto 140
                     call POS1TEST(xi,yi,xi1,yi1,xnew,ynew,itet)
                     if(itet .eq. 1) then
                        goto 140
                     endif


                     acc = ACCUTE(xi,yi,xi1,yi1,xnew,ynew,5.)

                     rl1 = (0.5*((rga(i)+rga(ii1))*(xi-xnew)*(xi-xnew)+
     *                    2*(rgb(i)+rgb(ii1))*(xi-xnew)*(yi-ynew)+
     *                    (rgc(i)+rgc(ii1))*(yi-ynew)*(yi-ynew)))**0.5

c                     quality1rez = quality1rez + (rl1 - 1.732050807)**2
c     ... NEW ACCUTE

                     quality1rez = quality1rez 
     *                    + (rl1 - 1.732050807)**2*acc

                     if(j .eq. len -1) then
                        rl1 = (0.5*((rga(i)+rga(ii2))*
     *                       (xi1-xnew)*(xi1-xnew)+
     *                       2*(rgb(i)+rgb(ii2))*
     *                       (xi1-xnew)*(yi1-ynew)+
     *                       (rgc(i)+rgc(ii2))*
     *                       (yi1-ynew)*(yi1-ynew)))**0.5

                        quality1rez = quality1rez + 
     *                       (rl1 - 1.732050807)**2

                     endif

                     ice = 0
 130              continue
                  quality1rez = quality1rez/len

                  if(quality1rez .lt. qualityrez ) then
                     qualityrez = quality1rez
                     jbet = k
                  endif

 140           continue
               if(jbet .gt. 0) then
                  x(i) = xloc(jbet)
                  y(i) = yloc(jbet)
                  ibb(i,1) = iloc(jbet)
               endif
            else
c     for periodical points
               i1 = ibp(i,1)
               if(ibp(i,2) .eq. 1) then
                  xperreal = xper
                  yperreal = yper
               else
                  xperreal = xper2
                  yperreal = yper2
               endif                  
               len1 = abs(icyc(i1,1))
               if(abs(x(i1) + xperreal - x(i) ) .lt. 1E-05 .and.
     *              abs(y(i1) + yperreal - y(i) ) .lt. 1E-05 ) then
                  imov = 1
               elseif(abs(x(i1) - xperreal - x(i) ) .lt. 1E-05 .and.
     *              abs(y(i1) - yperreal - y(i) ) .lt. 1E-05 ) then
                  imov = -1
               else
                  print *,'BAD in moving in periodical points'
                  print *,i,i1,imov
                  print *,x(i),y(i),xperreal
                  print *,x(i1),y(i1),yperreal
                  print *,abs(x(i1) + xperreal - x(i) ),
     *                 abs(y(i1) + yperreal - y(i) ),
     *                 abs(x(i1) - xperreal - x(i) ),
     *                 abs(y(i1) - yperreal - y(i) )
                  stop
               endif
               
               jbet = 0
               do 340 k=1,ilo
                  quality1 = 0.
                  quality1rez = 0.
                  xnew = xloc(k)
                  ynew = yloc(k)
                  do 330 j=1,len-1
                     j1 = mod(j,len )+1
                     ii1 = icyc(i,j+1)
                     ii2 = icyc(i,j1+1)
                     xi = x(icyc(i,j+1))
                     yi = y(icyc(i,j+1))
                     xi1 = x(icyc(i,j1+1))
                     yi1 = y(icyc(i,j1+1))
c     check the orientation and bad conditionality
                     detiii = xi*(yi1-ynew)+xi1*(ynew-yi)+xnew*(yi-yi1)
                     reps = pos*( ((xi1-xi)**2 + (yi1-yi)**2) +
     *                    ((xi-xnew)**2 + (yi-ynew)**2) +
     *                    ((xi1-xnew)**2 + (yi1-ynew)**2) )
                     
                     if (detiii .le. reps) goto 340
                     call POS1TEST(xi,yi,xi1,yi1,xnew,ynew,itet)
                     if(itet .eq. 1) then
                        goto 340
                     endif
                     
                     acc = ACCUTE(xi,yi,xi1,yi1,xnew,ynew, 1.)

                     rl1 = (0.5*((rga(i)+rga(ii1))*(xi-xnew)*(xi-xnew)+
     *                    2*(rgb(i)+rgb(ii1))*(xi-xnew)*(yi-ynew)+
     *                    (rgc(i)+rgc(ii1))*(yi-ynew)*(yi-ynew)))**0.5
                     
c                     quality1rez = quality1rez + (rl1 - 1.732050807)**2

c     ... NEW ACCUTE
                     quality1rez = quality1rez 
     *                    +(rl1 - 1.732050807)**2*acc

                     if(j .eq. len -1) then
                        rl1 = (0.5*((rga(i)+rga(ii2))*
     *                       (xi1-xnew)*(xi1-xnew)+
     *                       2*(rgb(i)+rgb(ii2))*
     *                       (xi1-xnew)*(yi1-ynew)+
     *                       (rgc(i)+rgc(ii2))*
     *                       (yi1-ynew)*(yi1-ynew)))**0.5

                        quality1rez = quality1rez + 
     *                       (rl1 - 1.732050807)**2
                     endif

 330              continue
                  xnew = xloc(k) - imov*xperreal
                  ynew = yloc(k) - imov*yperreal
                  do 350 j=1,len1-1
                     j1 = mod(j,len1 )+1
                     ii1 = icyc(i1,j+1)
                     ii2 = icyc(i1,j1+1)
                     xi = x(icyc(i1,j+1))
                     yi = y(icyc(i1,j+1))
                     xi1 = x(icyc(i1,j1+1))
                     yi1 = y(icyc(i1,j1+1))
c     check the orientation and bad conditionality
                     detiii = xi*(yi1-ynew)+xi1*(ynew-yi)+xnew*(yi-yi1)
                     reps = pos*( ((xi1-xi)**2 + (yi1-yi)**2) +
     *                    ((xi-xnew)**2 + (yi-ynew)**2) +
     *                    ((xi1-xnew)**2 + (yi1-ynew)**2) )
                     
                     if (detiii .le. reps) goto 340
                     call POS1TEST(xi,yi,xi1,yi1,xnew,ynew,itet)
                     if(itet .eq. 1) then
                        goto 340
                     endif

                     acc = ACCUTE(xi,yi,xi1,yi1,xnew,ynew, 1.)

                     rl1 = (0.5*((rga(i)+rga(ii1))*(xi-xnew)*(xi-xnew)+
     *                    2*(rgb(i)+rgb(ii1))*(xi-xnew)*(yi-ynew)+
     *                    (rgc(i)+rgc(ii1))*(yi-ynew)*(yi-ynew)))**0.5

c                     quality1rez = quality1rez + (rl1 - 1.732050807)**2
c     ... NEW ACCUTE
                     quality1rez = quality1rez 
     *                    +(rl1 - 1.732050807)**2*acc

                     if(j .eq. len1 -1) then
                        rl1 = (0.5*((rga(i)+rga(ii2))*
     *                       (xi1-xnew)*(xi1-xnew)+
     *                       2*(rgb(i)+rgb(ii2))*
     *                       (xi1-xnew)*(yi1-ynew)+
     *                       (rgc(i)+rgc(ii2))*
     *                       (yi1-ynew)*(yi1-ynew)))**0.5

                        quality1rez = quality1rez + 
     *                       (rl1 - 1.732050807)**2
                     endif
 350              continue
                  quality1rez = quality1rez/(len+len1+2)

                  if(quality1rez .lt. qualityrez ) then
                     qualityrez = quality1rez
                     jbet = k
                  endif
 340           continue
               if(jbet .gt. 0) then
                  x(i) = xloc(jbet)
                  y(i) = yloc(jbet)
                  x(i1) = xloc(jbet) - imov*xperreal
                  y(i1) = yloc(jbet) - imov*yperreal
               endif
            endif
         endif
 21      continue
 100  continue

      return
      end
