      subroutine REMOVE(ndim,melem,nelem,mpoin,npoin,
     *     maxdeg,x,y,lnd,iae,
     *     ra,icyc,rminerr,imin,rmaxrez,
     *     icha,nserr,wp,lbn,ibc,itc,nbelm,mbelm,
     *     rga,rgb,rgc,ipoint,nbp,xb,yb,ibb,ibpoin,ibp)
      dimension lnd(melem,3),iae(melem,3),x(mpoin),y(mpoin),
     *     ra(mpoin),wp(mpoin,ndim+1),rga(mpoin),rgb(mpoin),rgc(mpoin),
     *     icyc(mpoin,maxdeg),
     *     nserr(melem*3,2),lbn(mbelm,2),itc(mbelm),ibc(mbelm),
     *     xb(ipoint),yb(ipoint),ibp(mpoin,2),ibb(mpoin,3),ibpoin(0:nbp)
      integer nsr(3),locyc(30)
      real*8 rlen0,rlen1,rlen2,rcos,ss,ve1x,ve1y,ve2x,ve2y
      real rmin(3)
      integer jmin(3)
 
      common /const/ p, epsilon1, pos, pos1, numel,ityp
      common /period/ xper,yper,iper1,iper2
      common /period2/ xper2,yper2,iper3,iper4


      rlmin2 = 1.33

      icha = 0
      nelemold = nelem
      ipoc = 1
      do 20 iyi=1,nelemold
         i = ipoc
         if( i .le. nelem) then
            do 27 jdo=1,3
               j = jdo
               j1 = mod(j,3) + 1
               k1 = lnd(i,j)
               k2 = lnd(i,j1)
               x1 = x(k1)
               y1 = y(k1)
               x2 = x(k2)
               y2 = y(k2)
               a = (rga(k1) + rga(k2) )/2
               b = (rgb(k1) + rgb(k2) )/2
               c = (rgc(k1) + rgc(k2) )/2
               rmin(j) = (a*(x1-x2)*(x1-x2) + c*(y1-y2)*(y1-y2)
     *              + 2*b*(x1-x2)*(y1-y2))
               jmin(j) = j
 27         continue

            do 25 k=1,3
               do 26 l=1,2
                  if(rmin(l) .gt. rmin(l+1) ) then
                     rminhelp = rmin(l)
                     rmin(l) = rmin(l+1)
                     rmin(l+1) = rminhelp
                     jminhelp = jmin(l)
                     jmin(l) = jmin(l+1)
                     jmin(l+1) = jminhelp
                  endif
 26            continue
 25         continue
            
            do 28 jdo=1,3
               j = jmin(jdo)
               j1 = mod(j,3) + 1
               k1 = lnd(i,j)
               k2 = lnd(i,j1)
               x1 = x(k1)
               y1 = y(k1)
               x2 = x(k2)
               y2 = y(k2)
               ig1 = 0
               ig2 = 0
               do 21 ib=1,nbelm
                  if(lbn(ib,1) .eq. k1) ig1 = 1
                  if(lbn(ib,1) .eq. k2) ig2 = 1
 21            continue
               
               if(ig1 .eq. 1 .and. icyc(k1,1) .ge. 0) then
                  print *,'ERROR in REMOVE - boundary point 1'
                  kl = k1
                  write(*,'(i5,2e12.4,2i5)') kl,x(kl),y(kl),
     *                 icyc(kl,1),ig1
                  do kl1 = 1,abs(icyc(kl,1))
                     kll = icyc(kl,kl1+1)
                     write(*,'(2e12.4,i5)') x(kll),y(kll),kll
                  enddo
                  stop
               endif
               if(ig2 .eq. 1 .and. icyc(k2,1) .ge. 0) then
                  print *,'ERROR in REMOVE - boundary point 2'
                  kl = k2
                  write(*,'(i5,2e12.4,2i5)') kl,x(kl),y(kl),
     *                 icyc(kl,1),ig2
                  do kl1 = 1,abs(icyc(kl,1))
                     kll = icyc(kl,kl1+1)
                     write(*,'(2e12.4,i5)') x(kll),y(kll),kll
                  enddo
                  
                  do ib=1,nbelm
                     if(lbn(ib,1) .eq. kl) then
                        print *,'^^',lbn(ib,1),ib,x(lbn(ib,1)),
     *                       y(lbn(ib,1)),ibb(kl,1)
                     endif
                  enddo
                 stop
               endif
               
               if(iae(i,j) .gt. 0) then
c     for non boundary sides
                  if(ig1+ig2 .le. 1 .and. rmin(jdo) .le. rlmin2) then
c     we  remove this side (may be)

                     j2 = mod(j1,3)+1
                     ii = iae(i,j)
                     jj = 0
                     do 35 jjj=1,3
                        if(iae(ii,jjj) .eq. i) jj = jjj
 35                  continue
                     if(jj .eq. 0) then
                        print *,'error 1342'
                        stop
                     endif
                     jj1 = mod(jj,3)+1
                     jj2 = mod(jj1,3)+1
                     k3 = lnd(i,j2)
                     k4 = lnd(ii,jj2)

                     if(k2.ne.lnd(ii,jj) .or. k1.ne.lnd(ii,jj1))then
                        print *,'ERRROR in REMOVE'
                        print *,i,k1,k2,k3,k4
                        print *,i,lnd(i,1),lnd(i,2),lnd(i,3)
                        print *,ii,lnd(ii,1),lnd(ii,2),lnd(ii,3)
                        print *,x(k1),y(k1)
                        print *,x(k2),y(k2)
                        print *,x(k3),y(k3)
                        print *,x(k4),y(k4)
                        stop
                     endif
                     
                     if(iae(i,j1) .gt. 0) then
                        ia1 = iae(i,j1)
                        do 40 kk =1,3
                           if(iae(ia1,kk) .eq. i) ja1 = kk
 40                     continue
                     else
                        ia1 = -2
                     endif
                     if(iae(i,j2) .gt. 0) then
                        ia2 = iae(i,j2)
                        do 50 kk =1,3
                           if(iae(ia2,kk) .eq. i) ja2 = kk
 50                     continue
                     else
                        ia2 = -2
                     endif
                     if(iae(ii,jj1) .gt. 0) then
                        iia1 = iae(ii,jj1)
                        do 60 kk =1,3
                           if(iae(iia1,kk) .eq. ii) jja1 = kk
 60                     continue
                     else
                        iia1 = -2
                     endif
                     if(iae(ii,jj2) .gt. 0) then
                        iia2 = iae(ii,jj2)
                        do 70 kk =1,3
                           if(iae(iia2,kk) .eq. ii) jja2 = kk
 70                     continue
                     else
                        iia2 = -2
                     endif
c     here we check, so we will not obtain the triangle with two 
c     boundary sides
                     if(ia2 .lt. 0)then
                        if(iae(ia1,1) .lt. 0 .or. iae(ia1,2) .lt. 0 
     *                       .or.iae(ia1,3) .lt. 0 ) then
                           goto 28
                        endif
                     endif
                     if(ia1 .lt. 0)then
                        if(iae(ia2,1) .lt. 0 .or. iae(ia2,2) .lt. 0 
     *                       .or.iae(ia2,3) .lt. 0 )then
                           goto 28
                        endif
                     endif

                     if(iia2 .lt. 0)then
                        if(iae(iia1,1) .lt. 0 .or. iae(iia1,2) .lt. 0 
     *                       .or.iae(iia1,3) .lt. 0 ) then
                          goto 28
                       endif
                     endif
                     if(iia1 .lt. 0)then
                        if(iae(iia2,1) .lt. 0 .or. iae(iia2,2) .lt. 0 
     *                       .or.iae(iia2,3) .lt. 0 ) then
                          goto 28
                       endif
                     endif

c     here we check that after emoving don't arise a corner triangle
                     if(iia1 .eq. ia2 .and. ia2 .gt. 0 .and.
     *                    iia2 .lt. 0 .and. ia1 .lt. 0) then
                        goto 28
                     endif
                     if(ia1 .eq. iia2 .and. iia2 .gt. 0 .and.
     *                    ia2 .lt. 0 .and. iia1 .lt. 0) then
                        goto 28
                     endif

                     if( ig1 .eq. 1) then
c     k1 is on the boundary, no changes
                        xk1 = x(k1)
                        yk1 = y(k1)
                        wpk1 = wp(k1,1)
                        rgak = rga(k1)
                        rgbk = rgb(k1)
                        rgck = rgc(k1)
                     elseif( ig2 .eq. 1) then
c     k2 on the boundary
                        xk1 = x(k2)
                        yk1 = y(k2)
                        wpk1 = wp(k2,1)
                        rgak = rga(k2)
                        rgbk = rgb(k2)
                        rgck = rgc(k2)
                     else
                        xk1 = (x(k1) + x(k2) )/2
                        yk1 = (y(k1) + y(k2) )/2
                        wpk1 = (wp(k1,1) + wp(k2,1) )/2
                        rgak = (rga(k1) + rga(k2) )/2
                        rgbk = (rgb(k1) + rgb(k2) )/2
                        rgck = (rgc(k1) + rgc(k2) )/2


                  
                     endif
                  
c     we check that if some new triangle will satisfy the positivity

                     xx0 = xk1
                     yy0 = yk1
c     for point k1
                     if(icyc(k1,1) .gt. 0) then
                        ilen = icyc(k1,1)
                     else
                        ilen = abs(icyc(k1,1)) - 1
                     endif
                     do 450 kk=1,ilen
                        kk1 = mod(kk,icyc(k1,1)) + 1
                        if( icyc(k1,kk+1) .ne. k2 .and. 
     *                       icyc(k1,kk1+1) .ne. k2) then
                           xx1 = x(icyc(k1,kk+1))
                           yy1 = y(icyc(k1,kk+1))
                           xx2 = x(icyc(k1,kk1+1))
                           yy2 = y(icyc(k1,kk1+1))
                           reps = pos*( ((xx0-xx2)**2 + (yy0-yy2)**2) +
     *                          ((xx1-xx2)**2 + (yy1-yy2)**2) +
     *                          ((xx0-xx1)**2 + (yy0-yy1)**2) )
                           det123 = xx0*(yy1-yy2) + xx1*(yy2-yy0) + 
     *                          xx2*(yy0-yy1) 
                           
                           if( det123 .le. reps) then
c     violation of positivity, go to next j
                              goto 28
                           endif
                           call POS1TEST(xx0,yy0,xx1,yy1,xx2,yy2,itet)
                           if(itet .eq. 1) then
                              goto 28
                           endif
                        endif
 450                 continue
c     now for k2 

                     if(icyc(k2,1) .gt. 0) then
                        ilen = icyc(k2,1)
                     else
                        ilen = abs(icyc(k2,1)) - 1
                     endif
                     do 460 kk=1,ilen
                        kk2 = mod(kk,icyc(k2,1)) + 1
                        if( icyc(k2,kk+1) .ne. k1 .and. 
     *                       icyc(k2,kk2+1) .ne. k1) then
                           xx1 = x(icyc(k2,kk+1))
                           yy1 = y(icyc(k2,kk+1))
                           xx2 = x(icyc(k2,kk2+1))
                           yy2 = y(icyc(k2,kk2+1))
                           reps = pos*( ((xx0-xx2)**2 + (yy0-yy2)**2) +
     *                          ((xx1-xx2)**2 + (yy1-yy2)**2) +
     *                          ((xx0-xx1)**2 + (yy0-yy1)**2) )
                           det123 = xx0*(yy1-yy2) + xx1*(yy2-yy0) + 
     *                          xx2*(yy0-yy1) 
                           
                           if( det123 .le. reps) then
c     violation of positivity, go to next j
                              goto 28
                           endif
                           call POS1TEST(xx0,yy0,xx1,yy1,xx2,yy2,itet)
                           if(itet .eq. 1) then
                              goto 28
                           endif


                        endif
 460                 continue

                     kk1 = k1
                     kk2 = k2
                     if( ig2 .eq. 1) then
                        kk1 = k2
                        kk2 = k1
                     endif

                     x(kk1) = xk1
                     y(kk1) = yk1

                     wp(kk1,1) = wpk1
                     rga(kk1) = rgak
                     rgb(kk1) = rgbk
                     rgc(kk1) = rgck

c     shiftting of all array after removing k2 

                     do 6745 ip=1,npoin
                        if(ibp(ip,1) .eq. kk2 .and.kk1 .ne. npoin) 
     *                       ibp(ip,1) = kk1
                        if(ibp(ip,1) .eq. npoin .and.kk2 .ne. npoin) 
     *                       ibp(ip,1) = kk2
 6745                continue
                     
                     
                     ibp(kk2,1) = ibp(npoin,1) 
                     ibp(kk2,2) = ibp(npoin,2) 
                     x(kk2) = x(npoin)
                     y(kk2) = y(npoin)
                     ibb(kk2,1) = ibb(npoin,1)
                     ibb(kk2,2) = ibb(npoin,2)
                     ibb(kk2,3) = ibb(npoin,3)
                     wp(kk2,1) = wp(npoin,1)
                     rga(kk2) = rga(npoin)
                     rgb(kk2) = rgb(npoin)
                     rgc(kk2) = rgc(npoin)

                     iemin = min (i,ii)
                     iemax = max (i,ii)

                     if(ia1 .gt. 0) iae(ia1,ja1) = ia2
                     if(ia2 .gt. 0) iae(ia2,ja2) = ia1
                     if(iia1 .gt. 0) iae(iia1,jja1) = iia2
                     if(iia2 .gt. 0) iae(iia2,jja2) = iia1
                  
                     do 355 ie=1,nelem
                        do 360 kj=1,3
                           if(lnd(ie,kj) .eq. kk2 .and. kk1 .ne. npoin)
     *                          lnd(ie,kj) = kk1
                           if(lnd(ie,kj) .eq. npoin .and. kk2 .ne.npoin)
     *                          lnd(ie,kj) = kk2
 360                    continue
                        if( iemax .lt. nelem-1 ) then
                           do kj=1,3
                              if(iae(ie,kj).eq.nelem-1) iae(ie,kj)=iemin
                              if(iae(ie,kj) .eq. nelem) iae(ie,kj)=iemax
                           enddo
                        elseif(iemax .eq. nelem-1 ) then
                           do kj=1,3
                              if(iae(ie,kj) .eq. nelem) iae(ie,kj)=iemin
                           enddo
                        elseif(iemax .eq. nelem .and. 
     *                          iemin .lt. nelem-1) then
                           do kj=1,3
                              if(iae(ie,kj).eq.nelem-1) iae(ie,kj)=iemin
                           enddo
                        elseif(iemax .eq. nelem .and. 
     *                          iemin .eq. nelem-1) then
c     no performance
                        else
                           print *,'LOGICAL error in REMOVE - 111&*('
                           stop
                        endif
 355                 continue

                     if( iemax .lt. nelem-1 ) then
                        do kj=1,3
                           lnd(iemin,kj) = lnd(nelem-1,kj)
                           iae(iemin,kj) = iae(nelem-1,kj)
                           lnd(iemax,kj) = lnd(nelem,kj)
                           iae(iemax,kj) = iae(nelem,kj)
                        enddo
                     elseif(iemax .eq. nelem-1 ) then
                        do kj=1,3
                           lnd(iemin,kj) = lnd(nelem,kj)
                           iae(iemin,kj) = iae(nelem,kj)
                        enddo
                     elseif(iemax .eq. nelem .and. 
     *                       iemin .lt. nelem-1) then
                        do kj=1,3
                           lnd(iemin,kj) = lnd(nelem-1,kj)
                           iae(iemin,kj) = iae(nelem-1,kj)
                        enddo
                     elseif(iemax .eq. nelem .and. 
     *                       iemin .eq. nelem-1) then
c     no performance
                     else
                        print *,'LOGICAL error in REMOVE - &*('
                        stop
                     endif

                     do k=1,nbelm
                        if(itc(k) .eq. i) then
                           if(ia1 .lt. 0 .and. ia2 .gt. 0) then
                              itc(k) = ia2
                           elseif(ia2 .lt. 0 .and. ia1 .gt.0) then
                              itc(k) = ia1
                           else
                              print *,'LOG. EROR in REM 145'
                              stop
                           endif
                        elseif(itc(k) .eq. ii) then
                           if(iia1 .lt. 0 .and. iia2 .gt. 0) then
                              itc(k) = iia2
                           elseif(iia2 .lt. 0 .and. iia1 .gt. 0) then
                              itc(k) = iia1
                           else
                              print *,'LOG. EROR in REM 146'
                              stop
                           endif
                        endif
                     enddo

                     do 300 k=1,nbelm
                        do 310 l=1,2
                           if(lbn(k,l) .eq. kk2 .and. kk1.ne.npoin) 
     *                          lbn(k,l) = kk1
                           if(lbn(k,l) .eq. npoin .and. kk2 .ne. npoin)
     *                          lbn(k,l) = kk2
 310                    continue
                        if( iemax .lt. nelem-1 ) then
                           if(itc(k) .eq. nelem-1)  itc(k)=iemin
                           if(itc(k) .eq. nelem)  itc(k)=iemax
                        elseif(iemax .eq. nelem-1 ) then
                           if(itc(k) .eq. nelem)  itc(k)=iemin
                        elseif(iemax .eq. nelem .and. 
     *                          iemin .lt. nelem-1 ) then
                           if(itc(k) .eq. nelem-1)  itc(k)=iemin
                        elseif(iemax .eq. nelem .and. 
     *                          iemin .eq. nelem-1 ) then
c     no performance
                        else
                           print *,'ERRor in REMOVE 123'
                           print *,'LOGICAL error'
                           stop
                        endif
 300                 continue
c     connection of two cykles
                     is = 0
                     do 700 ic=1,abs(icyc(kk2,1))
                        ic1 = mod(ic,abs(icyc(kk2,1)) ) +1
                        if( icyc(kk2,ic1+1) .eq. kk1) is = ic
 700                 continue
                     if(is .eq. 0) then
                        print *,'ERROR in REMOVE in @#$%'
                        stop
                     endif
                     is1 = mod(is,abs(icyc(kk2,1)) ) +1
                     is2 = mod(is1,abs(icyc(kk2,1)) ) +1
                     ip = icyc(kk2,is+1)
                     ip1 = icyc(kk2,is1+1)
                     ip2 = icyc(kk2,is2+1)
                     
                     if(ip1 .ne. kk1) then
                        print *,'ERROR in $%$%$%',kk1,kk2
                        print *,is,is1,is2
                        print *,ip,ip1,ip2
                        stop
                     endif
                     
                     ir2 = 0
                     ir1 = 0
                     do 710 ic = 1,abs(icyc(kk1,1))
                        if(icyc(kk1,ic+1) .eq. ip2) ir2 = ic
                        if(icyc(kk1,ic+1) .eq. ip) ir1 = ic
 710                 continue
                     
                     if(ir1 .eq. 0 .or. ir2 .eq. 0) then
                        print *,'ERROR in REMOVE in $$$$'
                        stop
                     endif

                     locyc(1) = 0
                     irr = 0
                     do 720 ic =1,ir2
                        if(icyc(kk1,ic+1) .ne. kk2) then
                           irr = irr + 1
                           locyc(irr+1) = icyc(kk1,ic+1)
                           locyc(1) = locyc(1) + 1
                        endif
 720                 continue
                     
                     irr = locyc(1)
                     iskk2 = is2
 730                 ikk2 = mod(iskk2, abs(icyc(kk2,1) )) + 1
                     if( icyc(kk2,ikk2+1) .ne. ip) then
                        irr = irr + 1
                        locyc(1) = locyc(1) + 1
                        locyc(irr+1) = icyc(kk2,ikk2+1)
                        iskk2 = ikk2
                        goto 730
                     endif
                     
                     if( ir1 .gt. 2) then
                        do 740 ic= ir1,abs(icyc(kk1,1) )
                           irr = irr + 1
                           locyc(irr+1) = icyc(kk1,ic+1)
                           locyc(1) = locyc(1) + 1
 740                    continue
                     endif


                     if(locyc(1) + 1  .gt. maxdeg) then
                        print *,'Too long cykles in REMOVE'
                        print *,icyc(kk1,1),icyc(kk2,1),locyc(1),maxdeg
                        stop
                     endif
                     if(icyc(kk1,1) .gt. 0) then
                        icyc(kk1,1) = locyc(1) 
                     else
                        icyc(kk1,1) = -locyc(1) 
                     endif
                     
                     do 750 ic=1,locyc(1)
                        icyc(kk1,ic+1) = locyc(ic+1)
 750                 continue
c     end of connection of two cykles

                     do 500 ip =1,npoin
                        do 510 ic =1,abs(icyc(ip,1))
                           if(icyc(ip,ic+1) .eq. kk2)icyc(ip,ic+1) = kk1
                           if(icyc(ip,ic+1) .eq. npoin) 
     *                          icyc(ip,ic+1) = kk2
 510                    continue
 500                 continue
                     
                     do 530 ic=1,abs(icyc(npoin,1)) + 1
                        icyc(kk2,ic) = icyc(npoin,ic)
 530                 continue
                     
                     do 400 ip1 =1,2
                        if(ip1 .eq. 1) then
                           ip = k3
                           if(k3 .eq. npoin ) ip = kk2
                        endif
                        if(ip1 .eq. 2) then
                           ip = k4
                           if(k4 .eq. npoin ) ip = kk2
                        endif
                        do 410 ic =1,abs(icyc(ip,1))
                           ic1 = mod(ic,abs(icyc(ip,1)) ) + 1
                           if( icyc(ip,ic+1) .eq. icyc(ip,ic1+1) ) then
                              do 420 icc= ic1,abs(icyc(ip,1))-1
                                 icyc(ip,icc+1) = icyc(ip,icc+2)
 420                          continue
                              if(icyc(ip,1) .gt. 0) then
                                 icyc(ip,1) = icyc(ip,1) - 1
                              else
                                 icyc(ip,1) = icyc(ip,1) + 1
                              endif
                              goto 400
                           endif
 410                    continue
 400                 continue
c     end of shiftting

c     all is done, we can continue

                     npoin = npoin - 1
                     nelem = nelem - 2
                     icha = icha + 1

                     
                  endif
               else
c     for boundary sides

                  if( ig1 + ig2 .ne. 2) then
                     print *,'ERROR in REMOVE'
                     print *,'the boundary segment do not have ',
     *                    'the points on the boundary'
                     print *,i,k1,k2,ig1,ig2,icha
                     print *,lnd(i,1),lnd(i,2),lnd(i,3)
                     print *,nelem,npoin,nbelm
                     print *,melem,mpoin,mbelm
                     print *,x1,y1
                     print *,x2,y2
                     stop
                  endif

                  itest2 = 0
                  if(rmin(jdo) .le. rlmin2) then
c     we  remove this edge
                     itest2 = 1
                     ipe = 0
 999                 j1 = mod(j,3) +1
                     j2 = mod(j1,3)+1
                     k1 = lnd(i,j)
                     k2 = lnd(i,j1)
                     k3 = lnd(i,j2)
                     x1 = x(k1)
                     y1 = y(k1)
                     x2 = x(k2)
                     y2 = y(k2)
                     kb0 = 0
                     kb1 = 0
                     kb2 = 0


                     do 610 ib=1,nbelm
                        if(lbn(ib,1) .eq. k1 .and. 
     *                       lbn(ib,2) .eq. k2) then
                           kb1 = ib
                        elseif(lbn(ib,2) .eq. k1) then
                           kb0 = ib 
                        elseif(lbn(ib,1) .eq. k2) then
                           kb2 = ib
                        endif
 610                 continue

                     if( kb0*kb1*kb2 .eq. 0 ) then
                        print *,'The bounary segment does not found'
                        print *,i,k1,k2
                        print *,kb0,kb1,kb2
                        print *,x1,y1,x(k1),y(k1)
                        print *,x2,y2,x(k2),y(k2)
                        stop
                     endif

                     if(ipe .eq. 1) goto 993

c     "sharp angle
                     ikr1 = 0
                     ikr2 = 0
                     ibbk1 = ibb(k1,1)
                     ibbk11 = ibb(k1,2)
                     ibbk2 = ibb(k2,1)
                     ilk = 0
                     ilk1 = 0

                     if(ibb(k1,1) .gt. 0) then 
                        ikk1 = ibb(k1,2)
                        if(ibb(k1,1) .eq. ibpoin(ikk1-1)+1  .or.
     *                       ibb(k1,1) .eq. ibpoin(ikk1) .or. 
     *                       ibb(k1,3) .eq. -1) then
c               NO moving of final or initial node of profiles
                           ikr1 = 1
                           ilk = ibb(k1,2)
                           ilk1 = ibb(k1,3)
                        endif
                     endif

                     if(ibb(k2,1) .gt. 0) then 
                        ikk1 = ibb(k2,2)
                        if(ibb(k2,1) .eq. ibpoin(ikk1-1)+1  .or.
     *                       ibb(k2,1) .eq. ibpoin(ikk1) .or. 
     *                       ibb(k2,3) .eq. -1) then
c               NO moving of final or initial node of profiles
                           ikr2 = 1
                           ilk = ibb(k2,2)
                           ilk1 = ibb(k2,3)
                        endif
                     endif

                     if(ibbk1 .gt. 0 .and.  ibbk2 .gt. 0) then
                        ilk = ibb(k1,2)
                        ilk1 = ibb(k1,3)
                        if(ilk .ne. ibb(k2,2) ) then
                           print *,'error jkoli3',ss
                           print *,x(k1),y(k1),ibb(k1,1),ibb(k1,2)
                           print *,x(k2),y(k2),ibb(k2,1),ibb(k2,2)
                           stop
                        endif
                     endif

                     if(ilk .gt. 0 ) then
                        if(  ibbk1 .eq.  ibpoin(ilk-1) + 1 .or. 
     *                       ibbk1 .eq. ibpoin(ilk)) then
c     the point k1 we can not remove or move
                           ikr1 = 1
                        endif
                        if(  ibbk2 .eq.  ibpoin(ilk-1) + 1 .or. 
     *                       ibbk2 .eq. ibpoin(ilk)) then
c     the point k2 we can not remove or move
                           ikr2 = 1
                        endif
                     endif


                     rlen = ((x2-x(lbn(kb0,1)))**2 + 
     *                    (y2-y(lbn(kb0,1)))**2)
                     det = x(lbn(kb0,1))*(y1-y2) + x1*(y2-y(lbn(kb0,1)))
     *                    + x2*(y(lbn(kb0,1)) - y1)

                     ve1x = x(lbn(kb0,1)) - x1
                     ve1y = y(lbn(kb0,1)) - y1
                     ve2x = x2 - x1
                     ve2y = y2 - y1

                     ss = (ve1x*ve2x + ve1y*ve2y)/
     *                    (ve1x**2 + ve1y**2)**0.5/
     *                    (ve2x**2 + ve2y**2)**0.5

                     if(ss .gt. -0.96 ) then
c     the point k1 we can not remove or move
                        ikr1 = 1
                     endif
                     rlen = ((x1-x(lbn(kb2,2)))**2 + 
     *                    (y1-y(lbn(kb2,2)))**2)
                     det = x(lbn(kb2,2))*(y1-y2) + x1*(y2-y(lbn(kb2,2)))
     *                    + x2*(y(lbn(kb2,2))-y1)
                     ve1x = x(lbn(kb2,2)) - x2
                     ve1y = y(lbn(kb2,2)) - y2
                     ve2x = x1 - x2
                     ve2y = y1 - y2
                     ss = (ve1x*ve2x + ve1y*ve2y)/
     *                    (ve1x**2 + ve1y**2)**0.5/
     *                    (ve2x**2 + ve2y**2)**0.5

                     if(ss .gt. -0.96 ) then
c     the point k2 we can not remove or move
                        ikr2 = 1
                     endif


                     if( ikr2 .eq. 0 ) then
                        if(ikr1 .eq. 0) then
                           x0 = (x(k1) + x(k2) )/2
                           y0 = (y(k1) + y(k2) )/2
                           w0 = (wp(k1,1) + wp(k2,1) )/2
                           rgai = (rga(k1) + rga(k2)) /2
                           rgbi = (rgb(k1) + rgb(k2)) /2
                           rgci = (rgc(k1) + rgc(k2)) /2
                           if(ibb(k1,1).gt.0 .and. ibb(k2,1).gt.0) then
                              if(ibb(k2,1) .gt. ibb(k1,1) ) then
                                 if(ibb(k2,1) - ibb(k1,1) .ge. 2) then
                                    il0 = int(ibb(k1,1) + ibb(k2,1))/2
                                    x0 = xb(il0)
                                    y0 = yb(il0)
                                    ibbk1 = il0
                                    ibbk111 = ilk1
                                 else
c     a few points
                                    x0 = x(k1)
                                    y0 = y(k1)
                                 endif
                              else
                           
                                 if(abs(ibb(k1,1)-ibb(k2,1)-
     *                                ibpoin(ilk)+ibpoin(ilk-1)+1)
     *                                .ge. 2) then
                                    il0=int(ibb(k1,1)+ibb(k2,1)+
     *                                 ibpoin(ilk)-ibpoin(ilk-1)+1)/2
                                    if(il0 .ge. ibpoin(ilk)) 
     *                                   il0=il0-ibpoin(ilk)+
     *                                   ibpoin(ilk-1)+1
                                    x0 = xb(il0)
                                    y0 = yb(il0)
                                    ibbk1 = il0
                                    ibbk11 = ilk
                                    ibbk111 = ilk1
                                 else
c     a few points
                                    x0 = x(k1)
                                    y0 = y(k1)
                                 endif
                              endif
                           endif
                        else
                           x0 = x(k1)
                           y0 = y(k1)
                           w0 = wp(k1,1)
                           rgai = rga(k1) 
                           rgbi = rgb(k1) 
                           rgci = rgc(k1) 
                        endif
                     else
                        if(ikr1 .eq. 0) then
                           x0 = x(k2)
                           y0 = y(k2)
                           w0 = wp(k2,1)
                           rgai = rga(k2) 
                           rgbi = rgb(k2) 
                           rgci = rgc(k2) 
                           ibbk1 = ibb(k2,1)
                           ibbk11 = ibb(k2,2)
                           ibbk111 = ibb(k2,3)
                        else
c     no removing
                           goto 28
                        endif
                     endif
                     rll = ((x(k1) - x(k2))*(x(k1) - x(k2)) +
     *                    (y(k1) - y(k2))*(y(k1) - y(k2)) )

c     test the violation of positivity

                     ilen1 = abs(icyc(k1,1)) - 1
                     do 801 ic = 2,ilen1 
                        ic1 = ic + 1
                        x1 = x(icyc(k1,ic+1))
                        y1 = y(icyc(k1,ic+1))
                        x2 = x(icyc(k1,ic1+1))
                        y2 = y(icyc(k1,ic1+1))
                        reps = pos*( (x0-x1)**2+(y0-y1)**2 +
     *                       (x1-x2)**2+(y1-y2)**2 +
     *                       (x0-x2)**2 + (y0-y2)**2 )
                        det = x1*(y2-y0) + x0*(y1-y2) + x2*(y0-y1)
                        if( det .le. reps) then
                           goto 28
                        endif
                        call POS1TEST(x0,y0,x1,y1,x2,y2,itet)
                        if(itet .eq. 1) then
                           goto 28
                        endif


 801                 continue

                     ilen2 = abs(icyc(k2,1)) - 1
                     do 802 ic = 1,ilen2-1
                        ic1 = ic + 1
                        x1 = x(icyc(k2,ic+1))
                        y1 = y(icyc(k2,ic+1))
                        x2 = x(icyc(k2,ic1+1))
                        y2 = y(icyc(k2,ic1+1))
                        reps = pos*( (x0-x1)**2+(y0-y1)**2 +
     *                       (x1-x2)**2+(y1-y2)**2 +
     *                       (x0-x2)**2 + (y0-y2)**2 )
                        det = x1*(y2-y0) + x0*(y1-y2) + x2*(y0-y1)
                        if( det .le. reps) then
c     violation of positivity
                           goto 28
                        endif
                        call POS1TEST(x0,y0,x1,y1,x2,y2,itet)
                        if(itet .eq. 1) then
                           goto 28
                        endif
 802                 continue

c     periodic boundary
                     if(ibp(k1,1) .gt. 0 .and. ibp(k2,1) .gt. 0) then
                        if(ibp(k1,2) .ne. ibp(k2,2) ) goto 28
                        if(ibp(k2,2) .eq. 1) then
                           xperreal = xper
                           yperreal = yper
                        else
                           xperreal = xper2
                           yperreal = yper2
                        endif                  

c                        print *,'@@',k1,ibp(k1,1),ibp(k1,2),x(k1),y(k1)
c                        print *,'@@',k2,ibp(k2,1),ibp(k2,2),x(k2),y(k2)

                        ipe = -1
                        do 1000 iel =1,nelem
                           do 1001 jel=1,3
                              if(iae(iel,jel) .lt. 0 .and.
     *                             lnd(iel,jel) .eq. ibp(k2,1))goto 1002
 1001                      continue
 1000                   continue
 1002                   continue
                        je1 = mod(jel,3)+1
                        je2 = mod(je1,3)+1
                        ke1 = lnd(iel,jel)
                        ke2 = lnd(iel,je1)
                        ke3 = lnd(iel,je2)
                        if(abs(x(k2) + xperreal - x(ke1) ) .lt. 
     *                       1E-05 .and.
     *                       abs(y(k2)+yperreal-y(ke1) ) .lt. 
     *                       1E-05 ) then
                           imov = 1
                        elseif(abs(x(k2)-xperreal-x(ke1)) .lt. 
     *                          1E-05 .and.
     *                          abs(y(k2)-yperreal-y(ke1)).lt. 
     *                          1E-05 ) then
                           imov = -1
                        else
                           print *,'BAD in remove in periodical points'
                           print *,xper,yper,xper2,yper2
                           print *,i,k2,ke1,ibp(k2,1),ibp(k2,2)
                           print *,x(k2),y(k2),xperreal
                           print *,x(ke1),y(ke1),yperreal
                           print *,abs(x(k2) + xperreal - x(ke1) ),
     *                          abs(y(k2) + yperreal - y(ke1) ),
     *                          abs(x(k2) - xperreal - x(ke1) ),
     *                          abs(y(k2) - yperreal - y(ke1) )
                           stop
                        endif
                        xe0 = x0 + imov*xperreal
                        ye0 = y0 + imov*yperreal
                        we0 = w0
                        

c     test the violation of positivity
                        ilen1 = abs(icyc(ke1,1)) - 1
                        do 811 ic = 2,ilen1 
                           ic1 = ic + 1
                           x1 = x(icyc(ke1,ic+1))
                           y1 = y(icyc(ke1,ic+1))
                           x2 = x(icyc(ke1,ic1+1))
                           y2 = y(icyc(ke1,ic1+1))
                           reps = pos*( (xe0-x1)**2+(ye0-y1)**2 +
     *                          (x1-x2)**2+(y1-y2)**2 +
     *                          (xe0-x2)**2 + (ye0-y2)**2 )
                           det = x1*(y2-ye0) + xe0*(y1-y2) + x2*(ye0-y1)
                           if( det .le. reps) then
                              goto 28
                           endif
                           call POS1TEST(xe0,ye0,x1,y1,x2,y2,itet)
                           if(itet .eq. 1) then
                              goto 28
                           endif
 811                    continue

                        ilen2 = abs(icyc(ke2,1)) - 1
                        do 812 ic = 1,ilen2-1
                           ic1 = ic + 1
                           x1 = x(icyc(ke2,ic+1))
                           y1 = y(icyc(ke2,ic+1))
                           x2 = x(icyc(ke2,ic1+1))
                           y2 = y(icyc(ke2,ic1+1))
                           reps = pos*( (xe0-x1)**2+(ye0-y1)**2 +
     *                          (x1-x2)**2+(y1-y2)**2 +
     *                          (xe0-x2)**2 + (ye0-y2)**2 )
                           det = x1*(y2-ye0) + xe0*(y1-y2) + x2*(ye0-y1)
                           if( det .le. reps) then
                              goto 28
                           endif
                           call POS1TEST(xe0,ye0,x1,y1,x2,y2,itet)
                           if(itet .eq. 1) then
                              goto 28
                           endif
 812                    continue
                     endif
 993                 continue

                     ia1 = iae(i,j2)
                     if(ia1 .gt. 0) then
                        do 611 il =1,3
                           if(iae(ia1,il) .eq. i) ja1 = il
 611                    continue
                     endif
                     ia2 = iae(i,j1)
                     if(ia2 .gt. 0) then
                        do 612 il =1,3
                           if(iae(ia2,il) .eq. i) ja2 = il
 612                    continue
                     endif
                     if(ia1 .lt. 0 .or. ia2 .lt. 0 ) then
c                        print *,'PRoblem in remove'
c                        print *,icha
                        goto 28
                     endif

                     iae(ia1,ja1) = ia2
                     
                     ja21 = mod(ja2,3) + 1
                     lnd(ia2,ja21) = k1
                     iae(ia2,ja2) = ia1

c     begin of shifting 2
                     ibb(k1,1) = ibbk1
                     ibb(k1,2) = ibbk11
                     ibb(k1,3) = ibbk111

                     if(ipe .eq. 0 .or. ipe .eq. -1) then
                        x(k1) = x0
                        y(k1) = y0
                        wp(k1,1) = w0
                     elseif(ipe .eq. 1) then
                        x(k1) = xe0
                        y(k1) = ye0
                        wp(k1,1) = we0
                     else
                        print *,'bad number ipe=',ipe
                        stop
                     endif

                     rga(k1) = rgai
                     rgb(k1) = rgbi
                     rgc(k1) = rgci


                     if(ibp(k2,1) .gt. 0 .and. ibp(k1,1) .le. 0) then
c     in fact we remove k1 and k2 stay with new index k1
                        if(ikr1 .eq.1 .or. ikr2 .eq. 0) then
                           print *,'MISHMATCH in REMOVE'
                           print *,ikr1,ikr2
                           stop
                        endif
                        ibp(k1,1) = ibp(k2,1)
                        ibp(k1,2) = ibp(k2,2)
                     endif
                     ibp(k2,1) = ibp(npoin,1)
                     ibp(k2,2) = ibp(npoin,2)
                     do 6645 ip=1,npoin
                        if(ibp(ip,1) .eq. k2 .and.k1 .ne. npoin)then 
                           ibp(ip,1) = k1
                        endif
                        if(ibp(ip,1) .eq. npoin .and.k2 .ne. npoin) 
     *                       ibp(ip,1) = k2
 6645                continue


                     x(k2) = x(npoin)
                     y(k2) = y(npoin)
                     ibb(k2,1) = ibb(npoin,1)
                     ibb(k2,2) = ibb(npoin,2)
                     ibb(k2,3) = ibb(npoin,3)
                     wp(k2,1) = wp(npoin,1)
                     rga(k2) = rga(npoin)
                     rgb(k2) = rgb(npoin)
                     rgc(k2) = rgc(npoin)

                     do 620 ie =1,nelem
                        do 630 kj =1,3
                           if(lnd(ie,kj) .eq. k2 .and. k1 .ne. npoin)
     *                          lnd(ie,kj) = k1
                           if(lnd(ie,kj) .eq. npoin .and. k2 .ne.npoin)
     *                          lnd(ie,kj) = k2
                           if(iae(ie,kj) .eq. nelem .and. i .ne. nelem)
     *                          iae(ie,kj)=i
 630                    continue
 620                 continue
                     do kj=1,3
                        lnd(i,kj) = lnd(nelem,kj)
                        iae(i,kj) = iae(nelem,kj)
                     enddo


c     connection of two cykles 2
                     locyc(1) = icyc(k2,1) + 1
                     ill = abs(locyc(1))
                     if(abs(locyc(1)) .gt. maxdeg) then
                        print *,'2 - ERROR too long icyc'
                        stop
                     endif
                     do 705 ic=1,ill
                        locyc(ic+1) = icyc(k2,ic+1)
 705                 continue
                     do 715 ic=1,abs(icyc(k1,1)) - 2
                        locyc(ill+ic+1) = icyc(k1,ic+3)
 715                 continue
                     locyc(1) = locyc(1) - (abs(icyc(k1,1)) - 2)

                     if(abs(locyc(1)) .gt. maxdeg) then
                        print *,'3 - ERROR too long icyc'
                        stop
                     endif
                     do 723 ic=1,abs(locyc(1)) + 1
                        icyc(k1,ic) = locyc(ic)
 723                 continue

                     itestit = 0
                     k3len = abs(icyc(k3,1))

                     if(icyc(k3,k3len+1) .eq. k2) then
                        icyc(k3,1) = icyc(k3,1) - 1
                        itestit = 1
                        goto 729
                     endif

                     do 725 ic=1,k3len - 1
                        if(icyc(k3,ic+1) .eq. k2) then
                           do 727 ic1=ic,k3len - 1
                              icyc(k3,ic1+1) = icyc(k3,ic1+2)
 727                       continue
                           if(icyc(k3,1) .gt. 0) then
                              icyc(k3,1) = icyc(k3,1) - 1
                           else
                              icyc(k3,1) = icyc(k3,1) + 1
                           endif
                           itestit = 1
                           goto 729
                        endif
 725                 continue
 729                 continue

                     if(itestit .eq. 0) then
                        print *,'ERROR k1 does not found in icyc of k3'
                        print *,icha,k1,k2,k3
                        print *,x(k1),y(k1)
                        print *,x(k2),y(k2)
                        print *,x(k3),y(k3)
                        it = k3
                        write(*,'(10i5)') it,icyc(it,1),icyc(it,2),
     *                       icyc(it,3),icyc(it,4),icyc(it,5),
     *                       icyc(it,6),icyc(it,7),
     *                       icyc(it,8),icyc(it,9)

                        stop
                     endif
c     end of connection of two cykles 2

                     do 735 ie = 1,npoin
                        do 737 ic=1,abs(icyc(ie,1))
                           if(icyc(ie,ic+1) .eq. k2) icyc(ie,ic+1) = k1
                           if(icyc(ie,ic+1) .eq. npoin) 
     *                          icyc(ie,ic+1) = k2
 737                    continue
 735                 continue

                     do  ic=1,abs(icyc(npoin,1)) + 1
                        icyc(k2,ic) = icyc(npoin,ic)
                     enddo

                     if(k1 .ne. npoin) then
                        lbn(kb2,1) = k1
                     else
                        lbn(kb2,1) = k2
                        lbn(kb0,2) = k2
                     endif
                     do 810 ib=1,nbelm
                        do 815 jb=1,2
                           if(lbn(ib,jb) .eq. npoin .and. k2.ne.npoin)
     *                          lbn(ib,jb) = k2
 815                    continue
                        if(itc(ib) .eq. nelem) itc(ib) = i
 810                 continue
                     do 820 ib=kb1,nbelm-1
                        lbn(ib,1) = lbn(ib+1,1)
                        lbn(ib,2) = lbn(ib+1,2)
                        ibc(ib) = ibc(ib+1)
                        itc(ib) = itc(ib+1)
 820                 continue

c     end of shifting 2
                     npoin = npoin - 1
                     nelem = nelem - 1
                     nbelm = nbelm - 1

                     if( ipe .eq. -1) then
                        if(ke1 .eq. npoin+1) ke1 = k2
                        if(ke2 .eq. npoin+1) ke2 = k2 
                        do 1110 iel =1,nelem
                           do 1111 jel=1,3
                              if(iae(iel,jel) .lt. 0 .and.
     *                             lnd(iel,jel) .eq. ke1)goto 1112
 1111                      continue
 1110                   continue
 1112                   continue
                        i = iel
                        j = jel
                        ipe = 1
                        goto 999
                     endif 
                     if(ipe .eq. 1) then
                        ipe = 0
                        i = ipoc
                     endif
                     icha = icha + 1

                     do i=1,npoin
                        if(ibb(i,1) .gt. 0) then
                           do j=i+1,npoin
                              if(ibb(i,1) .eq. ibb(j,1)) then
                                 print *,'the same IBB,  icha =',icha
                                 print *,xb(ibb(i,1)),yb(ibb(i,1)),i,
     *                                ibb(i,1)
                                 print *,xb(ibb(j,1)),yb(ibb(j,1)),j,
     *                                ibb(j,1)
                              endif
                           enddo
                        endif
                     enddo

                  endif
               endif
               

               if( i .gt. nelem) goto 2000
 28         continue
            ipoc = ipoc + 1
         endif
 20   continue
 2000 continue


      return
      end
