      subroutine METRIX(ndim,melem,nelem,mpoin,npoin,maxdeg,
     *     x,y,lnd,iae,w,wp,supp,icyc,ra,surface,ibp,ifv,
     *     ipoint,nbp,ibb,ibpoin,xb,yb,tria)
      dimension lnd(melem,3),iae(melem,3),x(mpoin),y(mpoin),
     *     ra(melem*3),wp(mpoin,ndim+1),supp(mpoin),w(melem,ndim),
     *     icyc(mpoin,maxdeg),ibp(mpoin,2),ibpoin(0:nbp),
     *     ibb(mpoin,3),xb(ipoint),yb(ipoint),tria(melem)

      real*8 x0,y0,z0,x1,y1,z1,x2,y2,z2,deta,detb,detc,det0

      common /const/ pp, epsilon1, pos, pos1, numel,ityp
      common /period/ xper,yper,iper1,iper2
      common /period2/ xper2,yper2,iper3,iper4

      rkappa = 1.4

      surface = 0.
      do 2 i=1,nelem
         x1 = x(lnd(i,1))
         y1 = y(lnd(i,1))
         x2 = x(lnd(i,2))
         y2 = y(lnd(i,2))
         x3 = x(lnd(i,3))
         y3 = y(lnd(i,3))
         rmeas = (x1*(y2-y3) + x2*(y3-y1) + x3*(y1-y2) )/2
         tria(i) = rmeas
         surface = surface + rmeas
 2    continue


      if(ifv .eq. 0) then
         do i = 1,npoin
            do k = 1,ndim
               wp(i,k+1) = w(i,k)
            enddo
         enddo
      else
c     recomputation on the nodes and smoothing(for ismoothing > 1)
         if(ifv .eq. 2) then
            ismoothing = 1
         else
            ismoothing = 2
         endif

         do 12 is=1,ismoothing
            do 10 i=1,npoin
               supp(i) = 0.
               do 15 j=1,ndim+1
                  wp(i,j) = 0.
 15            continue
 10         continue
            do 20 i=1,nelem
               xc = (x(lnd(i,1))+x(lnd(i,2))+x(lnd(i,3)))/3
               yc = (y(lnd(i,1))+y(lnd(i,2))+y(lnd(i,3)))/3
               do 30 j=1,3
                  rl = ((xc-x(lnd(i,j)))**2 + (yc-y(lnd(i,j)))**2)**0.5
                  do 40 k=1,ndim
                     wp(lnd(i,j),k+1) = wp(lnd(i,j),k+1)+w(i,k)*tria(i)
 40               continue
                  supp(lnd(i,j)) = supp(lnd(i,j)) + tria(i)
 30            continue
 20         continue
            do 45 i=1,npoin
               do 60 k=2,ndim+1
                  wp(i,k) = wp(i,k)/supp(i)
 60            continue
 45         continue

            do 48 i=1,nelem
               do 49 k=1,ndim
                  w(i,k) = (wp(lnd(i,1),k+1) + wp(lnd(i,2),k+1) + 
     *                 wp(lnd(i,3),k+1) )/3
 49            continue
 48         continue
 12      continue
      endif


c     HERE IS POSSIBLE TO CHANGE THE USED QUNATITY FOR HESSIAN METRIXES
      do 50 i=1,npoin
         if(ityp .eq. 0 ) then
c     the uniform triangulation
            wp(i,1) = 1.0
         else
            wp(i,1) = wp(i,ityp+1)
         endif
 50   continue

c     periodic problems
      do 63 i=1,npoin
         do 64 k=1,ndim+1
            if(ibp(i,1) .gt. 0) then
               wp(i,k) = (wp(i,k) + wp(ibp(i,1),k))/2
               wp(ibp(i,1),k) = wp(i,k)
            endif
 64      continue
 63   continue

c     now only a local array
      do 65 i=1,npoin
         ra(i) = 0.
         supp(i) = 0.
 65   continue


      return
      end

      subroutine ERROR(ndim,melem,nelem,mpoin,npoin,
     *     maxdeg,dx,dy,area,
     *     tria,noit,f1,f2,
     *     x,y,lnd,iae,w,wp,icyc,ra,
     *     rga,rgb,rgc,surface, ibp)

      dimension lnd(melem,3),iae(melem,3),x(mpoin),y(mpoin),
     *     ra(melem*3),wp(mpoin,5),dx(melem),dy(melem),
     *     icyc(mpoin,maxdeg),rga(mpoin),rgb(mpoin),rgc(mpoin),
     *     area(mpoin),tria(melem),
     *     ibp(mpoin,1),w(melem,ndim)

      dimension  f1(melem,4),f2(melem,4),
     *     nasobx(3),nasoby(3),sum(3),rmaxi(4),
     *     aa(ndim,3),er(3),rlong(3)

c      real*8  x1,y1,x2,y2,x3,y3,d1,d2,d3,e1,e2,e3
      real*8 a,b,c,disc,rlam1,rlam2,xm11,xm12,xm21,xm22,
     *     ym12,ym11,ym21,ym22,
     *     t11,t12,t21,t22,z11,z12,z21,z22,rdet

      common /const/ p, epsilon1, pos, pos1, numel,ityp
      common /period/ xper,yper,iper1,iper2
      common /period2/ xper2,yper2,iper3,iper4

      rkappa = 1.4

      ielk = -3638

      ihel = 231
      open (ihel,file='hel',status='unknown')
      
      do 5 k=1,nelem
         pom=(rkappa-1)*(w(k,4)-0.5/w(k,1)*(w(k,2)*w(k,2)+
     *        w(k,3)*w(k,3)))
         pom1=(rkappa-1)*0.5*(w(k,2)*w(k,2)+w(k,3)*w(k,3))/w(k,1)
         f1(k,1)=w(k,2)
         f1(k,2)=w(k,2)*w(k,2)/w(k,1)+pom
         f1(k,3)=w(k,2)*w(k,3)/w(k,1)
         f1(k,4)=w(k,2)/w(k,1)*(rkappa*w(k,4)-pom1)
       
         f2(k,1)=w(k,3)
         f2(k,2)=f1(k,3)
         f2(k,3)=w(k,3)*w(k,3)/w(k,1)+pom
         f2(k,4)=w(k,3)/w(k,1)*(rkappa*w(k,4)-pom1)
 5    continue

      rmin = 10.
      rmax = 0.

c     the area of ideal triangle
      rnorm = 1.29903810567 *numel/surface


c vypocet souradnic vrcholu trojuhelnika a stedu jeho hran
      do 10 k=1,nelem
         x1=x(lnd(k,1)) 
         y1=y(lnd(k,1)) 
         x2=x(lnd(k,2)) 
         y2=y(lnd(k,2)) 
         x3=x(lnd(k,3)) 
         y3=y(lnd(k,3)) 
         rlong(1) = ((x2-x1)*(x2-x1) + (y2-y1)*(y2-y1) )**0.5
         rlong(2) = ((x2-x3)*(x2-x3) + (y2-y3)*(y2-y3) )**0.5
         rlong(3) = ((x3-x1)*(x3-x1) + (y3-y1)*(y3-y1) )**0.5

  
         x12=0.5*(x1+x2) 
         y12=0.5*(y1+y2) 
         x23=0.5*(x3+x2) 
         y23=0.5*(y3+y2) 
         x13=0.5*(x1+x3) 
         y13=0.5*(y1+y3) 
  
c poradova cisla sousedu
         l1=iae(k,1)
         l2=iae(k,2)
         l3=iae(k,3)

c      ...    turbine cascade
c  vypocet teziste trojuhelnika a zjisteni,zda neni na 
c periodicke hranici (je-li, pak nasob=1 nebo -1 )
         rperiod = 0.05511679
c       ***
         xik = 1./3*( x1 + x2 + x3 )  
         yik = 1./3*( y1 + y2 + y3 )  

         do 15 j=1,3
            nasobx(j)=0
            nasoby(j)=0
            kj = iae(k,j)
            if(kj.gt.0)then         
               xckj = 1./3*( x(lnd(kj,1)) + x(lnd(kj,2)) 
     *              + x(lnd(kj,3)) ) 
               yckj = 1./3*( y(lnd(kj,1)) + y(lnd(kj,2)) 
     *              + y(lnd(kj,3)) )

               if((yckj-yik) .gt. yper/4)nasoby(j)=-1           
               if((yik-yckj) .gt. yper/4)nasoby(j)=1 
               if((xckj-xik) .gt. xper/4)nasobx(j)=-1           
               if((xik-xckj) .gt. xper/4)nasobx(j)=1 
            endif
 15      continue

c         print *, 'za vypoctem tezist  '     
c postupne u kazdeho souseda vytvoreni sestiuhelniku a ten se pak 
c posle do sixtriang, kde se vypocte norma fi

         if(l1.gt.0)then 
            do 2 j=1,3
               if(iae(l1,j).eq.k) lj=j-1
 2          continue
            if(lj .eq. 0) lj=3        
            xx12=0.5*(x1+x(lnd(l1,lj))+nasobx(1)*xper)
            yy12=0.5*(y1+y(lnd(l1,lj))+nasoby(1)*yper)
            xxx12=0.5*(x2+x(lnd(l1,lj))+nasobx(1)*xper)
            yyy12=0.5*(y2+y(lnd(l1,lj))+nasoby(1)*yper)

            call SIXTRIANG(x12,y12,x1,y1,xx12,yy12,xxx12,yyy12,x2,y2,  
     *           x23,y23,x13,y13,sum1) 
         else
            sum1=1.
         endif 
         
         if(l2.gt.0)then 
            do 3 j=1,3
               if(iae(l2,j).eq.k) lj=j-1
 3          continue
            if(lj .eq. 0) lj=3        
            xx23=0.5*(x2+x(lnd(l2,lj))+nasobx(2)*xper)
            yy23=0.5*(y2+y(lnd(l2,lj))+nasoby(2)*yper)
            xxx23=0.5*(x3+x(lnd(l2,lj))+nasobx(2)*xper)
            yyy23=0.5*(y3+y(lnd(l2,lj))+nasoby(2)*yper)

            call SIXTRIANG(x23,y23,x12,y12,x2,y2,xx23,yy23,xxx23,
     *           yyy23,x3,y3,x13,y13,sum2) 
         else
            sum2=1.
         endif
         
         if(l3.gt.0)then 
            do 4 j=1,3
               if(iae(l3,j).eq.k) lj=j-1
 4          continue
            if(lj .eq. 0) lj=3        
            xx13=0.5*(x3+x(lnd(l3,lj))+nasobx(3)*xper)
            yy13=0.5*(y3+y(lnd(l3,lj))+nasoby(3)*yper)
            xxx13=0.5*(x1+x(lnd(l3,lj))+nasoby(3)*xper)
            yyy13=0.5*(y1+y(lnd(l3,lj))+nasoby(3)*yper)

            call SIXTRIANG(x13,y13,x1,y1,x12,y12,x23,y23,x3,y3,  
     *           xx13,yy13,xxx13,yyy13,sum3) 
         else
            sum3=1.
         endif

c         open(42,status='unknown' , file='zkousky')
c         if(sum1.gt.0) write(42,'(i5,3e16.5)') k,sum1,sum2,sum3

         sum(1)=sqrt(sum1)
         sum(2)=sqrt(sum2)
         sum(3)=sqrt(sum3)

c vypocet forem a , jejich abs hodnota a vydeleni normou fi pro tri
c sestiuheniky vztahujici se k trojuhelniku k 
         do 20 l=1,4
            do 30 j=1,3
               if(iae(k,j).gt.0)then
                  j1 = mod(j,3) + 1
                  rnu1kj = y(lnd(k,j1)) - y(lnd(k,j))
                  rnu2kj = x(lnd(k,j)) - x(lnd(k,j1))
                  kj=iae(k,j)
                  aa(l,j)=0.5*(rnu1kj*(f1(k,l)-f1(kj,l))+
     *                 rnu2kj*(f2(k,l)-f2(kj,l)))
                  aa(l,j)=abs(aa(l,j))
                  aa(l,j)=aa(l,j)/sum(j)
               else
                  aa(l,j)=0.
               endif 
               if(k .eq. ielk) then
                  write(*,'(4i5)') k,l,j,iae(k,j)
                  write(*,'(4e12.4)') 
     *                 aa(l,j),sum(j),0.5*(rnu1kj*(f1(k,l)-f1(kj,l))),
     *                 0.5*(rnu2kj*(f2(k,l)-f2(kj,l))),
     *                 0.5*(rnu1kj*(f1(k,l)-f1(kj,l))+
     *                 rnu2kj*(f2(k,l)-f2(kj,l)))
                  print *,'_________________' 
               endif
 30         continue

            do 35 j=1,3
               if( aa(l,j) .eq. 0) then
                  aa(l,j) = (aa(l,1) + aa(l,2) + aa(l,3))/2
               endif
               rmin = min (rmin,aa(1,j))
               rmax = max (rmax,aa(1,j))
 35         continue
c            if( l.eq. 1) 
c     *           write(*,'(2i5,3e12.4)') k,j,aa(1,1),aa(1,2),aa(1,3)


c            maximum ze tri vyrazu prave vypocteni coz je eta(l)
c            if( aa(l,1) .gt. aa(l,2))then
c               rmaxi(l)=aa(l,1)
c            else
c               rmaxi(l)=aa(l,2)
c            endif
c            
c            if(aa(l,3) .gt. rmaxi(l)) rmaxi(l)= aa(l,3)
 20      continue   

c         eh1 = (aa(1,1)**2+aa(2,1)**2+aa(3,1)**2+aa(4,1)**2)**0.5
c         eh2 = (aa(1,2)**2+aa(2,2)**2+aa(3,2)**2+aa(4,2)**2)**0.5
c         eh3 = (aa(1,3)**2+aa(2,3)**2+aa(3,3)**2+aa(4,3)**2)**0.5

         eh1 = aa(1,1)
         eh2 = aa(1,2)
         eh3 = aa(1,3)

c         if(max(eh1,eh2,eh3) .gt. 0.002) then
         if(k .eq. ielk) then
            write(ihel,'(2e14.6)') x1,y1
            write(ihel,'(2e14.6)') x2,y2
            write(ihel,'(2e14.6)') x3,y3
            write(ihel,'(2e14.6)') x1,y1
            write(ihel,'(x)')
         endif

         do 50 j=1,3
c            er(j) = + 1.E+03*
c     *           (aa(1,j)**2+aa(2,j)**2+aa(3,j)**2+aa(4,j)**2)**0.5
            er(j) = + 1.E+03 * aa(1,j)
 50      continue

         e1 = er(1)
         e2 = er(2)
         e3 = er(3)


         d1 = (y2*e1*y1-e1*y3*y1-e1*y2*y3+e1*y3**2+y1**2*e2-e2*y3*y1-
     *        y1*e2*y2+e2*y2*y3-y2*y1*e3+e3*y3*y1+e3*y2**2-e3*y2*y3)/
     *        (y2**2*x1**2-2*y2*y3*x1**2+y3**2*x1**2-2*y2**2*x1*x3+
     *        2*y1*y2*x1*x3-2*x2*y2*y1*x1+2*x1*x2*y2*y3+2*y2*y3*x1*x3-
     *        2*x1*x2*y3**2+2*x1*x2*y3*y1-2*x1*y1*x3*y3+y2**2*x3**2+
     *        2*y1*y2*x2*x3-2*x2*y2*y3*x3-2*y1*y2*x3**2-2*x2**2*y3*y1-
     *        2*x2*x3*y1**2+x3**2*y1**2+x2**2*y1**2+x2**2*y3**2+
     *        2*x2*x3*y3*y1)

         d2 = -(e1*x1*y2-e1*x1*y3-e1*x3*y2+2*e1*x3*y3+e1*x2*y1-e1*y1*x3
     *        -e1*x2*y3-e2*x1*y2+2*e2*x1*y1-e2*x1*y3+e2*x3*y2-e2*x2*y1+
     *        e2*x2*y3-e2*y1*x3-e3*x1*y2+e3*x1*y3+2*e3*x2*y2-e3*x3*y2-
     *        e3*x2*y1-e3*x2*y3+e3*y1*x3)/
     *        (y2**2*x1**2-2*y2*y3*x1**2+y3**2*x1**2-2*y2**2*x1*x3+
     *        2*y1*y2*x1*x3-2*x2*y2*y1*x1+2*x1*x2*y2*y3+2*y2*y3*x1*x3-
     *        2*x1*x2*y3**2+2*x1*x2*y3*y1-2*x1*y1*x3*y3+y2**2*x3**2+
     *        2*y1*y2*x2*x3-2*x2*y2*y3*x3-2*y1*y2*x3**2-2*x2**2*y3*y1-
     *        2*x2*x3*y1**2+x3**2*y1**2+x2**2*y1**2+
     *        x2**2*y3**2+2*x2*x3*y3*y1)/2

         d3 = (e1*x2*x1-e1*x1*x3-e1*x2*x3+e1*x3**2+e2*x1**2-e2*x1*x2-
     *        e2*x1*x3+e2*x2*x3-x1*x2*e3+e3*x1*x3+e3*x2**2-e3*x2*x3)/
     *        (y2**2*x1**2-2*y2*y3*x1**2+y3**2*x1**2-2*y2**2*x1*x3+
     *        2*y1*y2*x1*x3-2*x2*y2*y1*x1+2*x1*x2*y2*y3+2*y2*y3*x1*x3-
     *        2*x1*x2*y3**2+2*x1*x2*y3*y1-2*x1*y1*x3*y3+y2**2*x3**2+
     *        2*y1*y2*x2*x3-2*x2*y2*y3*x3-2*y1*y2*x3**2-2*x2**2*y3*y1-
     *        2*x2*x3*y1**2+x3**2*y1**2+x2**2*y1**2+x2**2*y3**2+
     *        2*x2*x3*y3*y1)

c      print *,k,d1,d2,d3,d1*d3 - d2*d2

c         if(max(eh1,eh2,eh3) .gt. 0.003) then
c            print *,'BAD metric in ERROR'
         if(k. eq. ielk) then
            write(*,'(2i5,4e12.4)') k,j,d1,d2,d3,d1*d3-d2*d2
            print *,x1,y1,rlong(1)
            print *,x2,y2,rlong(2)
            print *,x3,y3,rlong(3)
            print *,eh1,eh2,eh3
            print *,e1,e2,e3
            print *,d1,d2,d3
            print *,d1*(x2-x1)**2+ 2*d2*(x2-x1)*(y2-y1)+ d3*(y2-y1)**2
            print *,d1*(x2-x3)**2+ 2*d2*(x2-x3)*(y2-y3)+ d3*(y2-y3)**2
            print *,d1*(x3-x1)**2+ 2*d2*(x3-x1)*(y3-y1)+ d3*(y3-y1)**2
            stop
         endif

         ra(k) = d1
         ra(k+melem) = d2
         ra(k+2*melem) = d3


c     etae(l) tvori vektor, z nich pak norma je etae(k) 
c         s=0
c         do 40 l=1,4
c            s=s+rmaxi(l)*rmaxi(l)
c 40      continue
         
c nasobim konstantou, aby se magicke cislo dalo ve file.dt4 
c zapsat 
ccc       etae(k)=1000000000*sqrt(s)
c         etae(k)=10000*sqrt(s)
 10   continue
      
      do 210 i=1,npoin
         rga(i) = 0.
         rgb(i) = 0.
         rgc(i) = 0.
         area(i) = 0.
 210  continue
      
      do 220 i=1,nelem
         xc = (x(lnd(i,1))+x(lnd(i,2))+x(lnd(i,3)))/3
         yc = (y(lnd(i,1))+y(lnd(i,2))+y(lnd(i,3)))/3
         do 230 j=1,3
            k = lnd(i,j)
            rl = ((xc-x(k))**2 + (yc-y(k))**2)**0.5
            rga(k) = rga(k) + ra(i)/rl
            rgb(k) = rgb(k) + ra(i+melem)/rl
            rgc(k) = rgc(k) + ra(i+2*melem)/rl
            area(k) = area(k) + 1./rl
 230     continue
 220  continue
         
      do 240 i=1,npoin
         rga(i) = rga(i)/area(i)
         rgb(i) = rgb(i)/area(i)
         rgc(i) = rgc(i)/area(i)
         if( i .lt. -20) then
            write(*,'(i5,4e14.6)') i,rga(i),rgb(i),rgc(i),wp(i,1)
         endif
 240  continue
      
      rkon = 750.
      do 260 i=1,npoin
         if(ibp(i,1) .gt. 0) then
            rga(i) = (rga(i) + rga(ibp(i,1)))/2
            rga(ibp(i,1)) = rga(i)
            rgb(i) = (rgb(i) + rgb(ibp(i,1)))/2
            rgb(ibp(i,1)) = rgb(i)
            rgc(i) = (rgc(i) + rgc(ibp(i,1)))/2
            rgc(ibp(i,1)) = rgc(i)
         endif
         if(abs(rga(i)) .gt. rkon .or. abs(rgc(i)) .gt. rkon) then
            write(ihel,'(2e14.6)') x(i),y(i)
         endif
            
 260  continue
      

      ipr = -1
      rmax = 0.

      do 200 i=1,npoin
c      do 200 i=1,1
         if(abs(rgb(i)) .lt. 1E-05) then
c     the diagonal metrix
            rgb(i) = 0.
            rga(i) = (1. + epsilon1*abs(rga(i)))*rnorm
            rgc(i) = (1. + epsilon1*abs(rgc(i)))*rnorm
         else
c     the eigenvalues rlam1 , rlam2
            a = rga(i)
            b = rgb(i)
            c = rgc(i)

            disc = ((a - c)*(a - c) + 4*b*b)**0.5
            rlam1 = (a + c + disc)/2
            rlam2 = (a + c - disc)/2
            if(abs(rlam1) .lt. abs(rlam2) ) then
               rlampom = rlam1
               rlam1 = rlam2
               rlam2 = rlampom
            endif

            xm11 = b
            xm21 = -(a-rlam1)
            rl1 = (xm11*xm11+xm21*xm21)**0.5
            xm11 = xm11/rl1
            xm21 = xm21/rl1

            xm12 = b
            xm22 = -(a-rlam2)
            rl2 = (xm12*xm12+xm22*xm22)**0.5
            xm12 = xm12/rl2
            xm22 = xm22/rl2

            rdet = xm11*xm22 - xm21*xm12

c     inverse matrix
            ym11 = xm22/rdet
            ym12 = -xm12/rdet
            ym21 = -xm21/rdet
            ym22 = xm11/rdet

            z11 = abs(rlam1)*ym11
            z12 = abs(rlam1)*ym12
            z21 = abs(rlam2)*ym21
            z22 = abs(rlam2)*ym22
            
            t11 = xm11*z11 + xm12*z21
            t12 = xm11*z12 + xm12*z22
            t21 = xm21*z11 + xm22*z21
            t22 = xm21*z12 + xm22*z22

            if(i .eq. ipr) then
               print *,'***********************',i,'    *************'
               print *,a,b,c,rlam1,rlam2
               print *,a-rlam1,b
               print *,b,c-rlam1
               print *,'            '
               print *,'----------------------'
               write(*,'(6e12.4)')
     *              xm11,xm12,rlam1,0,ym11,ym12
               write(*,'(6e12.4)')
     *              xm21,xm22,0,rlam2,ym21,ym22
               print *,'----------------------'
               write(*,'(4e12.4)')
     *              z11,z12,t11,t12
               write(*,'(4e12.4)')
     *              z21,z22,t21,t22
               print *,'----------------------'
            endif

            if(t11 .gt. rmax .or. t22 .gt. rmax) then
               rmax = max(t11,t22)
               imax = i
            endif

c            rkon = 500.
c            if(abs(t11) .gt. rkon .or. abs(t22) .gt. rkon) then
c               write(ihel,'(2e14.6)') x(i),y(i)
c            endif

c     Gamm channel
c            eps1 = 7500./(7500.+max(t11,t22))

c     profile
c            eps1 = 250./(10000.+max(t11,t22))

            eps1 = epsilon1

            rga(i) = (1. + eps1*t11)*rnorm 
            rgb(i) = (eps1*(t12+t21)/2)*rnorm
            rgc(i) = (1. + eps1*t22)*rnorm

            if(rga(i)*rgc(i) .le. rgb(i)*rgb(i) ) then
               print *,'ERROR in metric, nonpositive matrix'
               write(*,'(i5,3e14.6)') i,rga(i),rgb(i),rgc(i)
               print *,a,b,c
               print *,'----------------------'
               write(*,'(6e12.4)')
     *              xm11,xm12,rlam1,0,ym11,ym12
               write(*,'(6e12.4)')
     *              xm21,xm22,0,rlam2,ym21,ym22
               print *,'----------------------'
               write(*,'(4e12.4)')
     *              z11,z12,t11,t12
               write(*,'(4e12.4)')
     *              z21,z22,t21,t22
               print *,'----------------------'
               stop
            endif

         endif

c     for NACA we improve
         rimp = 1.

c         rrrl = ( x(i)*x(i) + y(i)*y(i))**0.5 + 
c     *        ( (x(i)-1.)*(x(i)-1.) + y(i)*y(i))**0.5 
c         if(rrrl .lt. 1.) then
c            print *,'??',x(i),y(i),rrrl
c            rrrl = 1.0
c         endif
c         rimp = ((rrrl*rrrl )/(rrrl*rrrl-0.75))*2

         rga(i) = rga(i)*rimp
         rgb(i) = rgb(i)*rimp
         rgc(i) = rgc(i)*rimp

c         write(*,'(i5,7e12.4)') 
c     *        i,x(i),y(i),rrrl,rimp,rga(i),rgb(i),rgc(i)
            
c         if( i .gt. 80 .and. i .lt. 6130) then
         if( i .lt. -20) then
            write(*,'(i5,4e14.6)') i,rga(i),rgb(i),rgc(i),wp(i,1)
         endif
 200  continue

c      print *,'MAX =',imax,rmax

c     smoothing
      do 500 ic = 1,6
         do 400 i=1,nelem
            ra(i) = (rga(lnd(i,1)) + rga(lnd(i,2)) + rga(lnd(i,3)))/3
            ra(i+melem) = 
     *           (rgb(lnd(i,1)) + rgb(lnd(i,2)) + rgb(lnd(i,3)))/3
            ra(i+2*melem) = 
     *           (rgc(lnd(i,1)) + rgc(lnd(i,2)) + rgc(lnd(i,3)))/3
 400     continue
         
         do 410 i=1,npoin
            rga(i) = 0.
            rgb(i) = 0.
            rgc(i) = 0.
            area(i) = 0.
 410     continue
      
         do 420 i=1,nelem
            xc = (x(lnd(i,1))+x(lnd(i,2))+x(lnd(i,3)))/3
            yc = (y(lnd(i,1))+y(lnd(i,2))+y(lnd(i,3)))/3
            do 430 j=1,3
               k = lnd(i,j)
               rl = ((xc-x(k))**2 + (yc-y(k))**2)**0.5
               rga(k) = rga(k) + ra(i)/rl
               rgb(k) = rgb(k) + ra(i+melem)/rl
               rgc(k) = rgc(k) + ra(i+2*melem)/rl
               area(k) = area(k) + 1./rl
 430        continue
 420     continue
         
         do 440 i=1,npoin
            rga(i) = rga(i)/area(i)
            rgb(i) = rgb(i)/area(i)
            rgc(i) = rgc(i)/area(i)
            if( i .lt. -20) then
               write(*,'(i5,4e14.6)') i,rga(i),rgb(i),rgc(i),wp(i,1)
            endif
 440     continue
 500  continue
     
      do 63 i=1,npoin
         if(ibp(i,1) .gt. 0) then
            rga(i) = (rga(i) + rga(ibp(i,1)))/2
            rga(ibp(i,1)) = rga(i)
            rgb(i) = (rgb(i) + rgb(ibp(i,1)))/2
            rgb(ibp(i,1)) = rgb(i)
            rgc(i) = (rgc(i) + rgc(ibp(i,1)))/2
            rgc(ibp(i,1)) = rgc(i)
         endif
 63   continue

c      if(noit .eq. -1) then
c         imet = 44
c         open(imet, file='metric',status='unknown')
c         write(imet,*) 'The metric in each point:'
c         do 350 i=1,npoin
c            write(imet,'(i5,4e14.6)') i,rga(i),rgb(i),rgc(i),wp(i,1)
c 350     continue
c      endif

      return
      end

      subroutine SOLVE6_1(rmat,bmat,xmat)
      real*8 rmat(6,6),bmat(6),xmat(6),xmatold(6),sum,err,errold
      
      tau = 0.0005
      do i=1,6
         xmatold(i) = 0.D+00
      enddo

      errold = 100000.
      it = 1
 10   it = it + 1
         err = 0.D+00
         do i=1,6
            sum = 0.D+00
            do j=1,6
               sum = sum + rmat(i,j)*xmatold(j)
            enddo
            xmat(i) = xmatold(i) - tau*(sum - bmat(i))
            err = err + (xmat(i)-xmatold(i))**2
            xmatold(i) = xmat(i)
         enddo
c         do j=1,6
c            err = err + (xmat(j)-xmatold(j))**2
c            xmatold(j) = xmat(j)
c         enddo
         if(mod(it,5000) .eq. 1) 
     *        write(*,'(i10,7e11.3)') it,(xmat(ij), ij=1,6),err
         if(err .lt. 1E-25 .and. it .gt. 1) goto 20
         errold = err
         goto 10
 20      continue
      return
      end

      subroutine SOLVE6(rmat,bmat,xmat)
      real*8 rmat(6,6),bmat(6),xmat(6),xmatold(7),quot

      do i=1,6
         quot = rmat(i,i)
         if(quot .eq. 0. ) then
            ip = i - 1
 11         ip = ip + 1 
            if(quot .eq. 0. .and.  ip .lt. 6) then
c     reordering
               do l=1,6
                  xmatold(l) = rmat(i,l)
               enddo
               xmatold(7) = bmat(i)
               do k=i,5
                  do l=1,6
                     rmat(k,l) = rmat(k+1,l)
                  enddo
                  bmat(k) = bmat(k+1)
               enddo
               do l=1,6
                  rmat(6,l) = xmatold(l) 
               enddo
               bmat(6) = xmatold(7) 
               quot = rmat(i,i)
               goto 11
            elseif(quot .eq. 0 .and. ip .eq. 6) then
               print *,'Singular matrix'
               stop
            endif
         endif

         bmat(i) = bmat(i)/quot
         do j = i,6
            rmat(i,j) = rmat(i,j)/quot
         enddo
         do j= 1,6
            if(i .ne. j) then
               quot = rmat(j,i)
               do l =1,6
                  rmat(j,l) = rmat(j,l) - quot*rmat(i,l)
               enddo
               bmat(j) = bmat(j) - quot*bmat(i)
            endif
         enddo
c         do ii = 1,6
c            write(*,'(7f9.4)') (rmat(ii,ij), ij=1,6),bmat(ii)
c         enddo
c         print *,'----------------------------------------'
      enddo
      do j=1,6
         xmat(j) = bmat(j)
      enddo
      return
      end



      subroutine ERROR1(ndim, melem,nelem,mpoin,npoin,
     *     maxdeg,dx,dy,area,tria,noit,
     *     x,y,lnd,iae,wp,icyc,ra,rga,rgb,rgc,surface,
     *     ibp,ipoint,nbp,ibb,ibpoin,xb,yb,ifv )
      dimension lnd(melem,3),iae(melem,3),x(mpoin),y(mpoin),
     *     ra(melem*3),wp(mpoin,ndim+1),dx(melem),dy(melem),
     *     icyc(mpoin,maxdeg),rga(mpoin),rgb(mpoin),rgc(mpoin),
     *     area(mpoin),tria(melem),ibp(mpoin,2),ibb(mpoin,3),
     *     xb(ipoint),yb(ipoint),ibpoin(0:nbp)
      real*8 dxi,dyi,rmeas,x1,x2,x3,y1,y2,y3,w1,w2,w3,areai,rl
      real*8 a,b,c,disc,rlam1,rlam2,x11,x12,x21,x22,y12,y11,y21,y22,
     *     t11,t12,t21,t22,z11,z12,z21,z22,rdet,s,t
      real*8 rmat(6,6),bmat(6),xmat(6)
      real*8 sumx, sumy, sumx2, sumxy, sumy2, sumx3, sumx2y, sumxy2,
     *     sumy3, sumx4, sumx3y, sumx2y2, sumxy3, sumy4, sumu, sumux,
     *     sumuy, sumux2, sumuxy, sumuy2

      common /const/ p, epsilon1, pos, pos1, numel,ityp
      common /period/ xper,yper,iper1,iper2
      common /period2/ xper2,yper2,iper3,iper4
      common /visc/ Re, xte1,yte1,xte2,yte2

      rkappa = 1.4

c     dx the first derivative dw/dx
c     dy                      dw/dy
c     rga  the second der.    d2w/dx dx
c     rgb                     d2w/dx dy
c     rgc                     d2w/dy dy       


      do 10 i=1,nelem
         x1 = x(lnd(i,1))
         y1 = y(lnd(i,1))
         w1 = wp(lnd(i,1),1)
         x2 = x(lnd(i,2))
         y2 = y(lnd(i,2))
         w2 = wp(lnd(i,2),1)
         x3 = x(lnd(i,3))
         y3 = y(lnd(i,3))
         w3 = wp(lnd(i,3),1)
         rmeas = x1*(y2-y3) + x2*(y3-y1) + x3*(y1-y2)
         tria(i) = rmeas/2
         dx(i) = (y2-y1)*(w1+w2) + (y3-y2)*(w2+w3) + (y1-y3)*(w1+w3) 
         dy(i) = (x1-x2)*(w1+w2) + (x2-x3)*(w2+w3) + (x3-x1)*(w1+w3) 
         dx(i) = dx(i) /rmeas
         dy(i) = dy(i) /rmeas
 10   continue


      rmaxder = 0.
c     HERE INSERT deriv.f

      itest = -20

      err4 = 0.
      err5 = 0.
      err6 = 0.

      do 20 i=1,npoin
         areai = 0.
         rga(i) = 0.
         rgb(i) = 0.
         rgc(i) = 0.
         rgdi = 0.
         if(icyc(i,1) .gt. 0) then
            len = icyc(i,1) 
         else
            len = -icyc(i,1)  - 1
         endif
         x3 = x(i)
         y3 = y(i)
         w3 = wp(i,1)
         do 30 j=1,len
            j1 = mod(j, abs(icyc(i,1))) + 1
            x1 = x(icyc(i,j+1))
            y1 = y(icyc(i,j+1))
            w1 = wp(icyc(i,j+1),1)
            x2 = x(icyc(i,j1+1))
            y2 = y(icyc(i,j1+1))
            w2 = wp(icyc(i,j1+1),1)
            rmeas = x1*(y2-y3) + x2*(y3-y1) + x3*(y1-y2)
            areai = areai + rmeas/6
            dxi = (y2-y1)*(w1+w2) + (y3-y2)*(w2+w3) + (y1-y3)*(w1+w3) 
            dyi = (x1-x2)*(w1+w2) + (x2-x3)*(w2+w3) + (x3-x1)*(w1+w3) 
            dxfi = (y1-y2)/rmeas
            dyfi = (x2-x1)/rmeas

            if(i .eq. itest) write(*,'(a2,i2,3e14.6,2e12.4)')
     *           '$$',j,w1,w2,w3,dxi/rmeas,dyi/rmeas
            if(i .eq. itest) write(*,'(a2,4i5,4e12.4)')
     *           '  ',j,icyc(i,j+1),icyc(i,j1+1),i,x1,y1,x2,y2
            if(i .eq. itest) write(*,'(a2,3e14.6)') '  ',x1,y1,w1
            if(i .eq. itest) write(*,'(a2,3e14.6)') '  ',x2,y2,w2
            if(i .eq. itest) write(*,'(a2,3e14.6)') '  ',x3,y3,w3

            rga(i) = rga(i) - dxi/2*dxfi
            rgb(i) = rgb(i) - dyi/2*dxfi
            rgc(i) = rgc(i) - dyi/2*dyfi
            rgdi = rgdi - dxi/2*dyfi
            
c            if(i .eq. itest) print *,'**',j,dxi,dxfi,rga(i)

            if(icyc(i,1) .lt. 0 .and. ibp(i,1) .eq. 0 ) then
c     for the boundary points me must add the boundary sides
               if(j .eq. 1) then
                  rga(i) = rga(i) + dxi/rmeas*(y1-y3)/2
                  rgb(i) = rgb(i) + dyi/rmeas*(y1-y3)/2
                  rgc(i) = rgc(i) + dyi/rmeas*(x3-x1)/2
                  rgdi = rgdi + dxi/rmeas*(x3-x1)/2
               endif
               if( j .eq. len) then
                  rga(i) = rga(i) + dxi/rmeas*(y3-y2)/2
                  rgb(i) = rgb(i) + dyi/rmeas*(y3-y2)/2
                  rgc(i) = rgc(i) + dyi/rmeas*(x2-x3)/2
                  rgdi = rgdi + dxi/rmeas*(x2-x3)/2

               endif
            endif


c            if(i .eq. itest) print *,'**',j,dxi,dxfi,rga(i)

 30      continue
         area(i) = areai
c         if(icyc(i,1) .gt. 0) then
cc         rradius = (x(i)*x(i) + y(i)*y(i))**0.5
cc         if(rradius .gt. 0) then
cc            derxxtrue = 3./16*rradius**(-1.75)
cc            deryytrue = derxxtrue
c            
c            derxxtrue = -(1-y(i)**20)*90*x(I)**8
c            deryytrue = -(1-x(i)**10)*380*y(i)**18
c            derxytrue = 200*x(i)**9*y(i)**18
c            
c            era1 = ( ( rga(i) ) /area(i)-derxxtrue)
c            era2 = ( ( rgc(i) ) /area(i)-deryytrue)
c            era3 = ( ( rgb(i) ) /area(i)-derxytrue)
c            err4 = err4 + (era1*era1 + era2*era2 + 
c     *           2.*era3*era3)*area(i)
c            err5 = err5 + (derxxtrue**2 + derxytrue**2 +
c     *           2.*deryytrue**2)*area(i)
c            err6 = err6 + ( rga(i)**2 + 2*rgb(i)**2 +
c     *           rgc(i)**2)/area(i)
c            write(98,'(i5,7e12.4)') i,area(i),
cc     *        rga(i)/area(i),derxxtrue,
c     *        (era1*era1 + era2*era2)*area(i),
c     *           (derxxtrue**2 + deryytrue**2)*area(i),
c     *           err4,err5,err4/err5,err6
cc            endif
c         endif

 20   continue

c     for periodic boundary points
      if( xper .gt. 0 .or. yper .gt. 0) then
         do 18 i1=1,npoin
            i2 = ibp(i1,1)
            if( i2 .gt. 0 ) then
               if(rga(i1) .ne. rga(i2) .or. rgb(i1) .ne. rgb(i2) .or. 
     *              rgc(i1) .ne. rgc(i2) .or. area(i1) .ne. area(i2) )
     *              then
                  rga(i1) = rga(i1) + rga(i2)
                  rgb(i1) = rgb(i1) + rgb(i2)
                  rgc(i1) = rgc(i1) + rgc(i2)
                  area(i1) = area(i1) + area(i2)
                  rga(i2) = rga(i1) 
                  rgb(i2) = rgb(i1) 
                  rgc(i2) = rgc(i1) 
                  area(i2) = area(i1)
               endif
            endif
 18      continue
      endif

c      print *,'Total error = ',err4**0.5,err5**0.5,
c     *     err4**0.5/err5**0.5
c      print *,'Total error = ',(err4/err6)**0.5

      do 15 i=1,npoin
         rga(i) = rga(i)/area(i)
         rgb(i) = rgb(i)/area(i)
         rgc(i) = rgc(i)/area(i)
         if(i .eq. itest) print *,'..',area(i),rga(i)
c         if(abs(rga(i)) + abs(rgc(i)) .gt. 5.) 
c         if(x(i) .gt. 0.95) 
c     *        write(22,*) x(i),y(i),wp(i,1),rga(i),rgb(i),rgc(i),i
 15   continue


c     ... comparing real second derivatives with their approximation
      do i=1,npoin
         rradius = (x(i)*x(i) + y(i)*y(i))**0.5
         if(rradius .gt. 0) then
            derxxtrue = 3./16*rradius**(-1.75)
         else
            derxxtrue = 1E+25
         endif
         deryytrue = derxxtrue

c         derxxtrue = -(1-y(i)**20)*90*x(I)**8
c         deryytrue = -(1-x(i)**10)*380*y(i)**18

         era1 = (abs(rga(i))-derxxtrue)
         era2 = (abs(rgc(i))-deryytrue)
c         write(99,'(6e14.6)')
c     *        x(i),y(i),rga(i),derxxtrue,rgc(i),deryytrue
c     *        x(I),y(i),era1,era2,rga(i),rgc(i),derxxtrue
      enddo



      rmaxder = 0.
c     improvement for boundary points
      goto 101

      do 100 i=1,npoin
         if(icyc(i,1) .lt. 0 .and. ibp(i,1) .eq. 0) then
            len = abs(icyc(i,1))
            if( len .ge. 3) then
               ipoc = 0
               rga(i) = 0.
               rgb(i) = 0.
               rgc(i) = 0.
               rminlenght = 1E+38
               do 110 j=2,len-1
                  if(icyc(icyc(i,j+1),1) .gt. 0) then
c     this point isn't boundary
                     xlen = ((x(i)-x(icyc(i,j+1)))**2 +
     *                    (y(i) -y(icyc(i,j+1)))**2 )**0.5
                     if(xlen .lt. rminlenght) then
                        rga(i) = rga(icyc(i,j+1))
                        rgb(i) = rgb(icyc(i,j+1))
                        rgc(i) = rgc(icyc(i,j+1))
                        rminlenght = xlen
                     endif
                     if( i .eq. -170) then
                        print *,'**',j,icyc(i,j+1),rgc(icyc(i,j+1)),
     *                       xlen,rminlenght 
                     endif
                  endif
 110           continue
c     we use the value from the nearest point
               if(ipoc .gt. 0 ) then
                  rga(i) = rga(i)/ipoc
                  rgb(i) = rgb(i)/ipoc
                  rgc(i) = rgc(i)/ipoc
               else
c     in this case, we let the second derivations = 0 !!!!

               endif
            elseif( len .eq. 2) then
               i1 = icyc(i,2)
               i2 = icyc(i,3)
               do 120 ie =1,nelem
                  do 130 je =1,3
                     je1 = mod(je,3)+1
                     if(lnd(ie,je) .eq. i2 .and. 
     *                    lnd(ie,je1) .eq. i1) then
                        je2 = mod(je1,3) + 1
                        rga(i) = rga(lnd(ie,je2))
                        rgb(i) = rgb(lnd(ie,je2))
                        rgc(i) = rgc(lnd(ie,je2))
                        goto 140
                     endif
 130              continue
 120           continue
 140           continue
            else
               print *,'ERROR len < 2 !!!!'
            endif
         endif
         rmaxder = max(rmaxder,abs(rga(i)),abs(rgb(i)),abs(rgc(i)) )
 100  continue
 101  continue

      rnorm = 1.29903810567 *numel/surface
      rmaxderteor = epsilon1/3*rnorm
      der = rmaxderteor
      epsilon2p = epsilon1/p
c      epsilon2p = p

      epsilon2 = max (1.,epsilon2p)

      print *,'   '
      print *,'Given data:'
      print *,'Used component for adaptation:',ityp,
     *     '  (0-uniform mesh)'
      print *,'Dimension of the solution:    ',ndim
      print *,'Solution associated:          ',ifv,
     *     '  (0-cell vertex, 1-cell centered)'
      print *,'Positivity:                   ',pos
      print *,'Prescribed number of elements:',numel
      print *,'epsilon1:                     ',epsilon1
      print *,'p:                            ',p

      ipr = -1
c     we compute the elements of matrix M from the second derivations 

      rmax1 = 0.
      rmax2 = 0.
      rmax3 = 0.
      rmaxlambdas = 0.
      imaxl = 1

c      itest = 50

c      xmin1 = -0.15
c      xmax1 = 0.05
c      ymax1 = 0.01
c      rmaa = 0.
c      rmac = 0.
c      rmac = 0.
c      do i=1,npoin
c         if(x(i) .gt. xmin1 .and. x(i).lt. xmax1 .and.
c     *        y(i) .lt. ymax1) then
c            rmaa = max(rmaa, rga(i) )
c            rmab = max(rmaa, rgb(i) )
c            rmac = max(rmaa, rgc(i) )
c            write(49,*) x(i),y(i),rmaa,rmab,rmac
c         endif
c      enddo
c      do i=1,npoin
c         if(x(i) .gt. xmin1 .and. x(i).lt. xmax1 .and.
c     *        y(i) .lt. ymax1) then
c            rga(i) = 2*rmaa
c            rgb(i) = 0.
c            rgc(i) = 2*rmac
c         endif
c      enddo
c      close(49)


      do 200 i=1,npoin

         if(rga(i) .gt. rmax1) then
            rmax1 = rga(i)
            imax1 = i
         endif
         if(rgb(i) .gt. rmax2) then
            rmax2 = rgb(i)
            imax2 = i
         endif
         if(rgc(i) .gt. rmax3) then
            rmax3 = rgc(i)
            imax3 = i
         endif

         if(abs(rgb(i)) .lt. 1E-05) then
c     the diagonal matrix

            eps1 = epsilon1/(epsilon2+max(rga(i),rgc(i)))

            rgb(i) = 0.
            rga(i) = (1. + eps1*abs(rga(i)))*rnorm
            rgc(i) = (1. + eps1*abs(rgc(i)))*rnorm
            if(rga(i) + rgc(i) .gt. rmaxlambdas) 
     *           rmaxlambdas = rga(i)+rgc(i)
         else
c     the eigenvalues rlam1 , rlam2
            if(i .eq. itest) then
               print *,x(i),y(i)
               print *,'@#',rga(i),rgb(i),rgc(i)
            endif
            a = rga(i)
            b = rgb(i)
            c = rgc(i)

            disc = ((a - c)*(a - c) + 4*b*b)**0.5
            rlam1 = (a + c + disc)/2
            rlam2 = (a + c - disc)/2
            if(abs(rlam1) .lt. abs(rlam2) ) then
               rlampom = rlam1
               rlam1 = rlam2
               rlam2 = rlampom
            endif
            if(abs(rlam1) + abs(rlam2) .gt. rmaxlambdas) then
               rmaxlambdas = abs(rlam1) + abs(rlam2)
               imaxl = i
            endif
            x11 = b
            x21 = -(a-rlam1)
            rl1 = (x11*x11+x21*x21)**0.5
            x11 = x11/rl1
            x21 = x21/rl1

            x12 = b
            x22 = -(a-rlam2)
            rl2 = (x12*x12+x22*x22)**0.5
            x12 = x12/rl2
            x22 = x22/rl2

            rdet = x11*x22 - x21*x12

c     inverse matrix
            y11 = x22/rdet
            y12 = -x12/rdet
            y21 = -x21/rdet
            y22 = x11/rdet

            z11 = abs(rlam1)*y11
            z12 = abs(rlam1)*y12
            z21 = abs(rlam2)*y21
            z22 = abs(rlam2)*y22
            
            t11 = x11*z11 + x12*z21
            t12 = x11*z12 + x12*z22
            t21 = x21*z11 + x22*z21
            t22 = x21*z12 + x22*z22

            eps1 = epsilon1/(epsilon2+max(t11,t22))

            if(i .eq. itest) print *,' #',eps1,epsilon2,rnorm
            if(i .eq. itest) print *,' #',eps1*t11+1.,rnorm

            rga(i) = (1. + eps1*t11)*rnorm 
            rgb(i) = (eps1*(t12+t21)/2)*rnorm
            rgc(i) = (1. + eps1*t22)*rnorm
            if(i .eq. itest) print *,'@#',rga(i),rgb(i),rgc(i)

            if(rga(i)*rgc(i) .le. rgb(i)*rgb(i) ) then
               print *,'ERROR in metric, nonpositive matrix'
               write(*,'(i5,3e14.6)') i,rga(i),rgb(i),rgc(i)
               print *,a,b,c
               print *,'----------------------'
               write(*,'(6e12.4)')
     *              x11,x12,rlam1,0,y11,y12
               write(*,'(6e12.4)')
     *              x21,x22,0,rlam2,y21,y22
               print *,'----------------------'
               write(*,'(4e12.4)')
     *              z11,z12,t11,t12
               write(*,'(4e12.4)')
     *              z21,z22,t21,t22
               print *,'----------------------'
               stop
            endif
c            write(23,*) x(i),y(i),rga(i),rgb(i),rgc(i)

         endif
 200  continue
c      print *,'###############',rmaxlambdas,imaxl,
c     *     x(imaxl),y(imaxl)

c     CORRECTION of positivity a priori
      par = 1.0
      do i=1,npoin
         a = rga(i)
         b = rgb(i)
         c = rgc(i)
         disc = ((a - c)*(a - c) + 4*b*b)**0.5
         rlam1 = (a + c + disc)/2
         radius = 4*pos*pos*rlam1/par/par
c         rh0 = 1./(rlam1)**0.5
c         rh1 = rh0/3/pos*par
c         radius = 1/rh1/rh1
c     rgai,rgbi,rgci - cyrcle whose radius is the pos times the smallest
c     side
         rgai = radius
         rgbi = 0.
         rgci = radius
         if(i .eq. -20) then
            rgai = 4.
            rgbi = 2.
            rgci = 12.
            rga(i) = 3. 
            rgb(i) = 1.5
            rgc(i) = 9.
            print *,x(i),y(i),rlam1,radius
            print *,rga(i),rgb(i),rgc(i)
            print *,rgai,rgbi,rgci
            call ELIPS(14,rga(i),rgb(i),rgc(i),x(i),y(i) )
            call ELIPS(14,rgai,rgbi,rgci,x(i),y(i) )
          endif
          if(i .eq. itest) print *,'$$',rga(i),rgb(i),rgc(i)
          
          call INTERSECTION_METRIC(rga(i),rgb(i),rgc(i),
     *         rgai,rgbi,rgci)
          if(i .eq. itest) print *,'$2',rga(i),rgb(i),rgc(i)
c        if(i .eq. 20) then
c            call ELIPS(14,rga(i),rgb(i),rgc(i),x(i),y(i) )
c            print *,rga(i),rgb(i),rgc(i)
c            stop
c         endif
      enddo
c     end of CORRECTION of positivity a priori

c     smoothing
      do 500 ic = 1,1
         do 400 i=1,nelem
            ra(i) = (rga(lnd(i,1)) + rga(lnd(i,2)) + rga(lnd(i,3)))/3
            ra(i+melem) = 
     *           (rgb(lnd(i,1)) + rgb(lnd(i,2)) + rgb(lnd(i,3)))/3
            ra(i+2*melem) = 
     *           (rgc(lnd(i,1)) + rgc(lnd(i,2)) + rgc(lnd(i,3)))/3
 400     continue
         
         do 410 i=1,npoin
            rga(i) = 0.
            rgb(i) = 0.
            rgc(i) = 0.
            area(i) = 0.
 410     continue
      
         do 420 i=1,nelem
            xc = (x(lnd(i,1))+x(lnd(i,2))+x(lnd(i,3)))/3
            yc = (y(lnd(i,1))+y(lnd(i,2))+y(lnd(i,3)))/3
            do 430 j=1,3
               k = lnd(i,j)
c               rl = ((xc-x(k))**2 + (yc-y(k))**2)**0.5
               rga(k) = rga(k) + ra(i)*tria(i)
               rgb(k) = rgb(k) + ra(i+melem)*tria(i)
               rgc(k) = rgc(k) + ra(i+2*melem)*tria(i)
               area(k) = area(k) + tria(i)
 430        continue
 420     continue
         
         do 440 i=1,npoin
            rga(i) = rga(i)/area(i)
            rgb(i) = rgb(i)/area(i)
            rgc(i) = rgc(i)/area(i)
         if(i .eq. itest) print *,'$3',rga(i),rgb(i),rgc(i)
 440     continue
 500  continue

c @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

      if((ityp .eq. 3 .or. ityp .eq. 4 .or. ityp .eq. 5) .and.
     *     Re .gt. 0.) then


c     part of courved boundary, where is fixed walls
         ilkw = 1

c     generation the triangulation for the boundary layer for NS
         qbas = 1.25
c     charakterictic length
         xmax = -100000.
         ymax0 = -100000.
         xmin = 100000.
         ymin = 100000.
         do i=1,ipoint
            if( i .gt. ibpoin(ilkw-1) .and. 
     *           i .le. ibpoin(ilkw)) then
               xmax = max(xmax, xb(i) )
               ymax0 = max(ymax0, yb(i) )
               xmin = min(xmin, xb(i) )
               ymin = min(ymin, yb(i) )
            endif
         enddo
         rcharlen = ((xmax -xmin)**2 + (ymax0 - ymin)**2)**0.5
c     double precision
         x1 = xte1
         y1 = yte1
         x2 = xte2
         y2 = yte2
         
         Resminside = rmaxlambdas/3
         Res = min(Re, 10000*Resminside)
         if(Re .gt. Res) print*,'Re  <  10000*Resminside !!!'
         Res = Res/rcharlen

         print*,'Reynolds =',Res,'  (Resminside, Re):',Resminside,Re

c         ymax = ((3/rnorm)**0.5 - 1./sqrt(Res))/(qbas-1.)*rcharlen
         ymax1 = ((3/rnorm)**0.5 - 1./sqrt(Res))/(qbas-1.)*rcharlen
         ymax = 20./sqrt(Res)
c         ymax = 60./sqrt(Res)
         n0 = 3

         do i=1,npoin
            xi = x(i)
            yi = y(i)
            rmax = 100000.
            do k=ibpoin(ilkw-1)+1,ibpoin(ilkw)
               rlen = (xi-xb(k))**2 + (yi-yb(k))**2
               if(rlen .lt. rmax) then
                  rmax = rlen
                  imax = k
               endif
            enddo
c     distance from profile
            rmax = rmax**0.5

            x3 = xi
            y3 = yi

            sstt = (x1-x2)*(x1-x2) + (y1-y2)*(y1-y2)
            s = ( (x1-x2)*(x1-x3) + (y1-y2)*(y1-y3) )/sstt
            t = ( x1*(y3-y2) + x2*(y1-y3) + x3*(y2-y1) )/sstt
c     wake and boundary layer are investigated separetely,
c     as some points need as to BL as to Wake


c     BOUNDARY LAYERS            
            if(s .le. 0.01*rcharlen) then
c               if(rmax .gt. ymax .and. rmax .lt. 5*ymax)
c     *              write(32,*) x(i),y(i),rmax,ymax
               rwake = 2*rmax + 1.
               if( rmax .lt. ymax) then
c               if( rmax .lt. 5*ymax) then
                  cor = 1./n0
                  if(imax .gt. 1) then
                     ii1 = imax - 1
                  else
                     ii1 = ipoint - 1
                  endif
                  rn1 = -(yb(ii1) - yb(imax))
                  rn2 = xb(imax) - xb(ii1) 
c                  q = 5.*qbas
c                  q = (0.2+qbas)/1.2 -ymax/20.
c                  q = max(q, 0.)
                  rlen = (rn1*rn1 + rn2*rn2)**0.5
                  rn1 = rn1/rlen
                  rn2 = rn2/rlen

c               rh2 = cor/sqrt(Res) + rmax*(q - 1.)/rcharlen
                  rh2 = cor/sqrt(Res)+ (rcharlen/10. - cor/sqrt(Res))*
     *                 rmax/ymax
                  rh1 = rh2*(1+(1-24.*pos*pos)**0.5)/4/pos
c               write(33,*) x(i),y(i),q,rh1,rh2
                  rgai = rn2*rn2/rh1/rh1 + rn1*rn1/rh2/rh2
                  rgci = rn2*rn2/rh2/rh2 + rn1*rn1/rh1/rh1
                  rgbi = rn1*rn2*(1./rh1/rh1 - 1./rh2/rh2)
                  call INTERSECTION_METRIC(rga(i),rgb(i),rgc(i),
     *                 rgai,rgbi,rgci)
               endif
            endif

c     WAKES
            if(s .ge. 0.0) then
               xk = x1 + s*(x2-x1)
               yk = y1 + s*(y2-y1)
               rwake = ( ( xk - x3)**2 + (yk - y3)**2)**0.5
               if( rwake .lt. ymax) then
c                  cor = (2.+ s*4.)*0.15/n0
                  rlenrel = s*sqrt(sstt)/rcharlen
c                  cor = (1.+rlenrel)/n0*2.
                  cor = (1.+rlenrel)/n0*6.
c                  write(46,*) xi,yi,cor
                  rn1 = -(yte1 - yte2)
                  rn2 = xte2 - xte1
                  rmax = rwake-0.02*rcharlen
                  rmax = max (rmax,0.)
c                  q = (0.2+qbas)/1.2 - ymax/20.
c                  q = max(q, 0.)
c                  q = qbas
                  rlen = (rn1*rn1 + rn2*rn2)**0.5
                  rn1 = rn1/rlen
                  rn2 = rn2/rlen

c                  rh2 = cor/sqrt(Res) + rmax*(q - 1.)/rcharlen
                  rh2 = cor/sqrt(Res)+ (rcharlen/10. - cor/sqrt(Res))*
     *                 rmax/ymax
                  rh1 = rh2*(1+(1-24.*pos*pos)**0.5)/4/pos
ccc               write(33,*) x(i),y(i),q,rh1,rh2
                  rgai = rn2*rn2/rh1/rh1 + rn1*rn1/rh2/rh2
                  rgci = rn2*rn2/rh2/rh2 + rn1*rn1/rh1/rh1
                  rgbi = rn1*rn2*(1./rh1/rh1 - 1./rh2/rh2)

c               call ELIPS(64,rgai,rgbi,rgci,x(i),y(i) )
                  call INTERSECTION_METRIC(rga(i),rgb(i),rgc(i),
     *                 rgai,rgbi,rgci)
               endif
            endif
         enddo
      endif
c      stop

      icontrol = 1
      if(icontrol .eq. 1) then
c     MESH GRADIENT CONTROL H-variation
         alpha = 2.0
         do is =1,4
            do k=1,3*nelem
               ra(k) = 1.
            enddo
            do i=1,nelem
               do j=1,3
                  if(ra(3*(i-1)+j) .gt. 0) then
                     j1 = mod(j,3) + 1
                     k1 = lnd(i,j)
                     k2 = lnd(i,j1)
                     x1 = x(k1)
                     y1 = y(k1)
                     x2 = x(k2)
                     y2 = y(k2)
                     rga1 = rga(k1)
                     rgb1 = rgb(k1)
                     rgc1 = rgc(k1)
                     rga2 = rga(k2)
                     rgb2 = rgb(k2)
                     rgc2 = rgc(k2)
                     rl1 = (rga1*(x1-x2)**2 + 2*rgb1*(x1-x2)*(y1-y2) +
     *                    rgc1*(y1-y2)**2)**0.5
                     rl2 = (rga2*(x1-x2)**2 + 2*rgb2*(x1-x2)*(y1-y2) +
     *                    rgc2*(y1-y2)**2)**0.5
                     rga3 = rga2*(1+alpha*rl1)**(-2)
                     rgb3 = rgb2*(1+alpha*rl1)**(-2)
                     rgc3 = rgc2*(1+alpha*rl1)**(-2)
                     rga4 = rga1*(1+alpha*rl2)**(-2)
                     rgb4 = rgb1*(1+alpha*rl2)**(-2)
                     rgc4 = rgc1*(1+alpha*rl2)**(-2)
                     call INTERSECTION_METRIC(rga(k1),rgb(k1),rgc(k1),
     *                    rga3,rgb3,rgc3)
                     call INTERSECTION_METRIC(rga(k2),rgb(k2),rgc(k2),
     *                    rga4,rgb4,rgc4)
                     
                     ra(3*(i-1)+j) = -1.
                     if(iae(i,j) .gt. 0) then
                        ii = iae(i,j)
                        do l=1,3
                           if(iae(ii,l) .eq. i) ra(3*(ii-1)+l) = -1.
                        enddo
                     endif
                  endif
               enddo
            enddo
         enddo
c     end of MESH GRADIENT CONTROL

      elseif(icontrol .eq. 2) then
c     MESH GRADIENT CONTROL H-shock
         beta = 1.5
         do is =1,2
            do k=1,3*nelem
               ra(k) = 1.
            enddo
            do i=1,nelem
               do j=1,3
                  if(ra(3*(i-1)+j) .gt. 0) then
                     j1 = mod(j,3) + 1
                     k1 = lnd(i,j)
                     k2 = lnd(i,j1)
                     x1 = x(k1)
                     y1 = y(k1)
                     x2 = x(k2)
                     y2 = y(k2)
                     rga1 = rga(k1)
                     rgb1 = rgb(k1)
                     rgc1 = rgc(k1)
                     rga2 = rga(k2)
                     rgb2 = rgb(k2)
                     rgc2 = rgc(k2)
                     rnoem = ((x2-x1)**2 + (y2-y1)**2)**0.5
                     xx = (x2 -x1)/rnorm
                     yy = (y2 -y1)/rnorm
                     rl1 = (rga1*xx**2 + 2*rgb1*xx*yy +
     *                    rgc1*yy**2)**0.5
                     rl2 = (rga2*xx**2 + 2*rgb2*xx*yy +
     *                    rgc2*yy**2)**0.5
                     rl = ((rga1+rga2)/2*(x1-x2)**2 + 
     *                    (rgb1+rgb2)*(x1-x2)*(y1-y2) +
     *                    (rgc1+rgc2)/2*(y1-y2)**2)**0.5
                     if(rl2 .gt. rl1) then
                        cc = (rl2/rl1)**(1./rl)
                        if(cc .gt. beta) then
                           eta = (beta/cc)**rl
                           print *,'eta =',eta
                           rga(k2) = rga(k2)/eta/eta
                           rgb(k2) = rgb(k2)/eta/eta
                           rgc(k2) = rgc(k2)/eta/eta
                        endif
                     endif
                     ra(3*(i-1)+j) = -1.
                     if(iae(i,j) .gt. 0) then
                        ii = iae(i,j)
                        do l=1,3
                           if(iae(ii,l) .eq. i) ra(3*(ii-1)+l) = -1.
                        enddo
                     endif
                  endif
               enddo
            enddo
         enddo
c     end of MESH GRADIENT CONTROL
      endif


c     smoothing
      do 1500 ic = 1,5
         do 1400 i=1,nelem
            ra(i) = (rga(lnd(i,1)) + rga(lnd(i,2)) + rga(lnd(i,3)))/3
            ra(i+melem) = 
     *           (rgb(lnd(i,1)) + rgb(lnd(i,2)) + rgb(lnd(i,3)))/3
            ra(i+2*melem) = 
     *           (rgc(lnd(i,1)) + rgc(lnd(i,2)) + rgc(lnd(i,3)))/3
 1400     continue
         
         do 1410 i=1,npoin
            rga(i) = 0.
            rgb(i) = 0.
            rgc(i) = 0.
            area(i) = 0.
 1410     continue
      
         do 1420 i=1,nelem
            xc = (x(lnd(i,1))+x(lnd(i,2))+x(lnd(i,3)))/3
            yc = (y(lnd(i,1))+y(lnd(i,2))+y(lnd(i,3)))/3
            do 1430 j=1,3
               k = lnd(i,j)
c               rl = ((xc-x(k))**2 + (yc-y(k))**2)**0.5
               rga(k) = rga(k) + ra(i)*tria(i)
               rgb(k) = rgb(k) + ra(i+melem)*tria(i)
               rgc(k) = rgc(k) + ra(i+2*melem)*tria(i)
               area(k) = area(k) + tria(i)
 1430        continue
 1420     continue
         
         do 1440 i=1,npoin
            rga(i) = rga(i)/area(i)
            rgb(i) = rgb(i)/area(i)
            rgc(i) = rgc(i)/area(i)
         if(i .eq. itest) print *,'$3',rga(i),rgb(i),rgc(i)
 1440     continue
 1500  continue

c     ... no plotting (too big file)
      if(npoin .gt. 5000) return

c      imt = 18
c      open(imt,file='mt',status='unknown')
c      do 63 i=1,npoin
cc     for plotting of the elipses
c         if(ibp(i,1) .gt. 0) then
c            rga(i) = (rga(i) + rga(ibp(i,1)))/2
c            rga(ibp(i,1)) = rga(i)
c            rgb(i) = (rgb(i) + rgb(ibp(i,1)))/2
c            rgb(ibp(i,1)) = rgb(i)
c            rgc(i) = (rgc(i) + rgc(ibp(i,1)))/2
c            rgc(ibp(i,1)) = rgc(i)
c         endif
c         call ELIPS(imt,rga(i),rgb(i),rgc(i),x(i),y(i) )
cc         if(i .eq. itest) print *,'$$',rga(i),rgb(i),rgc(i)
c 63   continue
cc      stop
 1313 continue


      return
      end

      subroutine ELIPS(ieli,a,b,c,xi,yi)

      num = 100
      do i=0,num
         t = 1.*i/num*6.283185307
         x = cos(t)
         y = sin(t)
         rnorm = (x*x*a + 2*x*y*b + y*y*c)**0.5
         xs = x/rnorm + xi
         ys = y/rnorm + yi
         write(ieli,*) xs,ys
      enddo
      write(ieli,'(x)')
      return
      end
         


      subroutine INTERSECTION_METRIC(ra1,rb1,rc1,ra2,rb2,rc2)

      real*8 a1,a2,b1,b2,c1,c2,p1,p2,p3,p4,d,rmat1(2),rmat2(2),
     *     rlam1,rlam2,pi1,pi2,pi3,pi4

      a1 = ra1
      b1 = rb1
      c1 = rc1
      a2 = ra2
      b2 = rb2
      c2 = rc2
      
      p3 = 1.D+00
      p4 = 1.D+00

      d = (a1*c2 - a2*c1)**2 -4.D+00*(a1*b2-b1*a2)*(b1*c2-c1*b2)
      if((a1*b2-b1*a2) .ne. 0 .and. d .ge. 0.) then
         p2 = (a2*c1-a1*c2 - d**0.5)/2.D+00/(a1*b2-b1*a2)
      elseif(a2*c1-a1*c2 .ne. 0. .and. d .ge. 0. ) then
         p2 = (b1*c2-c1*b2)/(a2*c1-a1*c2)
      else
c         print *,'zero polynom'
         if(a1 .le. a2) then
            ra1 = ra2
            rb1 = rb2
            rc1 = rc2
         endif
         return
      endif

      if(p2*a2 + b2 .ne. 0.) then
         p1 = -(b2*p2 + c2)/(p2*a2 + b2)
      else
         if(a1 .le. a2) then
            ra1 = ra2
            rb1 = rb2
            rc1 = rc2
         endif
         return
      endif
         
      rmat1(1) = p1**2*a1+2*p1*p3*b1+p3**2*c1
      rmat112 = p2*p1*a1+p2*p3*b1+p4*p1*b1+p4*p3*c1
      rmat121 = p2*p1*a1+p2*p3*b1+p4*p1*b1+p4*p3*c1
      rmat1(2) = p2**2*a1+2*p2*p4*b1+p4**2*c1

      rmat2(1) = p1**2*a2+2*p1*p3*b2+p3**2*c2
      rmat212 = p2*p1*a2+p2*p3*b2+p4*p1*b2+p4*p3*c2
      rmat221 = p2*p1*a2+p2*p3*b2+p4*p1*b2+p4*p3*c2
      rmat2(2) = p2**2*a2+2*p2*p4*b2+p4**2*c2

      rlam1 = max(rmat1(1),rmat2(1) )
      rlam2 = max(rmat1(2),rmat2(2) )

      if(rlam1 .le. 0. .or. rlam2 .le. 0) then
         print *,'nonpositive eigenvalues'
         stop
      endif

      d = p1*p4 - p2*p3
      if(d .eq. 0.) then
         print *,'zero deter.'
         stop
      endif
      pi1 = p4/d
      pi2 = -p2/d
      pi3 = -p3/d
      pi4 = p1/d

      ra1 = pi1**2*rlam1+pi3**2*rlam2
      rb1 = pi1*rlam1*pi2+pi3*rlam2*pi4
      rc1 = pi2**2*rlam1+pi4**2*rlam2

      return
      end


      subroutine ERROR2(melem,nelem,mpoin,npoin,maxdeg,dx,dy,area,
     *     tria,noit,
     *     x,y,lnd,iae,wp,icyc,ra,rga,rgb,rgc,surface,
     *     ibp)
      dimension lnd(melem,3),iae(melem,3),x(mpoin),y(mpoin),
     *     ra(melem*3),wp(mpoin,5),dx(melem),dy(melem),
     *     icyc(mpoin,maxdeg),rga(mpoin),rgb(mpoin),rgc(mpoin),
     *     area(mpoin),tria(melem),ibp(mpoin,2)
      real*8 dxi,dyi,rmeas,x1,x2,x3,y1,y2,y3,w1,w2,w3,areai,rl
      real*8 a,b,c,disc,rlam1,rlam2,x11,x12,x21,x22,y12,y11,y21,y22,
     *     t11,t12,t21,t22,z11,z12,z21,z22,rdet

      common /const/ p, epsilon1, pos, pos1, numel,ityp
      common /period/ xper,yper,iper1,iper2
      common /period2/ xper2,yper2,iper3,iper4

      rkappa = 1.4

c     dx the first derivative dw/dx
c     dy                      dw/dy
c     rga  the second der.    d2w/dx dx
c     rgb                     d2w/dx dy
c     rgc                     d2w/dy dy       

      do 1600 i1=1,nelem
         do 1610 ji=1,3
            j1 = mod(ji,3) + 1
            if(iae(i1,ji) .lt. 0 .and. iae(i1,j1) .lt. 0) then
               print *,'$$$',icha,i1,ji,j1
               print *,lnd(i1,1),lnd(i1,2),lnd(i1,3)
               print *,x(lnd(i1,1)),y(lnd(i1,1))
               print *,x(lnd(i1,2)),y(lnd(i1,2))
               print *,x(lnd(i1,3)),y(lnd(i1,3))
            endif
 1610    continue
 1600 continue



      do 10 i=1,nelem
         x1 = x(lnd(i,1))
         y1 = y(lnd(i,1))
         w1 = wp(lnd(i,1),1)
         x2 = x(lnd(i,2))
         y2 = y(lnd(i,2))
         w2 = wp(lnd(i,2),1)
         x3 = x(lnd(i,3))
         y3 = y(lnd(i,3))
         w3 = wp(lnd(i,3),1)
         rmeas = x1*y2 + x2*y3 + x3*y1 - x1*y3  -x2*y1 - x3*y2
         tria(i) = rmeas/2
         if( rmeas .le. 0) then
            print *,'bad triangle in ERROR'
            print *,i,lnd(i,1),lnd(i,2),lnd(i,3)
            print *,x1,y1,rmeas
            print *,x2,y2
            print *,x3,y3
            stop
         endif
         dx(i) = (y2-y1)*(w1+w2) + (y3-y2)*(w2+w3) + (y1-y3)*(w1+w3) 
         dy(i) = (x1-x2)*(w1+w2) + (x2-x3)*(w2+w3) + (x3-x1)*(w1+w3) 
         dx(i) = dx(i) /rmeas
         dy(i) = dy(i) /rmeas

         if( i .eq. -10) then
            write(*,'(4i5 )')i,lnd(i,1),lnd(i,2),lnd(i,3)
            write(*,'(4e14.6 )')x1,y1,w1,rmeas
            write(*,'(3e14.6 )')x2,y2,w2
            write(*,'(3e14.6 )')x3,y3,w3
            write(*,'(3e14.6 )')(x1-x2),(x2-x3),(x3-x1)
            write(*,'(3e14.6 )')(w1+w2),(w2+w3),(w1+w3)
            write(*,'(3e14.6 )')(y2-y1),(y3-y2),(y1-y3)
            write(*,'(2e14.6 )')dx(i),dy(i)

         endif

 10   continue

      do 20 i=1,npoin
         areai = 0.
         rga(i) = 0.
         rgb(i) = 0.
         rgc(i) = 0.
         rgdi = 0.
         if(icyc(i,1) .gt. 0) then
            len = icyc(i,1) 
         else
            len = -icyc(i,1)  - 1
         endif
c         if(i .eq. -236)    print *,x(i),y(i),wp(i,1),i,len
         x3 = x(i)
         y3 = y(i)
         w3 = wp(i,1)
         do 30 j=1,len
            j1 = mod(j, abs(icyc(i,1))) + 1
            x1 = x(icyc(i,j+1))
            y1 = y(icyc(i,j+1))
            w1 = wp(icyc(i,j+1),1)
            x2 = x(icyc(i,j1+1))
            y2 = y(icyc(i,j1+1))
            w2 = wp(icyc(i,j1+1),1)
            rmeas = x1*y2 + x2*y3 + x3*y1 - x1*y3  -x2*y1 - x3*y2
            areai = areai + rmeas/6
            dxi = (y2-y1)*(w1+w2) + (y3-y2)*(w2+w3) + (y1-y3)*(w1+w3) 
            dyi = (x1-x2)*(w1+w2) + (x2-x3)*(w2+w3) + (x3-x1)*(w1+w3) 
            dxfi = (y1-y2)/rmeas
            dyfi = (x2-x1)/rmeas

            rga(i) = rga(i) - dxi/2*dxfi
            rgb(i) = rgb(i) - dyi/2*dxfi
            rgc(i) = rgc(i) - dyi/2*dyfi
            rgdi = rgdi - dxi/2*dyfi
            
c            itest = 13
c            if(i .eq. itest ) then
c               write(*,'(a1,2i5,4e14.6)')
c     *              ' ',i,icyc(i,j+1), rga(i),rgb(i),rgdi,rgc(i)
cc               write(*,'(3i5,4e14.6)') i,icyc(i,j+1),icyc(i,j1+1),
cc     *              w3,w1,w2,x1
c               write(*,'(5e14.6)') x1,y1,w1,dxi,dyi
c               write(*,'(5e14.6)') x2,y2,w2,dxfi,dyfi
c               write(*,'(4e14.6)') x3,y3,w3
cc               write(*,'(3e14.6)') x(i),y(i),wp(i,1)
c            endif

            if(icyc(i,1) .lt. 0 .and. ibp(i,1) .eq. 0 ) then
c     for the boundary points me must add the boundary sides
               if(j .eq. 1) then
                  rga(i) = rga(i) + dxi/rmeas*(y1-y3)/2
                  rgb(i) = rgb(i) + dyi/rmeas*(y1-y3)/2
                  rgc(i) = rgc(i) + dyi/rmeas*(x3-x1)/2
                  rgdi = rgdi + dxi/rmeas*(x3-x1)/2
c                  if(i .eq. itest) write(*,'(a1,2i5,4e14.6)')
c     *                 'f',i,icyc(i,j+1), rga(i),rgc(i),dxi,dyi
               endif
               if( j .eq. len) then
                  rga(i) = rga(i) + dxi/rmeas*(y3-y2)/2
                  rgb(i) = rgb(i) + dyi/rmeas*(y3-y2)/2
                  rgc(i) = rgc(i) + dyi/rmeas*(x2-x3)/2
                  rgdi = rgdi + dxi/rmeas*(x2-x3)/2

c                  if(i .eq. itest) write(*,'(a1,2i5,4e14.6)')
c     *                 'l',i,icyc(i,j+1), rga(i),rgc(i),dxi/rmeas,
c     *                 dyi/rmeas
               endif
            endif
 30      continue
         area(i) = areai
         
 20   continue

c     for periodic boundary points
      if( xper .gt. 0 .or. yper .gt. 0) then
         do 18 i1=1,npoin
            i2 = ibp(i1,1)
            if( i2 .gt. 0 ) then
               if(rga(i1) .ne. rga(i2) .or. rgb(i1) .ne. rgb(i2) .or. 
     *              rgc(i1) .ne. rgc(i2) .or. area(i1) .ne. area(i2) )
     *              then
                  rga(i1) = rga(i1) + rga(i2)
                  rgb(i1) = rgb(i1) + rgb(i2)
                  rgc(i1) = rgc(i1) + rgc(i2)
                  area(i1) = area(i1) + area(i2)
                  rga(i2) = rga(i1) 
                  rgb(i2) = rgb(i1) 
                  rgc(i2) = rgc(i1) 
                  area(i2) = area(i1)
               endif
            endif
 18      continue
      endif

      do 15 i=1,npoin
         rga(i) = rga(i)/area(i)
         rgb(i) = rgb(i)/area(i)
         rgc(i) = rgc(i)/area(i)

cx         u = x(i)
cx         v = y(i)

cx         rga(i) = 4*(-1+3*u*u)/(1+u*u)**3
cx         rgb(i) = 0.
cx         rgc(i) = 0.
         write(10,'(5e14.6)') x(i),y(i),rga(i),rgb(i),rgc(i)
 15   continue

      rmaxder = 0.
c     improvement for boundary points

      do 100 i=1,npoin
         if(icyc(i,1) .lt. 0 .and. ibp(i,1) .eq. 0) then
            len = abs(icyc(i,1))
            if( len .ge. 3) then
               ipoc = 0
               rga(i) = 0.
               rgb(i) = 0.
               rgc(i) = 0.
               rminlenght = 1E+38
               do 110 j=2,len-1
                  if(icyc(icyc(i,j+1),1) .gt. 0) then
c     this point isn't boundary
c                     rga(i) = rga(i) + rga(icyc(i,j+1))
c                     rgb(i) = rgb(i) + rgb(icyc(i,j+1))
c                     rgc(i) = rgc(i) + rgc(icyc(i,j+1))
c                     ipoc = ipoc + 1
                     xlen = ((x(i)-x(icyc(i,j+1)))**2 +
     *                    (y(i) -y(icyc(i,j+1)))**2 )**0.5
                     if(xlen .lt. rminlenght) then
                        rga(i) = rga(icyc(i,j+1))
                        rgb(i) = rgb(icyc(i,j+1))
                        rgc(i) = rgc(icyc(i,j+1))
                        rminlenght = xlen
                     endif
                     if( i .eq. -170) then
                        print *,'**',j,icyc(i,j+1),rgc(icyc(i,j+1)),
     *                       xlen,rminlenght 
                     endif
                  endif
 110           continue
c     we use the value from the nearest point
               if(ipoc .gt. 0 ) then
                  rga(i) = rga(i)/ipoc
                  rgb(i) = rgb(i)/ipoc
                  rgc(i) = rgc(i)/ipoc
               else
c     in this case, we let the second derivations = 0 !!!!

               endif
            elseif( len .eq. 2) then
               i1 = icyc(i,2)
               i2 = icyc(i,3)
               do 120 ie =1,nelem
                  do 130 je =1,3
                     je1 = mod(je,3)+1
                     if(lnd(ie,je) .eq. i2 .and. 
     *                    lnd(ie,je1) .eq. i1) then
                        je2 = mod(je1,3) + 1
                        rga(i) = rga(lnd(ie,je2))
                        rgb(i) = rgb(lnd(ie,je2))
                        rgc(i) = rgc(lnd(ie,je2))
                        goto 140
                     endif
 130              continue
 120           continue
 140           continue
            else
               print *,'ERROR len < 2 !!!!'
            endif
         endif
c         rga(i) = 0.
c         rgb(i) = 0.
c         rgc(i) = 0.
c         if(icyc(i,1) .lt. 0 .and. ibp(i,1) .eq. 0) rgc(i) = 100.
         write(11,'(5e14.6)') x(i),y(i),rga(i),rgb(i),rgc(i)
         rmaxder = max(rmaxder,abs(rga(i)),abs(rgb(i)),abs(rgc(i)) )
 100  continue
c      stop

c      return
c     the area of ideal triangle
      rnorm = 1.29903810567 *numel/surface
c     Gamm channel
c      epsilon1 = 7500.
c      epsilon2 = 7500.

c     NACA
c      epsilon1 = 10000.
c      epsilon2 = 250.

c     profile
c      epsilon1 = 250.
c      epsilon2 = 10000.

c     automatic generation
c      p = 0.95
c      epsilon1 = rmaxder*3/rnorm*10.
c      epsilon1 = min(10000.,epsilon1)
c      epsilon1 = 10000.
c      epsilon1 = max (50.,epsilon1)

      rmaxderteor = epsilon1/3*rnorm
      der = rmaxderteor
c      der = min(rmaxderteor,rmaxder)

      epsilon2p = der/10*(epsilon1 + 1.)*(1.-p)/
     *     (p*(epsilon1 + 1.)-1.)

      epsilon2 = max (1.,epsilon2p)

      print *,'                    p =',p,'    ityp =',ityp
      print *,'   number of elements =',numel
      print *,'rmaxder,rmaxderteor,c =',rmaxder,rmaxderteor,rnorm
      print *,'epsilon1 and epsilon2 = ',epsilon1,epsilon2,'(',
     *     epsilon2p,')'

      ipr = -1
c     we compute the elements of matrix M from the second derivations 

      rmax1 = 0.
      rmax2 = 0.
      rmax3 = 0.
      
      do 200 i=1,npoin
c      do 200 i=1,1

         if(rga(i) .gt. rmax1) then
            rmax1 = rga(i)
            imax1 = i
         endif
         if(rgb(i) .gt. rmax2) then
            rmax2 = rgb(i)
            imax2 = i
         endif
         if(rgc(i) .gt. rmax3) then
            rmax3 = rgc(i)
            imax3 = i
         endif

         if(abs(rgb(i)) .lt. 1E-05) then
c     the diagonal metrix

            eps1 = epsilon1/(epsilon2+max(rga(i),rgc(i)))

            rgb(i) = 0.
            rga(i) = (1. + eps1*abs(rga(i)))*rnorm
            rgc(i) = (1. + eps1*abs(rgc(i)))*rnorm
         else
c     the eigenvalues rlam1 , rlam2
            a = rga(i)
            b = rgb(i)
            c = rgc(i)

            disc = ((a - c)*(a - c) + 4*b*b)**0.5
            rlam1 = (a + c + disc)/2
            rlam2 = (a + c - disc)/2
            if(abs(rlam1) .lt. abs(rlam2) ) then
               rlampom = rlam1
               rlam1 = rlam2
               rlam2 = rlampom
            endif

            x11 = b
            x21 = -(a-rlam1)
            rl1 = (x11*x11+x21*x21)**0.5
            x11 = x11/rl1
            x21 = x21/rl1

            x12 = b
            x22 = -(a-rlam2)
            rl2 = (x12*x12+x22*x22)**0.5
            x12 = x12/rl2
            x22 = x22/rl2

            rdet = x11*x22 - x21*x12

c     inverse matrix
            y11 = x22/rdet
            y12 = -x12/rdet
            y21 = -x21/rdet
            y22 = x11/rdet

            z11 = abs(rlam1)*y11
            z12 = abs(rlam1)*y12
            z21 = abs(rlam2)*y21
            z22 = abs(rlam2)*y22
            
            t11 = x11*z11 + x12*z21
            t12 = x11*z12 + x12*z22
            t21 = x21*z11 + x22*z21
            t22 = x21*z12 + x22*z22

            if(i .eq. ipr) then
               print *,'***********************',i,'    *************'
               print *,a,b,c,rlam1,rlam2
               print *,a-rlam1,b
               print *,b,c-rlam1
               print *,'            '
               print *,'----------------------'
               write(*,'(6e12.4)')
     *              x11,x12,rlam1,0,y11,y12
               write(*,'(6e12.4)')
     *              x21,x22,0,rlam2,y21,y22
               print *,'----------------------'
               write(*,'(4e12.4)')
     *              z11,z12,t11,t12
               write(*,'(4e12.4)')
     *              z21,z22,t21,t22
               print *,'----------------------'
            endif

            eps1 = epsilon1/(epsilon2+max(t11,t22))

            rga(i) = (1. + eps1*t11)*rnorm 
            rgb(i) = (eps1*(t12+t21)/2)*rnorm
            rgc(i) = (1. + eps1*t22)*rnorm

            if(rga(i)*rgc(i) .le. rgb(i)*rgb(i) ) then
               print *,'ERROR in metric, nonpositive matrix'
               write(*,'(i5,3e14.6)') i,rga(i),rgb(i),rgc(i)
               print *,a,b,c
               print *,'----------------------'
               write(*,'(6e12.4)')
     *              x11,x12,rlam1,0,y11,y12
               write(*,'(6e12.4)')
     *              x21,x22,0,rlam2,y21,y22
               print *,'----------------------'
               write(*,'(4e12.4)')
     *              z11,z12,t11,t12
               write(*,'(4e12.4)')
     *              z21,z22,t21,t22
               print *,'----------------------'
               stop
            endif

         endif

 200  continue

c      print *,'*************************'
c      print *,imax1,rmax1,x(imax1),y(imax1)
c      print *,imax2,rmax2,x(imax2),y(imax2)
c      print *,imax3,rmax3,x(imax3),y(imax3)


c     smoothing
      do 500 ic = 1,5
         do 400 i=1,nelem
            ra(i) = (rga(lnd(i,1)) + rga(lnd(i,2)) + rga(lnd(i,3)))/3
            ra(i+melem) = 
     *           (rgb(lnd(i,1)) + rgb(lnd(i,2)) + rgb(lnd(i,3)))/3
            ra(i+2*melem) = 
     *           (rgc(lnd(i,1)) + rgc(lnd(i,2)) + rgc(lnd(i,3)))/3
 400     continue
         
         do 410 i=1,npoin
            rga(i) = 0.
            rgb(i) = 0.
            rgc(i) = 0.
            area(i) = 0.
 410     continue
      
         do 420 i=1,nelem
c            xc = (x(lnd(i,1))+x(lnd(i,2))+x(lnd(i,3)))/3
c            yc = (y(lnd(i,1))+y(lnd(i,2))+y(lnd(i,3)))/3
            do 430 j=1,3
               k = lnd(i,j)
c               rl = ((xc-x(k))**2 + (yc-y(k))**2)**0.5
               rga(k) = rga(k) + ra(i)*tria(i)
               rgb(k) = rgb(k) + ra(i+melem)*tria(i)
               rgc(k) = rgc(k) + ra(i+2*melem)*tria(i)
               area(k) = area(k) + tria(i)
 430        continue
 420     continue
         
         do 440 i=1,npoin
            rga(i) = rga(i)/area(i)
            rgb(i) = rgb(i)/area(i)
            rgc(i) = rgc(i)/area(i)
            if( i .lt. -20) then
               write(*,'(i5,4e14.6)') i,rga(i),rgb(i),rgc(i),wp(i,1)
            endif
 440     continue
 500  continue
     
      do 63 i=1,npoin
         if(ibp(i,1) .gt. 0) then
            rga(i) = (rga(i) + rga(ibp(i,1)))/2
            rga(ibp(i,1)) = rga(i)
            rgb(i) = (rgb(i) + rgb(ibp(i,1)))/2
            rgb(ibp(i,1)) = rgb(i)
            rgc(i) = (rgc(i) + rgc(ibp(i,1)))/2
            rgc(ibp(i,1)) = rgc(i)
         endif
         write(12,'(5e14.6)') x(i),y(i),rga(i),rgb(i),rgc(i)
 63   continue
c      stop
      return
      end


      subroutine SIXTRIANG(xp,yp,x1,y1,x2,y2,x3,y3,x4,
     *     y4,x5,y5,x6,y6,sum)
c         print *, 'uvnitr sixtriang '     
c vypocet normy fi v prostoru H(0,1), fi ma hodnotu 1 v xp,yp
c a 0 v xi,yi, je linearni
      
      call TRIANG(xp,yp,x1,y1,x2,y2,s1)
      call TRIANG(xp,yp,x2,y2,x3,y3,s2)
      call TRIANG(xp,yp,x3,y3,x4,y4,s3)
      call TRIANG(xp,yp,x4,y4,x5,y5,s4)
      call TRIANG(xp,yp,x5,y5,x6,y6,s5)
      call TRIANG(xp,yp,x6,y6,x1,y1,s6)

      sum=s1+s2+s3+s4+s5+s6
      return
      end 


      subroutine  TRIANG(xp,yp,xa,ya,xb,yb,s)

c         print *, 'uvnitr triang  '     
c vypocet integralu pro jednotlivy trojuhelnicek, ktery je 
c casti sestiuhelniku
      pom=(xp-xb)*(ya-yb)-(xa-xb)*(yp-yb)
      T=(ya-yb)/pom
      R=(xb-xa)/pom
      
      a=sqrt((xa-xp)*(xa-xp)+(ya-yp)*(ya-yp))
      b=sqrt((xb-xp)*(xb-xp)+(yb-yp)*(yb-yp))
      c=sqrt((xa-xb)*(xa-xb)+(ya-yb)*(ya-yb))

      cb=(c*c+b*b-a*a)/(2*c)
      v=sqrt(b*b-cb*cb)
      s=0.
c       s=v*c/12.
c        we have the space H(0,1), we use a seminorm, 
c             which is equivalent
      s=s+v*c*0.5*(T*T+R*R)
      return
      end


      subroutine SEEK_BOUN(melem,nelem,mpoin,npoin,ipoint,nbp,xb,yb,
     *     lnd,iae,ibb,ibpoin,x,y, icrack)
      dimension lnd(melem,3),iae(melem,3),xb(ipoint),yb(ipoint),
     *     ibb(mpoin,3),x(mpoin),y(mpoin),ibpoin(0:nbp)

      do i=1,npoin
         ibb(i,1) = -1
         ibb(i,2) = 0
      enddo
      

c     no smooth boundary
      if(nbp .eq. 0) return
     
      do i=1,nelem
         do j=1,3
            if(iae(i,j) .lt. 0) then
               j1 = mod(j,3) + 1
               ip = lnd(i,j)
c               if(ip .eq. 112) print *,'###'
               xp = x(ip)
               yp = y(ip)
               rlen0 = (xp - x(lnd(i,j1)))*(xp - x(lnd(i,j1))) + 
     *              (yp - y(lnd(i,j1)))*(yp - y(lnd(i,j1)))
               rl0 = 1.E+25*rlen0
               do k=1,nbp
                  do l=ibpoin(k-1)+1,ibpoin(k)
                     rlen = (xp - xb(l))*(xp - xb(l)) +
     *                    (yp - yb(l))*(yp - yb(l))
                     if(rlen .lt. rl0) then
                        if(icrack .gt. 0 .and. xp .gt. -0.01) then
                           yc = (y(lnd(i,1))+y(lnd(i,2))+
     *                          y(lnd(i,3)))/3
                           if(( yc .gt. 0 .and. l .lt. ibpoin(k)/2) 
     *                          .or. ( yc .lt. 0 .and. 
     *                          l .gt. ibpoin(k)/2) )then
                              rl0 = rlen
                              il0 = l
                              kl0 = k
                           endif
                        else
                           rl0 = rlen
                           il0 = l
                           kl0 = k
                        endif
                     endif
                  enddo
c               if(ip .eq. 2) 
c                  write(*,'(a3,3i5,6e12.4)')
c     *                 '###',ip,il0,kl0,x(ip),y(ip),rl0,rlen0,rl0/rlen0
               enddo
               if(rl0/rlen0 .lt. 1E-03) then
c     the node in 'profile' found
                  ibb(ip,1) = il0
                  ibb(ip,2) = kl0
               endif
            endif
         enddo
      enddo

       do i=1,npoin
         if(ibb(i,1) .gt.0 ) then
c            write(21,'(2e12.4,3i8)') 
c     *        xb(ibb(i,1)),yb(ibb(i,1)),ibb(i,1),ibb(i,2),i
cc     corection of the boundary            
            x(i) = xb(ibb(i,1))
            y(i) = yb(ibb(i,1))
         endif       
      enddo

      return
      end

      subroutine COINS(melem,nelem,mpoin,npoin,lnd,iae,
     *     nbelm,mbelm,lbn,itc)
      dimension lnd(melem,3),iae(melem,3),lbn(mbelm,2),itc(mbelm)

c     if some triangle has a two times iae(i,j) < 0 the me make a 
c     bascule such that this case doesn't appear

      do 10 i=1,nelem
         do 20 j=1,3
            j1 = mod(j,3) + 1
            j2 = mod(j1,3) + 1
            if( iae(i,j1) .lt. 0 .and. iae(i,j2) .lt. 0 ) then
               ii = iae(i,j)
               do 30 jjj=1,3
                  if(iae(ii,jjj) .eq. i) then
                     jj = jjj
                  endif
 30            continue
               jj1 = mod(jj,3) + 1
               jj2 = mod(jj1,3) + 1
               k1 = lnd(i,j)
               k2 = lnd(i,j1)
               k3 = lnd(i,j2)
               k4 = lnd(ii,jj2)
               if(k1 .ne. lnd(ii,jj1) .or. k2 .ne. lnd(ii,jj) ) then
                  print *,'ERROR in COINS 1'
               endif
               ia1 = iae(ii,jj1)
               if(ia1 .gt. 0) then
                  do 40 k=1,3
                     if(iae(ia1,k) .eq. ii) ja1 = k
 40               continue
               endif
               ia2 = iae(ii,jj2)
               if(ia2 .gt. 0) then
                  do 50 k=1,3
                     if(iae(ia2,k) .eq. ii) ja2 = k
 50               continue
               endif
               lnd(i,j1) = k4
               lnd(ii,jj1) = k3
               iae(i,j1) = ii
               iae(ii,jj) = -2
               iae(i,j) = ia1
               iae(ii,jj1) = i
               if(ia1 .gt. 0) iae(ia1,ja1) = i

               do ib=1,nbelm
                  if(itc(ib) .eq. i .and. 
     *                 lbn(ib,1) .eq. k2 .and.lbn(ib,2) .eq.k3)then
                     itc(ib) = ii
                  endif
               enddo

            endif
 20      continue
 10   continue
      return
      end


      subroutine ADJAC(melem,nelem,mpoin,npoin,lnd,iae,maxdeg,icyc)
      dimension lnd(melem,3),iae(melem,3),icyc(mpoin,maxdeg)

c     the array icyc has here only the local meaning
      do i=1,npoin
         icyc(i,1) = 0
      enddo
      do i=1,nelem
         do j=1,3
            k = lnd(i,j)
            icyc(k,1) = icyc(k,1) + 1
            if(icyc(k,1) .gt. maxdeg) then
               print *,'Bad dimension in ADJAC'
               print *,'maxdeg < icyc(k,1)',maxdeg,icyc(k,1)
               print *,k
               stop
            endif
            icyc(k,icyc(k,1)+1) = i
         enddo
      enddo
      
      do 10 i=1,nelem
         iae(i,1) = -2
         iae(i,2) = -2
         iae(i,3) = -2
 10   continue
      do 20 i=1,nelem
         do 30 j=1,3
            if(iae(i,j) .eq. -2)then
               j1 = mod(j,3) +1
               do 40 il=1,icyc(lnd(i,j),1)
                  ii = icyc(lnd(i,j),il+1)
                  if( ii .ne. i) then
                     do 50 jj=1,3
                        jj1 = mod(jj,3) +1
                        if( (lnd(i,j) .eq. lnd(ii,jj1) ).and.
     *                       (lnd(i,j1) .eq. lnd(ii,jj))) then
                           iae(i,j) = ii
                           iae(ii,jj) = i
                           goto 60
                        endif
 50                  continue
                  endif
 40            continue
 60            continue
            endif
 30      continue
 20   continue

c      print *,'The seeking of neighbourhouds done'
      return
      end

      subroutine CYKLE_BOUND(melem,nelem,mpoin,npoin,maxdeg,x,y,
     *     lnd,iae,icyc)
      dimension x(mpoin),y(mpoin),lnd(melem,3),
     *     icyc(mpoin,maxdeg),iae(melem,3)
      

      do 10 i=1,nelem
         do 20 j=1,3
            if(iae(i,j) .le. 0) then
               j0 = j
               j1 = mod(j0,3) + 1
               ip = lnd(i,j0)
               if(icyc(ip,1) .ne. -1) then
                  print *,'ERROR in CYKLE_BOUND'
                  print *,ip,icyc(ip,1),icyc(ip,2),icyc(ip,3)
                  print *,x(ip),y(ip)
                  return
               endif
               icyc(ip,2) = lnd(i,j1)
               ii = i
c     seeking the following point
 1000          ilen = abs(icyc(ip,1))
               itest = 0
               do 30 l=1,3
                  if(lnd(ii,l) .eq. ip) then
                     itest = 1
                     j0 = l
                     goto 40
                  endif
 30            continue
 40            continue
               j1 = mod(j0 ,3) + 1
               j2 = mod(j1,3) + 1
               icyc(ip,ilen+2) = lnd(ii,j2)
               icyc(ip,1) = icyc(ip,1) - 1
               if(abs(icyc(ip,1)) +1 .gt. maxdeg) then
                  print *,'The lenght of cykles > maxdeg = ',maxdeg
                  stop
               endif

               ii1 = iae(ii,j2)
               if(ii1 .gt. 0) then
                  ii = ii1
                  goto 1000
               endif
            endif
 20      continue
 10   continue

      
c      test of angles
      ipoc = 0
      if(ipoc .eq. 0) return

      rmax = 10.
      iost = 12134
      open(iost,file='ost',status='unknown')
      do 2000 i=1,nelem
         do 2010 j=1,3
            j1 = mod(j,3) + 1
            j2 = mod(j1,3) + 1
            x1 = x(lnd(i,j))
            y1 = y(lnd(i,j))
            x2 = x(lnd(i,j1))
            y2 = y(lnd(i,j1))
            x3 = x(lnd(i,j2))
            y3 = y(lnd(i,j2))
            u1 = x2 - x1
            v1 = y2 - y1
            u2 = x3 - x1
            v2 = y3 - y1
            rcos = (u1*u2+v1*v2)/((u1*u1+v1*v1)*(u2*u2+v2*v2))**0.5
            if (rcos .lt. -0.2) then
               write(iost,'(2e14.6)')x1,y1
               write(iost,'(2e14.6)')x2,y2
               write(iost,'(2e14.6)')x3,y3
               write(iost,'(2e14.6)')x1,y1
               write(iost,'(x)')

               ipoc = ipoc + 1
               if(rcos .lt. rmax) then
                  rmax = rcos
                  imax = i
                  jmax = j
               endif
            endif
 2010    continue
 2000 continue
      write( *,'(a12,3i5,2e14.6)') 
     *     'the number = ',ipoc,imax,jmax,rmax,acos(rmax)
      print *,'nelem = ',nelem
      return
      end

      subroutine CYKLE(melem,nelem,mpoin,npoin,maxdeg,x,y,
     *     lnd,iae,icyc,lbn,nbelm,mbelm,ibp,itc,ibc)
      dimension x(mpoin),y(mpoin),lnd(melem,3),lbn(mbelm,2),
     *     icyc(mpoin,maxdeg),
     *     iae(melem,3),ibp(mpoin,2),ibc(mbelm),itc(mbelm)

      common /period/ xper,yper,iper1,iper2
      common /period2/ xper2,yper2,iper3,iper4

      do 5 i=1,npoin
         icyc(i,1) = 0
 5    continue

      do 10 k=1,nbelm
         icyc(lbn(k,1),1) = -1
         icyc(lbn(k,2),1) = -1
 10   continue

c  ... seeking the  cyclus around each point exept boundaries

      do 30 i=1,nelem
         do 40 j=1,3
            ip = lnd(i,j)
            if(icyc(ip,1) .eq. 0) then
c     initialisation
               j1 = mod(j,3) + 1
               k1 = lnd(i,j1)
               ii = i
               jj2 = mod(j1,3) + 1
               icyc(ip,1) = icyc(ip,1) + 1
               icyc(ip,icyc(ip,1) + 1) = k1
c     repetition
 45            icyc(ip,1) = icyc(ip,1) + 1
               icyc(ip,icyc(ip,1) + 1) = lnd(ii,jj2)
               ii = iae(ii,jj2)
               jj = 0
               do jjj=1,3
                  if(lnd(ii,jjj) .eq. ip ) jj = jjj
               enddo
               if(jj .eq. 0) then
                  print *,'Triangle for node',ip,'doesn''t found'
                  print *,'@@',ip, ii,lnd(ii,1),lnd(ii,2),lnd(ii,3)
                  print *,'!!',icyc(ip,1),icyc(ip,2),icyc(ip,3),
     *                 icyc(ip,4),icyc(ip,5),icyc(ip,6)
                  print *,x(ip),y(ip)
                  print *,x(icyc(ip,2)),y(icyc(ip,2))
                  print *,x(icyc(ip,3)),y(icyc(ip,3))
                  stop
               endif
               jj1 = mod(jj,3) + 1
               jj2 = mod(jj1,3) + 1
               if( lnd(ii,jj2) .ne. k1) goto 45
            endif
 40      continue
 30   continue

c      print *,'The seeking of cykles done'

      if(xper .gt. 0. .or. yper .gt. 0.) then
         ibeg1 = 0
         ibeg2 = 0
         num1 = 0
         num2 = 0
         do i=1,nbelm
            if(ibeg1 .eq. 0 .and. ibc(i) .eq. iper1) ibeg1 = i
            if(ibeg2 .eq. 0 .and. ibc(i) .eq. iper2) ibeg2 = i
            if(ibc(i) .eq. iper1) num1 = num1 + 1
            if(ibc(i) .eq. iper2) num2 = num2 + 1
            if(ibc(i) .eq. iper1 .or. ibc(i) .eq. iper2) then
               iel = itc(i)
               do j=1,3
                  j1 = mod(j,3) +1
                  if(lnd(iel,j) .eq. lbn(i,1) .and. 
     *                 lnd(iel,j1) .eq. lbn(i,2) ) then
                     iae(iel,j) = -1
                     goto 2005
                  endif
               enddo
 2005          continue
            endif
         enddo
         if(num1 .ne. num2) then
            print *,'On the periodic boundary is not the same number ',
     *           'of points'
            stop
         endif
         if(num1 .eq. 0) then
            print *,'On the periodic boundary is zero points'
            stop
         endif
         do i=1,num1
            k1 = lbn(ibeg1 -1 + i,1)
            k2 = lbn(ibeg2 + num1 - i,2)
            ibp(k1,1) = k2
            ibp(k2,1) = k1
            ibp(k1,2) = ibp(k1,2) + 1
            ibp(k2,2) = ibp(k2,2) + 1
            if( i .eq. num1) then
               k1 = lbn(ibeg1 -1 + i,2)
               k2 = lbn(ibeg2 + num1 - i,1)
               ibp(k1,1) = k2
               ibp(k2,1) = k1
               ibp(k1,2) = ibp(k1,2) + 1
               ibp(k2,2) = ibp(k2,2) + 1
            endif
         enddo

c         print *,'The periodic boundary done'
      endif

c     the second pair of periodic boundaty component
      if(xper2 .gt. 0. .or. yper2 .gt. 0.) then
         ibeg1 = 0
         ibeg2 = 0
         num1 = 0
         num2 = 0
         do i=1,nbelm
            if(ibeg1 .eq. 0 .and. ibc(i) .eq. iper3) ibeg1 = i
            if(ibeg2 .eq. 0 .and. ibc(i) .eq. iper4) ibeg2 = i
            if(ibc(i) .eq. iper3) num1 = num1 + 1
            if(ibc(i) .eq. iper4) num2 = num2 + 1
            if(ibc(i) .eq. iper3 .or. ibc(i) .eq. iper4) then
               iel = itc(i)
               do j=1,3
                  j1 = mod(j,3) +1
                  if(lnd(iel,j) .eq. lbn(i,1) .and. 
     *                 lnd(iel,j1) .eq. lbn(i,2) ) then
                     iae(iel,j) = -1
                     goto 2006
                  endif
               enddo
 2006          continue
            endif
         enddo
         if(num1 .ne. num2) then
            print *,'On the periodic boundary is not the same number ',
     *           'of points'
            stop
         endif
         if(num1 .eq. 0) then
            print *,'On the periodic boundary is zero points'
            stop
         endif
c     ...ibp(k,2) = 3   ==> point is a periodic for both part of boundary
         do i=1,num1
            k1 = lbn(ibeg1 -1 + i,1)
            k2 = lbn(ibeg2 + num1 - i,2)
            ibp(k1,1) = k2
            ibp(k2,1) = k1
            ibp(k1,2) = ibp(k1,2) + 2
            ibp(k2,2) = ibp(k2,2) + 2
c            print *,' .',k1,ibp(k1,1),k2,ibp(k2,1)
            if( i .eq. num1) then
               k1 = lbn(ibeg1 -1 + i,2)
               k2 = lbn(ibeg2 + num1 - i,1)
               ibp(k1,1) = k2
               ibp(k2,1) = k1
               ibp(k1,2) = ibp(k1,2) + 2
               ibp(k2,2) = ibp(k2,2) + 2
            endif
         enddo

c         print *,'The periodic boundary done'
      endif

      return
      end

      subroutine TEST(melem,nelem,mpoin,npoin,maxdeg,x,y,
     *     lnd,iae,icyc,lbn,nbelm,mbelm,ibp,itc)
      dimension x(mpoin),y(mpoin),lnd(melem,3),lbn(mbelm,2),
     *     icyc(mpoin,maxdeg),itc(mbelm),
     *     iae(melem,3),ibp(mpoin,2)

      common /period/ xper,yper,iper1,iper2
      common /period2/ xper2,yper2,iper3,iper4

      print *,'Control of input/output files'

c                 do i=1,nelem
c                     write(*,'(7i5)') i,lnd(I,1),lnd(I,2),lnd(I,3),
c     *                    iae(i,1),iae(i,2),iae(i,3)
c                  enddo
c                  print*,'********************'
 
c     ... test of input datas
      do 600 i=1,nelem
         x1 = x(lnd(i,1))
         y1 = y(lnd(i,1))
         x2 = x(lnd(i,2))
         y2 = y(lnd(i,2))
         x3 = x(lnd(i,3))
         y3 = y(lnd(i,3))
         det = x1*(y2-y3) + x2*(y3-y1) + x3*(y1-y2)
         if(det .le. 0. ) then
            print *,'Bad triangle in GT'
            print *,x1,y1,lnd(i,1),det
            print *,x2,y2,lnd(i,2)
            print *,x3,y3,lnd(i,3)
            stop
         endif
         do 610 j=1,3

            j1 = mod(j,3) + 1
            if(lnd(i,j) .eq. lnd(i,j1) ) then
               print *,'ERROR in GT:'
               print *,i,'-th triangle contains the same nodes'
               write(*,'(3i5)') lnd(i,1),lnd(i,2),lnd(i,3)
               stop
            endif
            if(iae(i,j) .eq. iae(i,j1) ) then
               print *,'ERROR in GT:'
               print *,'code found bad neighbours for', i,'-th triangle'
               write(*,'(3i5)') iae(i,1),iae(i,2),iae(i,3)
               stop
            endif
            if(iae(i,j) .gt. 0) then
               ii = iae(i,j)
               jj = 0
               do 620 jjj=1,3
                  if(iae(ii,jjj) .eq. i) jj = jjj
 620           continue
               if( jj .eq. 0) then
                  print *, 'ERROR in GT:'
                  print *, 'the neighbourhouds are bad'
                  write(*,'(7i5)') i,lnd(i,1),lnd(i,2),lnd(i,3),
     *                 iae(i,1),iae(i,2),iae(i,3)
                  write(*,'(7i5)') ii,lnd(ii,1),lnd(ii,2),lnd(ii,3),
     *                 iae(ii,1),iae(ii,2),iae(ii,3)
                  stop
               endif
               jj1 = mod(jj,3) + 1
               if(lnd(i,j) .ne. lnd(ii,jj1) .or.
     *              lnd(i,j1) .ne. lnd(ii,jj) ) then
                  print *,'ERROR in GT: '
                  print *, 'the neighbourhouds points are bad'
                  write(*,'(7i5)') i,lnd(i,1),lnd(i,2),lnd(i,3),
     *                 iae(i,1),iae(i,2),iae(i,3)
                  write(*,'(7i5)') ii,lnd(ii,1),lnd(ii,2),lnd(ii,3),
     *                 iae(ii,1),iae(ii,2),iae(ii,3)
                  stop
               endif
            endif
 610     continue
 600  continue
      
c     checking of boundary
      do k=1,nbelm
         it = itc(k)
         k1 = lbn(k,1)
         k2 = lbn(k,2)

         if(it .gt. nelem) then
            print *,'ERROR in GT:'
            print *,'too high number itc'
            print *,k,it,k1,k2,nelem
            stop
         endif

         if((lnd(it,1) .eq. k1 .and. lnd(it,2) .eq. k2 .and. 
     *        iae(it,1) .lt. 0) .or.
     *        (lnd(it,2) .eq. k1 .and. lnd(it,3) .eq. k2 .and. 
     *        iae(it,2) .lt. 0) .or.
     *        (lnd(it,3) .eq. k1 .and. lnd(it,1) .eq. k2 .and. 
     *        iae(it,3) .lt. 0))  then
c     OK
         else
            print *,'ERROR in GT:'
            print *,k,'-th boundary segment is bad'
            print *,'lbn(k,1) and lbn(k,2) don''t coresponds with',
     *           'the field lnd(i,j)'
            print *,k,k1,k2
            stop
         endif
      enddo


c     checking of the  cykles
      do 900 ipp =1,npoin-1
         if( icyc(ipp,1) .gt. 0 ) then
            len = icyc(ipp,1)
         else
            len = abs( icyc(ipp,1)) - 1
         endif
         do 910 ic = 1,len
            ic1 = mod(ic,abs(icyc(ipp,1)) ) + 1
            ip1 = icyc(ipp,ic+1)
            ip2 = icyc(ipp,ic1+1)
            itest = 0
            do 920 jpp=1,nelem
               if(( lnd(jpp,1) .eq. ipp .and.
     *              lnd(jpp,2) .eq. ip1 .and.
     *              lnd(jpp,3) .eq. ip2 ) .or.
     *              ( lnd(jpp,2) .eq. ipp .and.
     *              lnd(jpp,3) .eq. ip1 .and.
     *              lnd(jpp,1) .eq. ip2 ) .or.
     *              ( lnd(jpp,3) .eq. ipp .and.
     *              lnd(jpp,1) .eq. ip1 .and.
     *              lnd(jpp,2) .eq. ip2 ) ) then
                  itest = 1
                  goto 922
               endif
 920        continue
 922        continue
            if(itest .eq. 0)then
               print *,'ERROR in CHECk in GT'
               print *,ipp,ip1,ip2,ic,ic1
               it = ipp
               print *,x(it),y(it)
               write(*,'(10i5)') it,icyc(it,1),
     *              icyc(it,2),
     *              icyc(it,3),icyc(it,4),icyc(it,5),
     *              icyc(it,6),icyc(it,7),
     *              icyc(it,8),icyc(it,9)
               do 912 itt=1,abs(icyc(it,1))
                  print *,x(icyc(it,itt+1)),
     *                 y(icyc(it,itt+1)),icyc(it,itt+1)
 912           continue
               do iu=1,nelem
                  if(lnd(iu,1) .eq. it .or. lnd(iu,2) .eq. it
     *                 .or. lnd(iu,3) .eq. it) then
                     write(*,'(4i5)') iu,lnd(iu,1),lnd(iu,2),
     *                    lnd(iu,3)
                  endif
               enddo
               stop
            endif
 910     continue
 900  continue

      if(xper .gt. 0 .or. yper .gt. 0) then
         ipoc = 0
         do i=1,npoin
            if(ibp(i,1) .gt. 0 .and. ibp(i,2) .eq. 1) then
               ipoc = ipoc + 1
               if(i .ne. ibp(ibp(i,1),1) ) then
                  print *,'ERROR in GT:'
                  print *,'The periodic nodes in triang are ',
     *                 'not periodical-1:'
                  print *,i,ibp(i,1)
                  print *,ibp(i,1),ibp(ibp(i,1),1)
                  print *,x(i),y(i)
                  print *,x(ibp(i,1)),y(ibp(i,1))
                  print *,x(ibp(ibp(i,1),1)),y(ibp(ibp(i,1),1))
                  stop
               endif

               xl = ( abs(x(i) - x(ibp(i,1))) ) - xper
               yl = ( abs(y(i) - y(ibp(i,1))) ) - yper
               if( xl .gt. 1E-05 .or. yl .gt. 1E-05) then
                  print *,'ERROR in GT, bad periodical boundary-1'
                  print *,i,ibp(i,1),ibp(ibp(i,1),1)
                  print *,x(i),y(i)
                  print *,x(ibp(i,1)),y(ibp(i,1))
                  print *,xper,yper,xl,yl
                  stop
               endif
            endif
         enddo
         if(ipoc .eq. 0) then
            print *,'ERROR in GT:'
            print *,'non periodic point!!!-1'
            stop
         endif
      endif

      if(xper2 .gt. 0 .or. yper2 .gt. 0) then
         ipoc = 0
         do i=1,npoin
            if(ibp(i,1) .gt. 0 .and. ibp(i,2) .eq. 2) then
               ipoc = ipoc + 1
               if(i .ne. ibp(ibp(i,1),1) ) then
                  print *,'ERROR in GT:'
                  print *,'The periodic nodes in triang are ',
     *                 'not periodical-2:'
                  print *,i,ibp(i,1)
                  print *,ibp(i,1),ibp(ibp(i,1),1)
                  print *,x(i),y(i)
                  print *,x(ibp(i,1)),y(ibp(i,1))
                  print *,x(ibp(ibp(i,1),1)),y(ibp(ibp(i,1),1))
                  stop
               endif

               xl = ( abs(x(i) - x(ibp(i,1))) ) - xper2
               yl = ( abs(y(i) - y(ibp(i,1))) ) - yper2
               if( xl .gt. 1E-05 .or. yl .gt. 1E-05) then
                  print *,'ERROR in GT, bad periodical boundary-2'
                  print *,i,ibp(i,1),ibp(ibp(i,1),1)
                  print *,x(i),y(i)
                  print *,x(ibp(i,1)),y(ibp(i,1))
                  print *,xper2,yper2,xl,yl
                  stop
               endif
            endif
         enddo
         if(ipoc .eq. 0) then
            print *,'ERROR in GT:'
            print *,'non periodic point!!!-2'
            stop
         endif
      endif
      print *,'Input/output file is OK'
      return
      end


      subroutine CYKLE_REP(melem,nelem,mpoin,npoin,maxdeg,x,y,
     *     lnd,iae,icyc,lbn,nbelm,mbelm,ibp)
      dimension x(mpoin),y(mpoin),lnd(melem,3),lbn(mbelm,2),
     *     icyc(mpoin,maxdeg),iae(melem,3),ibp(mpoin,2)

      do 5 i=1,npoin
         icyc(i,1) = 0
 5    continue

      do 10 k=1,nbelm
         icyc(lbn(k,1),1) = -1
         icyc(lbn(k,2),1) = -1
 10   continue

c  ... seeking the  cyclus around each point exept boundaries

      do 30 i=1,nelem
         do 40 j=1,3
            ip = lnd(i,j)
            if(icyc(ip,1) .eq. 0) then
c     initialisation
               j1 = mod(j,3) + 1
               k1 = lnd(i,j1)
               ii = i
               jj2 = mod(j1,3) + 1
               icyc(ip,1) = icyc(ip,1) + 1
               icyc(ip,icyc(ip,1) + 1) = k1
c     repetition
 45            icyc(ip,1) = icyc(ip,1) + 1
               if(icyc(ip,1) +1 .gt. maxdeg) then
                  print *,'The lenght of cykles > maxdeg = ', maxdeg
                  stop
               endif
               icyc(ip,icyc(ip,1) + 1) = lnd(ii,jj2)
               ii = iae(ii,jj2)
               jj = 0
               do jjj=1,3
                  if(lnd(ii,jjj) .eq. ip ) jj = jjj
               enddo
               if(jj .eq. 0) then
                  print *,'Triangle for node',ip,'doesn''t found'
                  stop
               endif
               jj1 = mod(jj,3) + 1
               jj2 = mod(jj1,3) + 1
               if( lnd(ii,jj2) .ne. k1) goto 45
            endif
 40      continue
 30   continue
      return
      end

      subroutine QUA2(x1,y1,w1,ra1,rb1,rc1,x2,y2,w2,ra2,rb2,rc2,
     *        x3,y3,w3,ra3,rb3,rc3,err1,err2,ice,ibo )
      dimension rra(3),rrb(3),rrc(3)
      common /const/ p, epsilon1, pos, pos1, numel,ityp
      common /period/ xper,yper,iper1,iper2
      common /period2/ xper2,yper2,iper3,iper4
      common /sides/ glmin,glmax

      err1 = 1.
      sqrt3 = 1.7320508075

      rl1 = (((ra1+ra2)*(x1-x2)*(x1-x2) + 2*(rb1+rb2)*(x1-x2)*(y1-y2) +
     *     (rc1+rc2)*(y1-y2)*(y1-y2) )/2 )**0.5
      rl2 = (((ra2+ra3)*(x2-x3)*(x2-x3) + 2*(rb2+rb3)*(x2-x3)*(y2-y3) +
     *     (rc2+rc3)*(y2-y3)*(y2-y3) )/2 )**0.5
      rl3 = (((ra1+ra3)*(x1-x3)*(x1-x3) + 2*(rb1+rb3)*(x1-x3)*(y1-y3) +
     *     (rc1+rc3)*(y1-y3)*(y1-y3) )/2 )**0.5

      err2 = (sqrt3-rl1)**2 + (sqrt3-rl2)**2 + (sqrt3-rl3)**2

      if(ibo .eq. 1) then
         err2 = err2 + (sqrt3-rl1)**2
      elseif(ibo .eq. 2) then
         err2 = err2 + (sqrt3-rl2)**2 
      elseif(ibo .eq. 3) then
         err2 = err2 + (sqrt3-rl3)**2 
      endif

      glmax = max(glmax, rl1**2,rl2**2,rl3**2)
      glmin = min(glmin, rl1**2,rl2**2,rl3**2)

      if(ice .eq. 13) then
         write(*,'(4e14.6)') rl1,rl2,rl3,err2
         write(*,'(5e14.6)') x1,y1,ra1,rb1,rc1
         write(*,'(5e14.6)') x2,y2,ra2,rb2,rc2
         write(*,'(5e14.6)') x3,y3,ra3,rb3,rc3
      endif
      return
      end

      subroutine QUALITY(ndim,melem,nelem,mpoin,npoin,x,y,lnd,iae,iter,
     *     err,rminerr,imin, errrez,rmaxrez,ra,wp,rga,rgb,rgc)
      dimension x(mpoin),y(mpoin),lnd(melem,3),iae(nelem,3),
     *     ra(melem*3),wp(mpoin,ndim+1),
     *     rga(mpoin),rgb(mpoin),rgc(mpoin)
      common /const/ p, epsilon1, pos, pos1, numel,ityp
      common /period/ xper,yper,iper1,iper2
      common /period2/ xper2,yper2,iper3,iper4
      common /sides/ glmin,glmax

      ice = 0
      err = 0.
      rminerr = 1.
      errrez = 0.
      rmaxrez = 0.
      glmax = 0.
      glmin = 1000.
      ipobound = 0
      ibo = 0
      do 10 i=1,nelem
         i1 = lnd(i,1)
         i2 = lnd(i,2)
         i3 = lnd(i,3)
         x1 = x(i1)
         y1 = y(i1)
         x2 = x(i2)
         y2 = y(i2)
         x3 = x(i3)
         y3 = y(i3)
         w1 = wp(i1,1)
         w2 = wp(i2,1)
         w3 = wp(i3,1)
         ra1 = rga(i1)
         rb1 = rgb(i1)
         rc1 = rgc(i1)
         ra2 = rga(i2)
         rb2 = rgb(i2)
         rc2 = rgc(i2)
         ra3 = rga(i3)
         rb3 = rgb(i3)
         rc3 = rgc(i3)
         

         do j=1,3
            if( iae(i,j) .lt. -1) then
               ibo = j
               ipobound = ipobound + 1 
            endif
         enddo

         call QUA2(x1,y1,w1,ra1,rb1,rc1,x2,y2,w2,ra2,rb2,rc2,
     *        x3,y3,w3,ra3,rb3,rc3,err1,err2,ice,ibo)

         ice = 0
         err = err + err1
         errrez = errrez + err2
         if(rminerr .gt. err1 ) then
            rminerr = err1
            imin = i
         endif
         rmaxrez = max(rmaxrez,err2)

         if( i .eq. -1 ) print *,i,errrez,err2,rmaxrez

 10   continue
      err = err/nelem
      errrez = errrez/(nelem*3 + ipobound)
      return
      end

      subroutine PLOT(melem,nelem,mpoin,npoin,x,y,lnd)
      dimension x(mpoin),y(mpoin),lnd(melem,3)

      common /period/ xper,yper,iper1,iper2
      common /period2/ xper2,yper2,iper3,iper4

c      ... plot of a new mesh

      igra = 53
      open(igra, file='mesh',status='UNKNOWN')
      
      do i=1,nelem
         write(igra,'(2e14.6)') x(lnd(i,1)),y(lnd(i,1))
         write(igra,'(2e14.6)') x(lnd(i,2)),y(lnd(i,2))
         write(igra,'(2e14.6)') x(lnd(i,3)),y(lnd(i,3))
         write(igra,'(2e14.6)') x(lnd(i,1)),y(lnd(i,1))
         write(igra,'(20x)')
      enddo
      if(xper .gt. 0 .or. yper .gt. 0) then
         do  i=1,nelem
            write(igra,'(2e14.6)') x(lnd(i,1))+xper,y(lnd(i,1))+yper
            write(igra,'(2e14.6)') x(lnd(i,2))+xper,y(lnd(i,2))+yper
            write(igra,'(2e14.6)') x(lnd(i,3))+xper,y(lnd(i,3))+yper
            write(igra,'(2e14.6)') x(lnd(i,1))+xper,y(lnd(i,1))+yper
            write(igra,'(20x)')
         enddo
      endif
      if(xper2 .gt. 0 .or. yper2 .gt. 0) then
         do  i=1,nelem
            write(igra,'(2e14.6)') x(lnd(i,1))+xper2,y(lnd(i,1))+yper2
            write(igra,'(2e14.6)') x(lnd(i,2))+xper2,y(lnd(i,2))+yper2
            write(igra,'(2e14.6)') x(lnd(i,3))+xper2,y(lnd(i,3))+yper2
            write(igra,'(2e14.6)') x(lnd(i,1))+xper2,y(lnd(i,1))+yper2
            write(igra,'(20x)')
         enddo
      endif
      return
      end

      function MEMO (typ, items)                                        
        character typ*(*)                                               
        integer   items                                                 
      include 'work.inc'
                                                                        
c     ... MEMO returns the index corresponding to the first item of     
c                    a new array of items items of the type typ         
c     ... typ is one of the following strings                           
c                       i,  i2, i4,                                     
c                       r,  r4, r8,  d,                                 
c                       c,  c8, c16, cd,                                
c                       l1, l,  l4                                      
c         work (1..mwork) is whole workarrea                            
c         work (1..lwork) is the occupied part of it                    
c     ... MEMO changes the value lwork                                  
c     ... initialize your common this way: mwork=75000,  lwork=0        
                                                                        
c     ... local                                                         
      integer length, ndem                                              
      character t*3                                                     
      if     ( typ.eq.'l1') then                                        
        length = 1                                                      
      elseif ( typ.eq.'i2') then                                        
        length = 2                                                      
      elseif ( typ.eq.'i'  .or. typ.eq.'l' .or. typ.eq.'r'                    
     *    .or. typ.eq.'i4' .or. typ.eq.'r4' .or. typ.eq.'l4') then      
        length = 4                                                      
      elseif ( typ.eq.'d'  .or. typ.eq.'c' 
     *    .or. typ.eq.'r8' .or. typ.eq.'c8' ) then                      
        length = 8                                                      
      elseif ( typ.eq.'cd' .or. typ.eq.'c16') then                      
        length = 16                                                     
      else                                                              
       print *, ' erreur dans MEMO: la valeur inconnue de type = ', typ 
        stop 4                                                          
      endif                                                             
      if (items .lt. 0) then                                            
        print *, ' erreur dans MEMO: items = ', items                   
        stop 4                                                          
      endif                                                             
c     ... correct the value lwork (for double and quatro variables)     
      if     (length .eq. 8 ) then                                      
        lwork = ((lwork+1) / 2 ) * 2                                    
      elseif (length .eq. 16) then                                      
        lwork = ((lwork+3) / 4 ) * 4                                    
      endif                                                             
c     ... the exact demand (numerical storage units)                    
      ndem = (items*length+3) / 4                                       
      t = typ                                                           
                                                                        
      if (ndem .gt. mwork-lwork) then                                   
        print *, ' Error in function MEMO: ', ndem-(mwork-lwork),
     *    ' values miss in blank common'                      
        stop 4                                                          
      endif                                                             
                                                                        
      MEMO = (lwork*4/length)+1                                         
      lwork = lwork + ndem                                              

      return                                                            
      end                                                               
